	SUBROUTINE INIT
*************************************************************
*    Control module <INIT> for reading all the input data   *
*  Written by S.Yu.Savrasov (P.N.Lebedev Physical Institute)*
*************************************************************
	CHARACTER*60 INIFILE,SCFFILE,STRFILE
	PRINT1000
	READ(5,1030)INIFILE
	PRINT1020
	READ(5,1030)STRFILE
	CALL READINI(INIFILE)  !!! read INIFILE
	CALL READSTR(STRFILE)  !!! read STRFILE
	CALL TEST              !!! test PARAM.DAT
	CALL PRINTI            !!! print INIFILE
	CALL PRINTS            !!! print STRFILE
	CALL RADMSH            !!! set radial mesh
	CALL FFTMSH            !!! set FFT-mesh
	CALL PLWMSH            !!! select plane waves for FFT
	CALL SETPAR            !!! select plane waves for basis
	CALL TEIPAR
	CALL PLWSTR            !!! distort plane waves after strain
1000    FORMAT(1X,'INIFILE? ',$)
1020    FORMAT(1X,'STRFILE? ',$)
1030    FORMAT(A)
	END

	SUBROUTINE READINI(INIFILE)
************************************************************
*  <READINI> reads control parameters,atomic stucture data *
*  iterative procedures limits and accuracy parameters     *
************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER IS(NPAT),ILST(NSORTMAX),ILSB(NSORTMAX),NHSORT(NSORTMAX)
     &   ,NODES(0:LMAXT,NSORTMAX,NKAPMAX,NPANMAX),ILSV(NSORTMAX)
     &   ,ICOR(NSORTMAX),IATS(NPAT,NPANMAX),ISTS(NSORTMAX,NPANMAX)
     &   ,NKAP(NPANMAX),NBNDF(NPANMAX),NBNDE(NPANMAX),NFFTG(3)
     &   ,NSEM(NSORTMAX),LBS(36,NSORTMAX),NDS(36,NSORTMAX)
     &   ,MNY(0:LMAXT,NSORTMAX,NKAPMAX,NPANMAX),LR(NSORTMAX)
     &   ,ITS(0:LMAXT,NSORTMAX,NKAPMAX,NPANMAX),NDIV(3),NDIC(3)
     &   ,NBNDT(NPANMAX),ISPL(NSORTMAX)
	DIMENSION ENY(0:LMAXT,NSORTMAX,NKAPMAX,NPANMAX,NSPINMAX)
     &   ,SPLIT(NSORTMAX),ORTH(2:3),SASA(NSORTMAX),SH(3,NPANMAX)
     &   ,Z(NSORTMAX),ZCORE(NSORTMAX),SMT(NSORTMAX)
     &   ,DNY(0:LMAXT,NSORTMAX,NKAPMAX,NPANMAX,NSPINMAX)
     &   ,TNY(0:LMAXT,NSORTMAX,NKAPMAX,NPANMAX,NSPINMAX)
	COMPLEX*16 EK(NKAPMAX,NPANMAX),EKAP(NKAPMAX,NPANMAX)
     &   ,ESEM(36,NSORTMAX)
	CHARACTER*60 INIFILE,CONFILE,FTRFILE,KOVFILE,PTNFILE,WFFILE
     &   ,TMPFILE,POTFILE,SCFFILE,OUTFILE,BNDFILE,DOSFILE
	LOGICAL LTPAN(0:LMAXT+1,NPAT,NKAPMAX,NPANMAX)
     &   ,LSPAN(0:LMAXT+1,NSORTMAX,NKAPMAX,NPANMAX),EXIST
	CHARACTER TEXT*64,TXT*72,TXTEL(NSORTMAX)*10,TXTSP(2)*2
     &   ,SCRFILE(100)*60,UN(100)*2,SCRDIR*60
	COMMON /CONTROL/ LIFT,LMTO,NCOU,NINT,NPF             !!! from init
	COMMON /PARAM/   NSORT,IS,ILST,ILSB,ILSV,NATOM,NHSORT!!! from init
	COMMON /MULTRO/  Z,ZCORE                             !!! from init
	COMMON /POTCOM/  SWZ,SMT                             !!! from init
	COMMON /LATPAR/  PAR                                 !!! from init
	COMMON /INPPAR/  TNY,ENY,DNY,NODES,MNY               !!! from init
	COMMON /KAPPAR/  NPAN,NKAP,EK,EKAP                   !!! from init
	COMMON /PANPAR/  LTPAN,LSPAN,IATS,ISTS               !!! from init
	COMMON /ACCURG/  EPSR,EPSG,ECUTG                     !!! from init
	COMMON /FFTMESH/ NFFTG                               !!! from init
	COMMON /COR1/    ICOR                                !!! from init
	COMMON /OUT0/    SCRFILE                             !!! from init
	COMMON /OUT1/    ICON,IFTR,IKOV,IWF,ITMP,IBND,IPOT   !!! from init
     &                  ,IPTN,IDOS,ISCF,IOUT
	COMMON /OUT2/    CONFILE,FTRFILE,KOVFILE,WFFILE,TMPFILE,BNDFILE
     &                  ,POTFILE,PTNFILE,DOSFILE,SCFFILE,OUTFILE
	COMMON /INTTR/   NDIV,NDIC,SH                        !!! from init
	COMMON /ACCU/    EPSTOT,EPSRHO,EPSMAG                !!! from init
	COMMON /MIXRHO1/ ADMIX1,ADMIN,ADMAX,KEY              !!! from init
	COMMON /MIXMAG1/ ADSPIN,ASMIN,ASMAX,KSP              !!! from init
        COMMON /MIXBROY/ LBROY,IBROY,ADMIXB,ADMIXH           !!! from init
	COMMON /RELATIV/ LR                                  !!! from init
	COMMON /NBANDS/  NBNDF,NBNDE,NBNDT                   !!! from init
	COMMON /ASASPH/  SASA                                !!! from init
	COMMON /SCF1COM/ NITER1                              !!! from init
        COMMON /ORBS/    NORBS                               !!! from init
	COMMON /SPIN/    NSPIN,SPLIT,ISPL                    !!! from init
	COMMON /EXCH/    IEXCH                               !!! from init
	COMMON /TEXT/    TEXT                                !!! from init
	COMMON /TXTEL/   TXTEL,TXTSP                         !!! from init
	COMMON /UNIT/    IUN                                 !!! from init
	DATA PI/3.141592653589793D0/                             
	DATA UN/'01','02','03','04','05','06','07','08','09','10'
     &         ,'11','12','13','14','15','16','17','18','19','20'
     &         ,'21','22','23','24','25','26','27','28','29','30'
     &         ,'31','32','33','34','35','36','37','38','39','40'
     &         ,'41','42','43','44','45','46','47','48','49','50'
     &         ,'51','52','53','54','55','56','57','58','59','60'
     &         ,'61','62','63','64','65','66','67','68','69','70'
     &         ,'71','72','73','74','75','76','77','78','79','80'
     &         ,'81','82','83','84','85','86','87','88','89','90'
     &         ,'91','92','93','94','95','96','97','98','99','00'/
C--------------------------------------------
C***** INPUT FILE 1 FOR NMT-PACK ************
C--------------------------------------------
	IUN=6
	OPEN(1,FILE=INIFILE,STATUS='OLD')
	READ(1,1000) TEXT
C    LIFT=1 - strmsh ; =2 + bands ; =3 + self-consistence
C    LMTO=1 - original (bare) LMTO
C    NCOU=0 - free parameter
C    NINT=1 - overlap matrix via cells, 2 - via S-dot
C    NPF =0 - without, =1/2 with slow/fast atomic force calculations
	READ(1,1001)TXT
	READ(1,*)LIFT
	READ(1,*)LMTO
	READ(1,*)NCOU
	READ(1,*)NINT
	READ(1,*)NPF
C   ****** EXCHANGE-CORRELATION CODE ******
C    IEXCH - 1:Barth-Hedin,2:Gun-Lun,3:Mor-Jan-Will,4:Vosko-Wilk,Nuss.
C            5:Perdew-Wang 1991, 6:Gaspar-Kohn-Sham 
C    for IEXCH < 0 generalized gradient corrections after Perdew 1991
C    are included. The local potential is according to ABS(IEXCH)
	READ(1,1000)TXT
	READ(1,*)IEXCH
	IF(IEXCH.LT.0)PRINT*,'<READINI>:: FOR GGA91 ONLY SPHERICAL
     &  PART OF THE TOTAL DENSITY IS TAKEN INTO ACCOUNT'
C   ****** ITERATIVE PROCEDURES LIMITS : ******
C   NITER1 - Max.number of iterations in <SCF1>
C   ADMIX1 - Charge Density Admixture in <SCF1>
C   ADSPIN - Magnetization  Admixture in <SCF1>
C   EPSTOT - Total energy accuracy (Ry)
C   LBROY  - switch on Broyden mixing for Lbroy=0,1,... components
C   IBROY  - switch on Broyden mixing after N=IBROY iterations
C   ADMIXB - Initial Broyden Jakobian
C   ADMIXH - Mixing for high-l components of the density if
C            low-l components (.le lbroy) are mixed with Broyden
        READ(1,1000)TXT
        READ(1,*) NITER1,ADMIX1,ADSPIN,EPSTOT
     &           ,LBROY,IBROY,ADMIXB,ADMIXH
C   SETTINGS FOR LINEAR MIXING
        ADMIN=MAX(0.D0,ADMIX1/2.D0)
        ADMAX=MIN(1.D0,ADMIX1*2.D0)
        ASMIN=ADSPIN
        ASMAX=ADSPIN
C   KEY=0(1) - Admixture=ADMIX1(Admixture=1.D0) when iter=1
        KEY=0
        KSP=0
C   ********* ATOMIC DATA : *********
C   NATOM - number of atoms in unit-cell
C   NSORT - number of different types of atoms
C   NSPIN - number of spins
C   NORBS - 1/2 which switches off/on spin-orbit coupling
C   PAR   - lattice parameter, equillibrium volume ratio
C   IS(IATOM) - number of sort for each atom
C   NKAP,EKAP  - number of tail for wave functions and their energies
	READ(1,1000) TXT
	READ(1,*)  NATOM,NSORT,NSPIN,NORBS
C   CHECK THEM
	IF(NATOM.GT.NPAT)STOP'<READINI>: # OF ATOMS MISMATCHES,
     &  INCREASE "NPAT" IN PARAM.DAT'
	IF(NSORT.GT.NSORTMAX)STOP'<READINI>: # OF SORTS MISMATCHES,
     &  INCREASE "NSORTMAX" IN PARAM.DAT'
	IF(NSPIN.GT.NSPINMAX)STOP'<READINI>: # OF SPINS MISMATCHES,
     &  SET "NSPINMAX=2" IN PARAM.DAT'
        IF(NORBS.GT.NSPINMAX)STOP'<READINI>: TO SWITCH ON SO-COUPLING,
     &  SET "NSPINMAX=2" IN PARAM.DAT'
        IF(NSPIN.EQ.1.AND.NORBS.EQ.2)STOP'<READINI>: TO SWITCH SO-COUPLING,
     &  NSPIN MUST BE EQUAL 2'
	READ(1,*)  PAR0,VV0
	READ(1,*) (IS(I),I=1,NATOM)
	READ(1,*)  NKAP(1),(EKAP(IKAP,1),IKAP=1,NKAP(1))
	IF(NKAP(1).GT.NKAPMAX)STOP'<READINI>: # OF KAPPAS MISMATCHES'
C   ILST(ISORT) - lmax for trial function expansion
C   ILSB(ISORT) - lmax for basis set
C   ILSV(ISORT) - lmax for the potential and charge density
C   Z(ISORT) - nuclear charge
C   ZCORE(ISORT) - number of core electrons
C   LR(ISORT) =0 - non =1 - semirelativistic version
C   ICOR(ISORT) - core renormalisation key
C   ISPL(ISORT) = 1 - permanent splitting (magnetic field)
C   SPLIT(ISORT) - splitting in case spin-polarisation 
C   SMT(ISORT)   - mt-sphere radius
C   ITS(IKAP,L,ISORT) - basis set description: 1 - present, 0 - absent in basis
C   MNY(IKAP,L,ISORT) - choice of Eny: 0-input Eny, 1-input Dny, 2-semicore,
C   ENY(IKAP,L,ISORT) - initial Eny                 3 - centers of gravity
C   DNY(IKAP,L,ISORT) - initial Dny
C   NODES(IKAP,L,ISORT) - main quantum numbers
	DO 50 ISORT=1,NSORT               !!! over diff.types of atoms
	READ(1,1000)TXTEL(ISORT)
	READ(1,*)Z(ISORT),ZCORE(ISORT),LR(ISORT),ICOR(ISORT),
     &  ISPL(ISORT),SPLIT(ISORT)
	READ(1,*)SMT(ISORT),SROU1,SASA(ISORT)
	READ(1,*)ILST(ISORT),ILSB(ISORT),ILSV(ISORT)
	IF(ILST(ISORT).GT.LMAXT)STOP'<READINI>: LMAXT MISMATCH,
     &  INCREASE "LMAXT" IN PARAM.DAT'
	IF(ILSB(ISORT).GT.LMAXB)STOP'<READINI>: LMAXB MISMATCH,
     &  INCREASE "LMAXB" IN PARAM.DAT'
	IF(ILSV(ISORT).GT.LMAXV)STOP'<READINI>: LMAXV MISMATCH,
     &  INCREASE "LMAXV" IN PARAM.DAT'
	IF(ILST(ISORT).GT.ILSV(ISORT))STOP'<READINI>:ILST.GT.ILSV'
	IF(LMAXT.GT.LMAXV)STOP'<READINI>:LMAXT.GT.LMAXV,
     &  SET "LMAXT.LE.LMAXV" IN PARAM.DAT'
	READ(1,1000)TXT
	DO 30 IKAP=1,NKAP(1)
	READ(1,1000)TXT
	READ(1,*)(NODES(L,ISORT,IKAP,1),L=0,ILSB(ISORT))
	READ(1,*)(ITS  (L,ISORT,IKAP,1),L=0,ILSB(ISORT))
	READ(1,*)(MNY  (L,ISORT,IKAP,1),L=0,ILSB(ISORT))
	READ(1,*)(ENY  (L,ISORT,IKAP,1,1),L=0,ILSB(ISORT)),ENYUP
	READ(1,*)(DNY  (L,ISORT,IKAP,1,1),L=0,ILSB(ISORT))
	DO 15 L=0,ILSB(ISORT)
	NODES(L,ISORT,IKAP,1)=NODES(L,ISORT,IKAP,1)-L-1
	ENY(L,ISORT,IKAP,1,NSPIN)=ENY(L,ISORT,IKAP,1,1)
	DNY(L,ISORT,IKAP,1,NSPIN)=DNY(L,ISORT,IKAP,1,1)
  15    CONTINUE
	DO 20 L=ILSB(ISORT)+1,ILST(ISORT)
	ENY(L,ISORT,IKAP,1,1)=ENYUP
	ENY(L,ISORT,IKAP,1,NSPIN)=ENYUP
  20    CONTINUE
  30    CONTINUE
	READ(1,1000)TXT
	READ(1,*)NSEM(ISORT)
	DO 40 ISEM=1,NSEM(ISORT)
	READ(1,*)NDS(ISEM,ISORT),LBS(ISEM,ISORT),ESEM(ISEM,ISORT)
	NDS(ISEM,ISORT)=NDS(ISEM,ISORT)-LBS(ISEM,ISORT)-1
  40    CONTINUE                          !!! over diff.types of atoms
  50    CONTINUE
C   ****** CONTROL PARAMETERS FOR OUTPUT AND RESTART ******
	READ(1,1000)TXT
	READ(1,*)ICON,CONFILE      !!! structure constants
	READ(1,*)IFTR,FTRFILE      !!! fourier constants file
	READ(1,*)IWF,WFFILE        !!! wave functions
	READ(1,*)ITMP,TMPFILE      !!! temporary storage
	READ(1,*)IBND,BNDFILE      !!! band structure
	READ(1,*)IPOT,POTFILE      !!! full potential
	READ(1,*)IPTN,PTNFILE      !!! potential parameters
	READ(1,*)IDOS,DOSFILE      !!! density of states
	READ(1,*)ISCF,SCFFILE      !!! charge density destribution
	READ(1,*)IOUT,OUTFILE      !!! current output
C   ***** OTHER DATA FOR NMT-PACK *****
C   NTF - number of filled bands
C   NFF - number of fully filled bands
C   NEF - number of bands at EF
C   NDIV(1..3) - divisions along G1,G2,G3 of the BZ
C   NDC - divisions along G1 for semicore panels
C   NFFT(1..3) - fft-grid, must be even numbers
	READ(1,1000) TXT
	READ(1,*)NFF,NEF
	READ(1,*)(NDIV(I),I=1,3),NDC
	READ(1,*)(NFFTG(I),I=1,3),EPSR,EPSG
	IF(NFFTG(1).EQ.0)STOP'SET FFT-GRID IN INIFILE'
	IF(MOD(NFFTG(1),2).NE.0)STOP'FFT-GRID MUST BE EVEN'
	IF(MOD(NFFTG(2),2).NE.0)STOP'FFT-GRID MUST BE EVEN'
	IF(MOD(NFFTG(3),2).NE.0)STOP'FFT-GRID MUST BE EVEN'
	NBNDF(1)=NFF+NEF
	NBNDE(1)=NFF+1
	IF(NDC.EQ.0)STOP'SET DIVISIONS FOR SEMICORE PANELS NC.NE.0'
	CLOSE(1)
C  SET DIVISIONS FOR SEMICORE PANELS
	DN2=DBLE(NDIV(2))/DBLE(NDIV(1))
	DN3=DBLE(NDIV(3))/DBLE(NDIV(1))
	NDIC(1)=NDC
	NDIC(2)=ANINT(DBLE(NDC)*DN2)
	NDIC(3)=ANINT(DBLE(NDC)*DN3)
	IF(NDIC(2).EQ.0)NDIC(2)=1
	IF(NDIC(3).EQ.0)NDIC(3)=1
C  SET LATTICE PARAMETERS ACCORDING TO V/V0
	PAR=PAR0*VV0**0.333333333333333333D0
	DO 60 ISORT=1,NSORT
	SMT(ISORT)=SMT(ISORT)*PAR/PAR0
  60    CONTINUE
C SET # OF ATOMS FOR GIVEN SORT ARRAY
	DO 80 ISORT=1,NSORT
	NHSORT(ISORT)=0
	DO 70 IATOM=1,NATOM
	IF(IS(IATOM).EQ.ISORT)NHSORT(ISORT)=NHSORT(ISORT)+1
  70    CONTINUE
  80    CONTINUE
C  DEFINE MAIN VALENCE PANEL
	NBND=0
	DO 120 IATOM=1,NATOM
	ISORT=IS(IATOM)
	I=0
	DO 110 IKAP=1,NKAP(1)
	DO 90 L=0,ILSB(ISORT)
	LTPAN(L,IATOM,IKAP,1)=.FALSE.
	LSPAN(L,ISORT,IKAP,1)=.FALSE.
	IF(ITS(L,ISORT,IKAP,1).EQ.1)THEN
	LTPAN(L,IATOM,IKAP,1)=.TRUE.
	LSPAN(L,ISORT,IKAP,1)=.TRUE.
	I=I+1
	NBND=NBND+2*L+1
	ENDIF
  90    CONTINUE
	DO 100 L=ILSB(ISORT)+1,LMAXT
	LTPAN(L,IATOM,IKAP,1)=.FALSE.
	LSPAN(L,ISORT,IKAP,1)=.FALSE.
	MNY(L,ISORT,IKAP,1)=0
 100    CONTINUE
	LTPAN(LMAXT+1,IATOM,IKAP,1)=.FALSE.
	LSPAN(LMAXT+1,ISORT,IKAP,1)=.FALSE.
 110    CONTINUE
	IATS(IATOM,1)=0
	ISTS(ISORT,1)=0
	IF(I.NE.0)IATS(IATOM,1)=IATOM
	IF(I.NE.0)ISTS(ISORT,1)=ISORT
 120    CONTINUE
	NBNDT(1)=NBND
C  DEFINE # OF SEMICORE PANELS AND ATOMS PARTICIPATING IN EACH PANEL
	IPAN=1
	DO 150 IATOM=1,NATOM
	ISORT=IS(IATOM)
	DO 140 ISEM=1,NSEM(ISORT)
	ILSB(ISORT)=MAX(ILSB(ISORT),LBS(ISEM,ISORT))
	I=0
	DO 130 JPAN=2,IPAN
	IF(ESEM(ISEM,ISORT).NE.EKAP(1,JPAN))I=I+1
 130    CONTINUE
	IF(I.EQ.IPAN-1)THEN
	IPAN=IPAN+1
	NKAP(IPAN)=1
	EKAP(1,IPAN)=ESEM(ISEM,ISORT)
	ENDIF
 140    CONTINUE
 150    CONTINUE
	NPAN=IPAN
	DO 190 IPAN=2,NPAN
	NBND=0
	DO 180 IATOM=1,NATOM
	ISORT=IS(IATOM)
	IATS(IATOM,IPAN)=0
	ISTS(ISORT,IPAN)=0
	DO 160 L=0,ILST(ISORT)
	LSPAN(L,ISORT,1,IPAN)=.FALSE.
	LTPAN(L,IATOM,1,IPAN)=.FALSE.
	MNY(L,ISORT,1,IPAN)=0
 160    CONTINUE
	LTPAN(ILST(ISORT)+1,IATOM,1,IPAN)=.FALSE.
	LSPAN(ILST(ISORT)+1,ISORT,1,IPAN)=.FALSE.
	DO 170 ISEM=1,NSEM(ISORT)
	IF(ESEM(ISEM,ISORT).EQ.EKAP(1,IPAN))THEN
	L=LBS(ISEM,ISORT)
	IATS(IATOM,IPAN)=IATOM
	ISTS(ISORT,IPAN)=ISORT
	NBND=NBND+2*L+1
	LTPAN(L,IATOM,1,IPAN)=.TRUE.
	LSPAN(L,ISORT,1,IPAN)=.TRUE.
	MNY(L,ISORT,1,IPAN)=2
	NODES(L,ISORT,1,IPAN)=NDS(ISEM,ISORT)
	ENDIF
 170    CONTINUE
 180    CONTINUE
	NBNDF(IPAN)=NBND
	NBNDT(IPAN)=NBND
	NBNDE(IPAN)=NBND+1
 190    CONTINUE
	DO 200 IPAN=1,NPAN
	DO 200 IKAP=1,NKAP(IPAN)
	EKAP(IKAP,IPAN)=EKAP(IKAP,IPAN)*PAR0**2/PAR**2
	EK(IKAP,IPAN)=EKAP(IKAP,IPAN)*PAR*PAR
 200    CONTINUE
C  SET BZ-SHIFT FOR METALLIC CASE
	DO 210 IPAN=1,NPAN
	DO 210 I=1,3
	SH(I,IPAN)=0.D0 
 210    CONTINUE
	IF(NBNDF(1)-NBNDE(1)+1.NE.0.AND.IBND.EQ.0)THEN
	SH(1,1)=1.D-07
	SH(2,1)=2.D-07
	SH(3,1)=3.D-07
	ENDIF
 230    CONTINUE
1000    FORMAT(A)
1001    FORMAT(/A)
	END





	SUBROUTINE READSTR(STRFILE)
************************************************************
*  <READSTR> reads crystalline structure and IBZ data      *
************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	CHARACTER*60 STRFILE,KOVFILE,CONFILE,FTRFILE,SYS*1,TXT*72
	INTEGER IS(NPAT),ILST(NSORTMAX),ILSB(NSORTMAX),ILSV(NSORTMAX)
     &    ,NDIV(3),NDIC(3)
	DIMENSION RBASR(3,3),TAUR(3,NPAT),BASR(3),BBASR(3,3),ORTH(2:3) 
     &    ,GBAS(3,3),RBAS(3,3),BBAS(3,3),TAU(3,NPAT),STRAIN(3,3,2)
     &    ,SH(3,NPANMAX),AK(3,3,2),RK(3,3,2),HSPNT(3,2,KMAX)
     &    ,HSPNTR(3,2,KMAX),RSTN(3,3),TAU0(3,NPAT),TAU0R(3,NPAT)
        CHARACTER PNTNOT(2,KMAX)*1,TEXT*64,TEXTS*64,STRING(80)*1
	COMMON /LATTICE/RBAS,GBAS,AK,RK                 !!! from init
	COMMON /MANSTR/ ISTRAIN,IBAS,IBZ,ICALC          !!! from init
	COMMON /BASIS/  TAU                             !!! from init
	COMMON /BASIS0/ TAU0                            !!! from init
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM   !!! from init
	COMMON /LATPAR/ PAR,ORTH,OMEGAC,STRAIN          !!! from init
	COMMON /OUT1/   ICON,IFTR,IKOV                  !!! from init
	COMMON /OUT2/   CONFILE,FTRFILE,KOVFILE         !!! from init
	COMMON /INTTR/  NDIV,NDIC,SH,NDIR,HSPNT         !!! from init
	COMMON /HSPNTS/ PNTNOT                          !!! from init
	COMMON /STRINP/ NVECMX,ALPHA                    !!! from init
	COMMON /SRFINP/ NDIV1,NDIV2                     !!! from init
	COMMON /TEXT/   TEXT,TEXTS                      !!! from init
	COMMON /UNIT/   IUN                             !!! from init
	DATA PI/3.141592653589793D0/
C--------------------------------------------
C***** INPUT FILE 3 FOR NMT-PACK ************
C--------------------------------------------
	OPEN(UNIT=1,FILE=STRFILE,STATUS='OLD')
	READ(1,1000)TEXTS
C  **** MAIN PARAMETERS *********************
C  NATOM - number of atoms in unit-cell
C  ORTH  - ortorhombicity, i.e. b/a, c/a
C  IBAS  - if 1 then Cartesian, else in RBAS
C  IBZ   - if 1 then from RBAS, else input
C  ICALC - if 1 using the calculator
C  ISTRAIN - if 1 plane waves follow the distortions
C  NDIV1 - generation of polyhedra parameter
C  NDIV2 - polyhedron surface mesh parameter
C  NVECMX - number of structure vectors
C  ALPHA - Evald's splitting parameter
	READ(1,1001)TXT
	READ(1,*) NATOM0,ORTH
	READ(1,*) IBAS,IBZ,ICALC,ISTRAIN
	READ(1,*) NDIV1,NDIV2
	READ(1,*) NVECMX,ALPHA
	IF(NATOM0.NE.NATOM)STOP'<READSTR>: # OF ATOMS MISMATCHES
     &  IN STRFILE, CHECK IT'
C  **** PRIMITIVE TRANSLATIONS **************
C  RBAS(1:3,IVEC) - x,y,z components of translations
	READ(1,1000)TXT
	DO 10 IVEC=1,3
	IF(ICALC.NE.1)THEN
	READ(1,*)(RBASR(I,IVEC),I=1,3)
	ELSEIF(ICALC.EQ.1)THEN
	READ(1,1020)STRING
	CALL COMPVEC(STRING,RBASR(1,IVEC),3)
	ENDIF
  10    CONTINUE
C  **** BASIS ATOMS IN ORIGINAL CELL ****************
C  TAU0  - positions of atoms in original cell
	READ(1,1000)TXT
	DO 15 IATOM=1,NATOM
	IF(IBAS.EQ.1)THEN     !!! basis in Cartesian coordinates
	IF(ICALC.NE.1)THEN
	READ(1,*)(TAU0R(I,IATOM),I=1,3)
	ELSEIF(ICALC.EQ.1)THEN!!! using calculator
	READ(1,1020)STRING
	CALL COMPVEC(STRING,TAU0R(1,IATOM),3)
	ENDIF
	ELSEIF(IBAS.NE.1)THEN !!! basis in units of RBAS
	IF(ICALC.NE.1)THEN
	READ(1,*)(BASR(I),I=1,3)
	ELSEIF(ICALC.EQ.1)THEN!!! using calculator
	READ(1,1020)STRING
	CALL COMPVEC(STRING,BASR(1),3)
	ENDIF
	TAU0R(1,IATOM)=BASR(1)*RBASR(1,1)
     &                +BASR(2)*RBASR(1,2)
     &                +BASR(3)*RBASR(1,3)
	TAU0R(2,IATOM)=BASR(1)*RBASR(2,1)
     &                +BASR(2)*RBASR(2,2)
     &                +BASR(3)*RBASR(2,3)
	TAU0R(3,IATOM)=BASR(1)*RBASR(3,1)
     &                +BASR(2)*RBASR(3,2)
     &                +BASR(3)*RBASR(3,3)
	ENDIF
  15    CONTINUE
C  **** BASIS ATOMS IN DISTORTED CELL ****************
C  TAU  - actual positions of atoms 
	READ(1,1000)TXT
	DO 20 IATOM=1,NATOM
	IF(IBAS.EQ.1)THEN     !!! basis in Cartesian coordinates
	IF(ICALC.NE.1)THEN
	READ(1,*)(TAUR(I,IATOM),I=1,3)
	ELSEIF(ICALC.EQ.1)THEN!!! using calculator
	READ(1,1020)STRING
	CALL COMPVEC(STRING,TAUR(1,IATOM),3)
	ENDIF
	ELSEIF(IBAS.NE.1)THEN !!! basis in units of RBAS
	IF(ICALC.NE.1)THEN
	READ(1,*)(BASR(I),I=1,3)
	ELSEIF(ICALC.EQ.1)THEN!!! using calculator
	READ(1,1020)STRING
	CALL COMPVEC(STRING,BASR(1),3)
	ENDIF
	TAUR(1,IATOM)=BASR(1)*RBASR(1,1)
     &               +BASR(2)*RBASR(1,2)
     &               +BASR(3)*RBASR(1,3)
	TAUR(2,IATOM)=BASR(1)*RBASR(2,1)
     &               +BASR(2)*RBASR(2,2)
     &               +BASR(3)*RBASR(2,3)
	TAUR(3,IATOM)=BASR(1)*RBASR(3,1)
     &               +BASR(2)*RBASR(3,2)
     &               +BASR(3)*RBASR(3,3)
	ENDIF
  20    CONTINUE
C  **** STRAIN MATRIX ***********************                      _
C  STRAIN(1..3,1..3) - matrix applied to translations and basis R'=S*R
C  Its diagonal components in case no strain are just 1,1,1
	READ(1,1000)TXT
	DO 30 I=1,3
	IF(ICALC.NE.1)THEN
	READ(1,*)(STRAIN(I,J,1),J=1,3)
	ELSEIF(ICALC.EQ.1)THEN
	READ(1,1020)STRING
	CALL COMPVEC(STRING,BASR(1),3)
	STRAIN(I,1,1)=BASR(1)
	STRAIN(I,2,1)=BASR(2)
	STRAIN(I,3,1)=BASR(3)
	ENDIF
  30    CONTINUE
C  SET RECIPROCAL STRAIN MATRIX: S*S^(-1)=1
	CALL CROSS(RSTN(1,1),STRAIN(1,2,1),STRAIN(1,3,1))
	CALL CROSS(RSTN(1,2),STRAIN(1,3,1),STRAIN(1,1,1))
	CALL CROSS(RSTN(1,3),STRAIN(1,1,1),STRAIN(1,2,1))
	W=STRAIN(1,1,1)*RSTN(1,1)
     &	 +STRAIN(2,1,1)*RSTN(2,1)
     &   +STRAIN(3,1,1)*RSTN(3,1)
	IF(ABS(W).LE.1.D-10)STOP'<READSTR>:: WRONG STRAIN, DET=0'
	DO 40 I=1,3
	STRAIN(1,I,2)=RSTN(I,1)/W
	STRAIN(2,I,2)=RSTN(I,2)/W
	STRAIN(3,I,2)=RSTN(I,3)/W
  40    CONTINUE
C  **** POINT GROUP DESCRIPTION *************
C  SYS - C(cubic) or H(hexogonal) system of rotations
C      - A(arbitrary) system can be also specified.
C        Group operations must be listed in KOVFILE,
C        see WIGMAT subroutine for more details.
        READ(1,1000)TXT
        READ(1,*)SYS
        IF(SYS.EQ.'C')IKOV=1
        IF(SYS.EQ.'H')IKOV=2
        IF(SYS.EQ.'A')IKOV=3
        IF(IKOV.EQ.3)THEN
        BACKSPACE(1)
        READ(1,*)SYS,KOVFILE
        ENDIF
C  ****  BRILLOUIN ZONE **********
C  BBAS - three primitive translations (possibly reciprocal lattice vectors)
        READ(1,1000)TXT
        DO 50 IVEC=1,3
	IF(ICALC.NE.1)THEN
	READ(1,*)(BBASR(I,IVEC),I=1,3)
	ELSEIF(ICALC.EQ.1)THEN
	READ(1,1020)STRING
	CALL COMPVEC(STRING,BBASR(1,IVEC),3)
	ENDIF
  50    CONTINUE
C  **** HIGH-SYMMETRY DIRECTION SETTINGS ****
C  NDIR - number of directions to be calculated
C  HSPNT(1:3,1:2,IDIR) - starting and end points 
	READ(1,1000)TXT
	READ(1,*)NDIR                             !!! # of h.s. directions
	IF(NDIR.GT.KMAX)STOP'<READSTR>: # OF DIRECTIONS IS TOO LARGE,
     &  ALLOWED # IS EQUAL TO KMAX'
	DO 60 IDIR=1,NDIR
        READ(1,1010)(PNTNOT(IVEC,IDIR),IVEC=1,2)
	IF(ICALC.NE.1)THEN
	READ(1,*)((HSPNTR(I,IVEC,IDIR),I=1,3),IVEC=1,2) ! high-symmetry dirs
	ELSEIF(ICALC.EQ.1)THEN
	READ(1,1020)STRING
	CALL COMPVEC(STRING,HSPNTR(1,1,IDIR),6)
	ENDIF
  60    CONTINUE
	CLOSE(1)
C  ACCOUNT FOR ORTHOROMBICITY PARAMETERS
	DO 90 I=2,3
	DO 70 IVEC=1,3
	RBASR(I,IVEC)=RBASR(I,IVEC)*ORTH(I)
        BBASR(I,IVEC)=BBASR(I,IVEC)/ORTH(I)
  70    CONTINUE
	DO 80 IATOM=1,NATOM
	TAU0R(I,IATOM)=TAU0R(I,IATOM)*ORTH(I)
	TAU R(I,IATOM)=TAU R(I,IATOM)*ORTH(I)
  80    CONTINUE
  90    CONTINUE
	DO 130 I=2,3
	DO 120 IVEC=1,2
	DO 110 IDIR=1,NDIR
	HSPNTR(I,IVEC,IDIR)=HSPNTR(I,IVEC,IDIR)/ORTH(I)
 110    CONTINUE
 120    CONTINUE
 130    CONTINUE
C  APPLY STRAIN MATRIX FOR TRANSLATIONS:  R'=S*R
	DO 150 IVEC=1,3
	DO 150 I=1,3
	RBAS(I,IVEC)=0.D0
	DO 140 J=1,3
	RBAS(I,IVEC)=RBAS(I,IVEC)+STRAIN(I,J,1)*RBASR(J,IVEC) 
 140    CONTINUE
 150    CONTINUE
C  APPLY STRAIN FOR BASIS VECTORS:  T'=S*T
	DO 170 IATOM=1,NATOM
	DO 170 I=1,3
	TAU (I,IATOM)=0.D0
	TAU0(I,IATOM)=0.D0
	DO 160 J=1,3
	TAU (I,IATOM)=TAU (I,IATOM)+STRAIN(I,J,1)*TAU R(J,IATOM)
	TAU0(I,IATOM)=TAU0(I,IATOM)+STRAIN(I,J,1)*TAU0R(J,IATOM)
 160    CONTINUE
 170    CONTINUE
C  APPLY INVERSE STRAIN FOR BRILLOUIN ZONE: BZ'=BZ*S^(-1)
	DO 190 IVEC=1,3
	DO 190 I=1,3
	BBAS(I,IVEC)=0.D0
	DO 180 J=1,3
	BBAS(I,IVEC)=BBAS(I,IVEC)+BBASR(J,IVEC)*STRAIN(J,I,2)
 180    CONTINUE
 190    CONTINUE
C  APPLY INVERSE STRAIN TO HIGH-SYMMETRY DIRECTIONS: K'=K*S^(-1)
	DO 220 IDIR=1,NDIR
	DO 220 IVEC=1,2
	DO 220 I=1,3
	HSPNT(I,IVEC,IDIR)=0.D0
	DO 210 J=1,3
	HSPNT(I,IVEC,IDIR)=HSPNT(I,IVEC,IDIR)+
     &	HSPNTR(J,IVEC,IDIR)*STRAIN(J,I,2)
 210    CONTINUE
 220    CONTINUE
C  SET RECIPROCAL LATTICE VECTORS WITHOUT 2*PI
	CALL CROSS(GBAS(1,1),RBAS(1,2),RBAS(1,3))
	CALL CROSS(GBAS(1,2),RBAS(1,3),RBAS(1,1))
	CALL CROSS(GBAS(1,3),RBAS(1,1),RBAS(1,2))
	W=RBAS(1,1)*GBAS(1,1)
     &	 +RBAS(2,1)*GBAS(2,1)
     &   +RBAS(3,1)*GBAS(3,1)
	DO 230 I=1,3
	GBAS(I,1)=GBAS(I,1)/W
	GBAS(I,2)=GBAS(I,2)/W
	GBAS(I,3)=GBAS(I,3)/W
 230    CONTINUE
	OMEGAC=ABS(W)*PAR**3
C  SET BRILLOUIN ZONE TO GBAS IF REQUIRED
	IF(IBZ.EQ.1)THEN
	DO 240 I=1,3
	BBAS(I,1)=GBAS(I,1)
	BBAS(I,2)=GBAS(I,2)
	BBAS(I,3)=GBAS(I,3)
 240 	CONTINUE
	ENDIF
C  SET PRIMITIVE TRANSLATIONS FOR BZ AND PRIMITIVE CELL
	DO 250 I=1,3
	AK(I,1,1)=BBAS(I,1)/NDIV(1)
	AK(I,2,1)=BBAS(I,2)/NDIV(2)
	AK(I,3,1)=BBAS(I,3)/NDIV(3)
	AK(I,1,2)=BBAS(I,1)/NDIC(1)
	AK(I,2,2)=BBAS(I,2)/NDIC(2)
	AK(I,3,2)=BBAS(I,3)/NDIC(3)
 250    CONTINUE
C  SET TRANSLATIONS WHICH ARE RECIPROCAL TO AK AND AD
	DO 270 IP=1,2
	CALL CROSS(RK(1,1,IP),AK(1,2,IP),AK(1,3,IP))
	CALL CROSS(RK(1,2,IP),AK(1,3,IP),AK(1,1,IP))
	CALL CROSS(RK(1,3,IP),AK(1,1,IP),AK(1,2,IP))
	WK=AK(1,1,IP)*RK(1,1,IP)+AK(2,1,IP)*RK(2,1,IP)+
     &  AK(3,1,IP)*RK(3,1,IP)
	DO 260 I=1,3
	RK(I,1,IP)=RK(I,1,IP)/WK
	RK(I,2,IP)=RK(I,2,IP)/WK
	RK(I,3,IP)=RK(I,3,IP)/WK
 260    CONTINUE
 270    CONTINUE
1000    FORMAT(A)
1001    FORMAT(/A)
1010    FORMAT(2(1X,A1))
1020	FORMAT(80A1)
	END





	SUBROUTINE TEST
****************************************************
*  Test input data for correct limits of arrays    *
****************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER IS(NPAT),ILST(NSORTMAX),ILSB(NSORTMAX),ILSV(NSORTMAX)
     &   ,NHSORT(NSORTMAX),NKAP(NPANMAX),NBNDF(NPANMAX)
     &   ,NBNDT(NPANMAX),NBNDE(NPANMAX),LR(NSORTMAX)
	DIMENSION Z(NSORTMAX),ZCOR(NSORTMAX)
	CHARACTER TXTEL(NSORTMAX)*10
	COMMON /PARAM/   NSORT,IS,ILST,ILSB,ILSV,NATOM,NHSORT
	COMMON /MULTRO/  Z,ZCOR                          !!! from init
	COMMON /SPIN/    NSPIN                           !!! from init
	COMMON /KAPPAR/  NPAN,NKAP                       !!! from init
	COMMON /RELATIV/ LR                              !!! from init
	COMMON /NBANDS/  NBNDF,NBNDE,NBNDT               !!! from init
	COMMON /TXTEL/   TXTEL                           !!! from init
	ZVAL=0.D0
	DO 10 ISORT=1,NSORT
	IF(Z(ISORT).GT.21.AND.LR(ISORT).EQ.0)PRINT*,
     &  'No scalar relativism is switched on ',TXTEL(ISORT),
     &  '; Recommended when Z > 21' 
	IF(Z(ISORT).EQ.0.D0)Z(ISORT)=1.D-12
	IF(ZCOR(ISORT).EQ.0.D0)ZCOR(ISORT)=1.D-12
	ZVAL=ZVAL+(Z(ISORT)-ZCOR(ISORT))*NHSORT(ISORT)
  10    CONTINUE
	DO 20 IPAN=1,NPAN
	IF(NKAP(IPAN).GT.NKAPMAX)STOP'# OF KAPPA MISMATCH IN <TEST>'
	IF(NBNDT(IPAN).GT.NDIMMAX)STOP'NDIMMAX MISMATCH IN <TEST>'
	IF(NBNDF(IPAN).GT.NBNDT(IPAN))
     &  STOP'INPUT # OF FILLED BANDS > # OF TOTAL ONES'
	IF(IPAN.GT.1)ZVAL=ZVAL-2.D0*NBNDT(IPAN)
  20    CONTINUE
	IF(2.D0*NBNDF(1).LT.ZVAL)PRINT*,'# OF FILLED BANDS IS TOO SMALL'
	IF(2.D0*NBNDF(1).LT.ZVAL)NBNDF(1)=ZVAL/2.D0+2
	END



	SUBROUTINE RADMSH
*************************************************************
*   Module prepares radial mesh in each  MT-sphere          *
*************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER   IS(NPAT),ILST(NSORTMAX),ILSB(NSORTMAX),ILSV(NSORTMAX)
     &     ,NRAD(NSORTMAX),LR(NSORTMAX)
	DIMENSION H(NSORTMAX),R(0:NRADMAX,NSORTMAX),SMT(NSORTMAX)
     &     ,GL(3),WEIGHT(0:NRADMAX,NSORTMAX),Z(NSORTMAX),AS(NPAT)
     &     ,RL(0:NRADMAX,0:LMAXV,NSORTMAX),ZCOR(NSORTMAX)
     &     ,DR(0:NRADMAX,NSORTMAX),SASA(NSORTMAX)
	COMMON /PARAM/   NSORT,IS,ILST,ILSB,ILSV,NATOM      !!! from init
	COMMON /LATTICE/ A(3),B(3),C(3)                     !!! from init
	COMMON /RADMESH/ NRAD,H,R,DR,WEIGHT,RL              !!! for all modules
	COMMON /MULTRO/  Z,ZCOR                             !!! from init
	COMMON /POTCOM/  SWZ,SMT                            !!! for all modules
	COMMON /ASASPH/  SASA                               !!! for all modules
	COMMON /RELATIV/ LR                                 !!! from init
	COMMON /LATPAR/  PAR                                !!! from init
	COMMON /UNIT/    IUN                                !!! from init
	DATA PI/3.141592653589793D0/,DELTANR/0.03D0/,DELTAR/0.03D0/
C  DEFINE WIGNER-ZEITS SPHERE
	CALL CROSS(GL,B,C)
	OMEGA=ABS(A(1)*GL(1)+A(2)*GL(2)+A(3)*GL(3))   !!! volume of unit-cell
	DO 1 IATOM=1,NATOM
    1   AS(IATOM)=SASA(IS(IATOM))
	CALL SCASW(NATOM,OMEGA,AS,S0,AS)              !!! ASA sphere radii
	SWZ=PAR*S0                                    !!! WZ sphere radius
	DO 5 IATOM=1,NATOM
    5   SASA(IS(IATOM))=PAR*AS(IATOM)
	DO 30 ISORT=1,NSORT
C  DEFINE STEP
	IF(LR(ISORT).EQ.0)H(ISORT)=DELTANR
	IF(LR(ISORT).EQ.1)H(ISORT)=DELTA R
C  DEFINE MESH PARAMETERS
	BETTA=1.D0/(2.D0*Z(ISORT)+1.D0)
	NRAD(ISORT)=2*LOG(SMT(ISORT)/BETTA+1.D0)/H(ISORT)
	NRAD(ISORT)=MAX(NRAD(ISORT),100)
	NRAD(ISORT)=MIN(NRAD(ISORT),NRADMAX)
	NRAD(ISORT)=((NRAD(ISORT)-1)/2)*2  !!! must be odd number
	BETTA=SMT(ISORT)/(EXP(H(ISORT)*NRAD(ISORT))-1.D0)
C  DEFINE RADIAL MESH ARRAYS
	DO 20 IRAD=0,NRAD(ISORT)
	R(IRAD,ISORT)=BETTA*(EXP(H(ISORT)*IRAD)-1.D0)
	DR(IRAD,ISORT)=BETTA*EXP(H(ISORT)*IRAD)
	WEIGHT(IRAD,ISORT)=4.D0*PI*R(IRAD,ISORT)**2*DR(IRAD,ISORT)
	RL(IRAD,0,ISORT)=1.D0
	DO 10 L=1,LMAXV
	RL(IRAD,L,ISORT)=R(IRAD,ISORT)**L
  10    CONTINUE
  20    CONTINUE
  30    CONTINUE
	END



	SUBROUTINE SCASW(NATOM,OMEGA,R,S0,S)
*********************************************************
*  Scale ASA sphere radii according to the numbers R(I) *
*********************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	DIMENSION R(NATOM),S(NATOM)
	DATA PI/3.141592653589793D0/
	S0=(OMEGA/NATOM/(4.*PI)*3.)**0.33333333333333D0
	OMEGAR=0.0
	DO 10 I=1,NATOM
  10    OMEGAR=OMEGAR+4.D0/3.D0*PI*R(I)**3
	A=(OMEGA/OMEGAR)**0.333333333333333D0
	DO 20 I=1,NATOM
  20    S(I)=A*R(I)
	END
