	   SUBROUTINE STRMSH
**************************************************************
*  The preparation of the structure constants for the        *
*  LMTO method  at different energies and their energy       *
*  derivatives (following from the KKR)                      *
*  The symmetry analysis of the crystalline structure and    *
*  determination of the point group (possibly nonsymmorphic) *
*  Written by S.Yu.Savrasov (P.N.Lebedev PhysicaL Institute) *
**************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	PARAMETER (LPLMAX=(2*LMAXV+3)**2,NDTMAX=NPAT*NPAT
     &    ,LDLMAX=(2*LMAXB+2)**2,LTLMAX=(LMAXT+1+LMAXB+1)**2)
	INTEGER IS(NPAT),ILST(NSORTMAX),ILSB(NSORTMAX)
     &    ,LIMLPL2(NDTMAX),ILS2(NDTMAX),LIMLPL4(NDTMAX)
     &    ,LIMLDL2(NDTMAX),ILD2(NDTMAX),LIMLDL4(NDTMAX)
     &    ,LIM2OLD(NDTMAX),LIM4OLD(NDTMAX),NKAP(NPANMAX)
     &    ,LID2OLD(NDTMAX),NDIV(3),NDIC(3),ILS4(NDTMAX)
     &    ,NKAP0(NPANMAX),IDELP(NPAT,NPAT),NPNT(NPANMAX)
     &    ,ILSV(NSORTMAX),ILD4(NDTMAX)
	COMPLEX*16 EK(NKAPMAX,NPANMAX),EKAP(NKAPMAX,NPANMAX)
     &    ,EKOLD(NKAPMAX,NPANMAX)
	DIMENSION PNT(3,KMAX,NPANMAX),HSPNT(3,2,KMAX),SH(3,NPANMAX)
     &    ,DELTAU(3,NDTMAX)
	CHARACTER*60 KOVFILE,FTRFILE,CONFILE,SCRFILE(100),SYS*1
	LOGICAL FIRST
	COMMON /CONTROL/LIFT,LMTO                           !!! from init
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM       !!! from init
	COMMON /LATTICE/A(3,3)                              !!! from init
	COMMON /BASIS0/ TAU0(3,NPAT)                        !!! from init
	COMMON /BASIS/  TAU(3,NPAT)                         !!! from init
	COMMON /OUT1/   ICON,IFTR,IKOV,IWF,ITMP,IBND        !!! from init
	COMMON /OUT2/   CONFILE,FTRFILE,KOVFILE             !!! from init
	COMMON /VECGEN/ LIMDT,DELTAU                        !!! from vecgen
	COMMON /LM2STR/ IDELP,NR2,ILS2,ILD2,LIMLPL2,LIMLDL2 !!! from vecgen
	COMMON /LM4STR/       NR4,ILS4,ILD4,LIMLPL4,LIMLDL4 !!! from vecgen
	COMMON /INTTR/  NDIV,NDIC,SH,NDIR,HSPNT             !!! from init
	COMMON /KAPPAR/ NPAN,NKAP,EK,EKAP,EDGE              !!! from init
	COMMON /GROUPOUT/NGROUP                             !!! from group
	COMMON /MESH/   NPNT,PNT                            !!! from ttrmsh
        COMMON /ORBS/   NORBS                               !!! from init
        COMMON /SPIN/   NSPIN                               !!! from init
	COMMON /OUT0/   SCRFILE                             !!! from init
	COMMON /UNIT/   IUN                                 !!! from init
	COMMON /WORD/   NVAL                                !!! from nmtdata
C       EQUIVALENCE (SIGMA(1,1,1),SIGMM(1,1))
	DATA PI/3.141592653589793D0/,EPS/1.D-05/
C  INITIATION
	LMMT=0
	LMMB=0
	LMMV=0
	DO 10 IATOM=1,NATOM
	LMMT=MAX(LMMT,ILST(IS(IATOM)))   !!! maximum lmaxt for all atoms
	LMMB=MAX(LMMB,ILSB(IS(IATOM)))   !!! maximum lmaxb for all atoms
	LMMV=MAX(LMMV,ILSV(IS(IATOM)))   !!! maximum lmaxv for all atoms
  10    CONTINUE
	LMMC=MAX(LMMT+1,LMMV+1)
C  CALCULATE TRANSFORMATION MATRICES
        IF(IKOV.EQ.1)SYS='C'
        IF(IKOV.EQ.2)SYS='H'
        IF(IKOV.EQ.3)SYS='A'
        CALL WIGMAT(LMMT,SYS,KOVFILE)
        CALL GROUPS(A,TAU0,IS,LMMT,NATOM,NSPIN,NORBS,EPS,1)
        WRITE(IUN,1010)NGROUP
        CALL WIGMAT(LMMT,SYS,KOVFILE)
        CALL GROUPS(A,TAU, IS,LMMT,NATOM,NSPIN,NORBS,EPS,2)
        WRITE(IUN,1020)NGROUP
        CALL KELITAB              !!! calculate Keli table
C  K-MESH CONSTRUCTION
	IF(IBND.NE.1)CALL SBZMESH(NDIV,NDIC)
	IF(IBND.EQ.1)CALL HSMSH(NDIV,HSPNT,NDIR)
	WRITE(IUN,1030)NPNT(1)
	IF(NPAN.GT.1)WRITE(IUN,1040)NPNT(NPAN)
C  GENERATE STR.VECTORS AND CHECK SINGULARITIES IN STR.CONSTANTS
	CALL GDATA(LMMC)          !!! calculate Gaunt-coefficients
	CALL SYMLMM               !!! calculate some logical arrays
	CALL SYMMOLD
C  STORE CHARGE DENSITY IN ORDER TO USE SOME MEMORY
	CALL SVECGEN              !!! generate structure vectors
	IF(LMTO.EQ.1)CALL CHECKS  !!! check singularities in str.con
1010    FORMAT(1X,I4,' elements discovered for original   lattice')
1020    FORMAT(1X,I4,' elements found      for distorted  lattice')
1030    FORMAT(1X,I4,' k-points generated  for main valence panel')
1040    FORMAT(1X,I4,' k-points generated  for semicore    panels')
	END


	SUBROUTINE HSMSH(NDIV,HSPNT,NDIR)
******************************************************
* Construction of the k-mesh in arbitrary directions *
******************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER NPNT(NPANMAX)
	DIMENSION HSPNT(3,2,KMAX),PNT(3,KMAX,NPANMAX)
	COMMON /KAPPAR/NPAN
	COMMON /MESH/  NPNT,PNT
	NP=0
	DO 30 ND=1,NDIR
	DX=HSPNT(1,2,ND)-HSPNT(1,1,ND)
	DY=HSPNT(2,2,ND)-HSPNT(2,1,ND)
	DZ=HSPNT(3,2,ND)-HSPNT(3,1,ND)
		DO 20 I=1,NDIV+1
		NP=NP+1
		PNT(1,NP,1)=HSPNT(1,1,ND)+DX*(I-1)/NDIV
		PNT(2,NP,1)=HSPNT(2,1,ND)+DY*(I-1)/NDIV
		PNT(3,NP,1)=HSPNT(3,1,ND)+DZ*(I-1)/NDIV
  20            CONTINUE
  30    CONTINUE
	NPNT(1)=NP
	DO 40 IPAN=2,NPAN
	NPNT(IPAN)=0
  40    CONTINUE
	END




	SUBROUTINE CHECKS
****************************************************************
*    Check the singularities in the structure constants        *
*    by calculating the difference between free-electron       *
*    energies and input tail energies.                         *
****************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	PARAMETER (NDTMAX=NPAT*NPAT)
	INTEGER IS(NPAT),ILST(NSORTMAX),ILSB(NSORTMAX),ILSV(NSORTMAX)
     &    ,NKAP(NPANMAX),NPNT(NPANMAX)
	DIMENSION PNT(3,KMAX,NPANMAX),RBAS(3,3),GBAS(3,3)
     &    ,DELTAU(3,NDTMAX),GVEC(3,NVCMAX),RVEC(3,NVCMAX)
	COMPLEX*16 EK(NKAPMAX,NPANMAX),EKAP(NKAPMAX,NPANMAX)
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM       !!! from init
	COMMON /KAPPAR/ NPAN,NKAP,EK,EKAP                   !!! from init
	COMMON /VECGEN/ LIMDT,DELTAU,NRVEC,RVEC,NGVEC,GVEC  !!! from vecgen
	COMMON /MESH/   NPNT,PNT                            !!! from ttrmsh
	COMMON /UNIT/   IUN                                 !!! from init
	DATA PI/3.141592653589793D0/
	DO 50 IPAN=1,1 ! NPAN
	DO 40 IKAP=1,NKAP(IPAN)
	DIFMIN=10.D+10
	DO 30 IPNT=1,NPNT(IPAN)
	DO 20 IGVEC=1,NGVEC
	GKX=GVEC(1,IGVEC)+PNT(1,IPNT,IPAN)
	GKY=GVEC(2,IGVEC)+PNT(2,IPNT,IPAN)
	GKZ=GVEC(3,IGVEC)+PNT(3,IPNT,IPAN)
	GK2=GKX*GKX+GKY*GKY+GKZ*GKZ
	DIF=ABS(GK2-DREAL(EK(IKAP,IPAN))/4.D0/PI/PI)
	DIFMIN=MIN(DIFMIN,DIF)
  20    CONTINUE
  30    CONTINUE
	WRITE(IUN,1010)IKAP,DIFMIN
	IF(DIFMIN+ABS(DIMAG(EK(IKAP,IPAN))).LE.1.D-10)
     &  PRINT*,' <CHECKS> : STR.CONSTANTS WILL BE SINGULAR'
  40    CONTINUE
  50    CONTINUE
1010    FORMAT(1X,'Minimum difference between |k+G|^2 and kappa',
     &  I1,'^2 is ',G14.7)
	END
