	SUBROUTINE SYMMOLD
****************************************************************
*  Define which coefficients in the expansion of the potential *
*  or charge density over spherical harmonics are not equal    *
*  to zero for a given crystalline group.                      *
*  Written by S.Yu.Savrasov (P.N.Lebedev Physical Institute)   *
****************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	DIMENSION IP(NPAT,NOPRMAX),IKOV(NOPRMAX)
     &   ,IS(NPAT),NHSORT(NSORTMAX),IARR(LMMAXV),NRAD(NSORTMAX)
     &   ,TAU(3,NPAT),ILST(NSORTMAX),ILSB(NSORTMAX),ILSV(NSORTMAX)
     &   ,NSYM(NPAT),NNEW(NPAT),LMSYM(LMMAXV,NPAT),LMNEW(LMMAXV,NPAT)
     &   ,C(0:LMAXV+1,LMMAXV1,LMMAXV1)
     &   ,LPR(0:LMAXV),MPR(0:LMAXV,2*LMAXV+1)
	COMPLEX*16 U(NWIGMAX,48),S(-LMAXT:LMAXT,-LMAXT:LMAXT)
     &   ,SR(-LMAXT:LMAXT,-LMAXT:LMAXT,-LMAXT:LMAXT,-LMAXT:LMAXT,NPAT)
     &   ,TMP
	LOGICAL SYM(LMMAXV,NPAT),SYMNEW(LMMAXV,NPAT)
	CHARACTER TXTEL(NSORTMAX)*10,BLANCK*40
	COMMON /CONTROL/ MAN,LMTO,NLR                        !!! from init
	COMMON /PARAM/   NSORT,IS,ILST,ILSB,ILSV,NATOM,NHSORT!!! from init
	COMMON /INVERS/  INV,IKOV                            !!! from group
	COMMON /BASIS/   TAU                                 !!! from init
	COMMON /STORE1/  SR,WORK1,WORK2                      !!! tmp.storage
	COMMON /GAUNT/   C                                   !!! from gdata
	COMMON /GROUPOUT/NGROUP,U,IP,RDC,SHIFT               !!! from group
	COMMON /SYMOLD/  SYM,LMSYM,NSYM                      !!! from sym
	COMMON /SYMMLM/  SYMNEW,LMNEW,NNEW                   !!! from sym
	COMMON /RADMESH/ NRAD                                !!! from radmsh
	COMMON /SPIN/    NSPIN                               !!! from init
	COMMON /TXTEL/   TXTEL                               !!! from init
	COMMON /UNIT/    IUN                                 !!! from init
	DATA PI/3.141592653589793D0/
C   DEFINE WHICH OF THE MATRIX ELEMENTS WILL BE EQUAL TO ZERO
	DO 260 IATOM=1,NATOM                !!! over iatom
	DO 10 L2M2=1,(ILSV(IS(IATOM))+1)**2
	SYM(L2M2,IATOM)=.FALSE.
  10    CONTINUE
	DO 210 L1=0,ILST(IS(IATOM))         !!! over l1
	DO 200 L=0,ILST(IS(IATOM))          !!! over l
	DO 120 M1=-L1,L1                    !!! over m1
	NLS1=L1*(2*L1-1)*(2*L1+1)/3
	L1M1=L1*(L1+1)+M1+1
	MM1=L1+M1+1
	DO 110 M=-L,L                       !!! over m
	NLS=L*(2*L-1)*(2*L+1)/3
	LM=L*(L+1)+M+1
	MM=L+M+1
	DO 40 JATOM=1,NATOM
	DO 30 M2=-L1,L1
	DO 20 M3=-L,L
	SR(M2,M3,M1,M,JATOM)=(0.D0,0.D0)
  20    CONTINUE
  30    CONTINUE
  40    CONTINUE
	ABSS1=0.D0
	ABSS2=0.D0
	DO 100 JATOM=1,NATOM                !!! over jatom
	  DO 60 M2=-L1,L1
	  DO 50 M3=-L,L
	  S(M2,M3)=(0.D0,0.D0)
  50      CONTINUE
  60      CONTINUE
	DO 90 IR=1,NGROUP                   !!! over group
	IG=IKOV(IR)
	  DO 80 M2=-L1,L1
	  MM2=L1+M2+1
	  IWIG12=NLS1+(2*L1+1)*(L1+M2)+MM1
	  IWIG21=NLS1+(2*L1+1)*(L1+M1)+MM2
	  DO 70 M3=-L,L
	  MM3=L+M3+1
	  IWIG03=NLS+(2*L+1)*(L+M3)+MM
	  IWIG30=NLS+(2*L+1)*(L+M)+MM3
	  IF(IP(IATOM,IR).EQ.JATOM)SR(M2,M3,M1,M,JATOM)=
     &    SR(M2,M3,M1,M,JATOM)+
     &    CONJG(U(IWIG12,IG))*U(IWIG03,IG)
	  IF(IP(JATOM,IR).EQ.IATOM)S(M2,M3)=S(M2,M3)+
     &    CONJG(U(IWIG21,IG))*U(IWIG30,IG)
  70      CONTINUE
  80      CONTINUE
  90    CONTINUE                            !!! over group
 100    CONTINUE                            !!! over jatom
 110    CONTINUE                            !!! over m
 120    CONTINUE                            !!! over m1
C   DEFINE WHICH OF THE DENSITY OR POTENTIAL L-COMPONENTS WILL BE ZERO
	DO 190 LR=ABS(L-L1),L+L1,2
	LLR=LR/2
	IF(LR.GT.ILSV(IS(IATOM)))GOTO190
	DO 180 MR=-LR,LR
	LRMR=LR*(LR+1)+MR+1
	ABSSR=0.D0
	DO 170 JATOM=1,NATOM
	IF(IS(JATOM).NE.IS(IATOM))GOTO170
	DO 160 M2=-L1,L1
	DO 150 M3=-L,L
	TMP=(0.D0,0.D0)
	DO 140 M1=-L1,L1
	L1M1=L1*(L1+1)+M1+1
	DO 130 M=-L,L
	LM=L*(L+1)+M+1
	IF(M-M1.EQ.MR)TMP=TMP+C(LLR,LM,L1M1)*SR(M2,M3,M1,M,JATOM)
 130    CONTINUE
 140    CONTINUE
	ABSSR=ABSSR+ABS(TMP)
 150    CONTINUE
 160    CONTINUE
 170    CONTINUE
	IF(ABSSR.GE.1.D-06)SYM(LRMR,IATOM)=.TRUE.
 180    CONTINUE
 190    CONTINUE
 200    CONTINUE                            !!! over l
 210    CONTINUE                            !!! over l1
C  PRINT ALLOWED LM-VALUES
	BLANCK='                                        '
	WRITE(IUN,1010)(TAU(I,IATOM),I=1,3),TXTEL(IS(IATOM))
	WRITE(IUN,1020)ILST(IS(IATOM))
	WRITE(IUN,1030)ILSV(IS(IATOM))
	WRITE(IUN,1040)
	NSYM(IATOM)=0
	NSTOP=0
	LPRMAX=0
	DO 240 L=0,ILSV(IS(IATOM))
	LPR(L)=0
	DO 230 M=-L,L
	LM=L*(L+1)+M+1
	LMSYM(LM,IATOM)=0
	IF(SYM(LM,IATOM))THEN
	NSYM(IATOM)=NSYM(IATOM)+1
	LMSYM(LM,IATOM)=NSYM(IATOM)
	LPR(L)=LPR(L)+1
	MPR(L,LPR(L))=M
	ENDIF
 230    CONTINUE
	IF(L.GT.8)GOTO240
	LPRMAX=MAX(LPRMAX,LPR(L))
 240    CONTINUE
C THE FOLLOWING CYCLE IS JUST FOR PRINTING, REMOVE IT IF DOES NOT WORK
	DO 250 L=0,ILSV(IS(IATOM))
	NSHIFT=2*(LPRMAX-LPR(L))+1
	IF(NSHIFT.LE. 0)NSHIFT=1 
	IF(NSHIFT.GT.40)NSHIFT=40
	IF(LPR(L).NE.0.AND.L.LE.8)WRITE(IUN,1050)L,BLANCK(:NSHIFT),
     &  (MPR(L,I),I=1,LPR(L))
	IF(LPR(L).NE.0.AND.L.GT.8)WRITE(IUN,1060)L,LPR(L)
 250    CONTINUE
	WRITE(IUN,1070)NSYM(IATOM)
	IF(NSYM(IATOM).GT.NSYMMAX)NSTOP=1
	IF(NSTOP.EQ.1)
     &  STOP'<SYMMLM>: SYMMETRY IS TOO LOW,
     &  INCREASE "NSYMMAX" IN PARAM.DAT'
C  CHECK ARRAYS
	IF(NSYM(IATOM).NE.NNEW(IATOM))STOP'<SYMOLD>: NSYM.NE.NNEW'
	DO 255 LM=1,(ILSV(IS(IATOM))+1)**2
	IF(LMSYM(LM,IATOM).NE.LMNEW(LM,IATOM))
     &  STOP'<SYMOLD>:LMSYM.NE.LMNEW'
 255    CONTINUE
 260    CONTINUE
1010    FORMAT(1X,'Position : (',G12.5,',',G12.5,',',G12.5,') ',A10)
1020    FORMAT(1X,'LMTO-basis set is expanded in spherical harminics ',
     &  'up to Lmax=',I2)
1030    FORMAT(1X,'Charge density is expanded in spherical harmonics ',
     &  'up to Lmax=',I2)
1040    FORMAT(1X,'Non-zero elements allowed by symmetry are ',
     &            'the following:')
1050    FORMAT(1X,'l=',I2,' ; m=',A,17(1X,I3))
1060    FORMAT(1X,'l=',I2,' ; m= ',I2,' elements')
1070    FORMAT(1X,'Total # of non-zero components found ',I3)
	END
