	PROGRAM MAKESCFM
****************************************************************
*  The program calculates sum over lattice of the atomic       *
*  densities according to Mattheiss procedure.                 *
****************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
C DECLARE ARRAYS
	CHARACTER*60 CORFILE(NSORTMAX),STRFILE
     &   ,SCFFILE,INIFILE,TXTEL(NSORTMAX)*10
	INTEGER NNIZ(36,NSORTMAX),JCORE(NSORTMAX),JMAX(NSORTMAX)
     &   ,NRAD(NSORTMAX),NSYM(NPAT),LR(NSORTMAX),IS(NPAT)
     &   ,LMSYM(LMMAXV,NPAT)
	INTEGER ILST(NSORTMAX),ILSB(NSORTMAX),ILSV(NSORTMAX)
	DIMENSION SMT(NSORTMAX),Z(NSORTMAX),ROCOR(0:NRADMAX,NSORTMAX)      
     &   ,ROCATOM(0:631,NSORTMAX),ROATOM(0:631,NSORTMAX)
     &   ,XZ(36,NSORTMAX),XE(36,NSORTMAX),HLIB(NSORTMAX)
     &   ,R(0:NRADMAX,NSORTMAX),DR(0:NRADMAX,NSORTMAX)
     &   ,WEIGHT(0:NRADMAX,NSORTMAX),H(NSORTMAX),RBAS(3,3)
     &   ,ZCORE(NSORTMAX),SW(NSORTMAX),RLIB(0:631,NSORTMAX)
     &   ,GPLW(3,0:NPLWMAX),ORTH(2:3),CHR(NSORTMAX),GBAS(3,3)
	COMPLEX*16 RO(0:NRADMAX,NSYMMAX,NPAT)
     &   ,ROVALDS(3,NSYMMAX,NPAT),RHOPS(0:NPLWMAX)
	CHARACTER ELEMENT(104)*2,DIR*57,FILE*4,ANSW*1 
	LOGICAL SYM(LMMAXV,NPAT)
C SET LMTO-COMMONS
	COMMON /PARAM/   NSORT,IS,ILST,ILSB,ILSV,NATOM
	COMMON /POTCOM/  SWZ,SMT
	COMMON /LATTICE/ RBAS,GBAS
	COMMON /DENS/    RO,ROVALDS,ROCOR
	COMMON /PSRHO/   RHOPS
	COMMON /MULTRO/  Z,ZCORE
	COMMON /LATPAR/  PAR,ORTH,OMEGAC
	COMMON /RADMESH/ NRAD,H,R,DR,WEIGHT
	COMMON /PLWMESH/ NPLW,GPLW
	COMMON /ASASPH/  SW
	COMMON /RADIUS/  RADIUS
	COMMON /RELATIV/ LR
	COMMON /SYMMLM/  SYM,LMSYM,NSYM
	COMMON /CORE/    ROATOM,ROCATOM,JCORE,JMAX,XZ,XE,NNIZ
	COMMON /LIBMESH/ NLIB,HLIB,RLIB
	COMMON /UNIT/    IUN
	COMMON /TXTEL/   TXTEL
	DATA PI/3.141592653589793D0/,NSPIN/1/
C SET PERIODIC TABLE DATA
	DATA ELEMENT/'h ','he','li','be','b ','c ','n ','o ','f ','ne'
     &              ,'na','mg','al','si','p ','s ','cl','ar','k ','ca'
     &              ,'sc','ti','v ','cr','mn','fe','co','ni','cu','zn'
     &              ,'ga','ge','as','se','br','kr','rb','sr','y ','zr'
     &              ,'nb','mo','tc','ru','rh','pd','ag','cd','in','sn'
     &              ,'sb','te','i ','xe','cs','ba','la','ce','pr','nd'
     &              ,'pm','sm','eu','gd','tb','dy','ho','er','tm','yb'
     &              ,'lu','hf','ta','w ','re','os','ir','pt','au','hg'
     &              ,'tl','pb','bi','po','at','rn','fr','ra','ac','th'
     &              ,'pa','u ','np','pu','am','cm','bk','cf','es','fm'
     &              ,'md','no','lw','??'/
	DATA FILE/'den.'/       !!! <--- FILE NAME
	DATA ANSW/' '/
C HERE IS THE PATH TO THE ATOMIC-DATA DIRECTORY:::
	DIR='/u/a4/savrasov/atomdat/                                  '
	NBL=INDEX(DIR,' ')
	SQPI4=2.D0*SQRT(PI)
	IUN=6
C PRINT TITLE OF THE PROGRAM
      PRINT*,'********************************************************'
      PRINT*,'<Makescfm> creates input scffile to the FP-LMTO program.'
      PRINT*,'It analizes atomic  data written in the inifile  and it '
      PRINT*,'reads free electron charge densities of the consituents '
      PRINT*,'involved. You  can either specify the  input file names '
      PRINT*,'for every atom or use default names "../atomdat/den.el" '
      PRINT*,'known from the nuclei charges.Mattheiss prescription is '
      PRINT*,'used for generating input charge density distribution.  ' 
      PRINT*,'Adapted to full potential PW-version of the LMTO method '
      PRINT*,'versions 1.40 or later.                                 '
      PRINT*,'********************************************************'
C READ INPUT FILE NAMES
   5    PRINT999
	READ(5,1003)ANSW
	IANSW=-1
	IF(ANSW.EQ.' '.OR.ANSW.EQ.'Y'.OR.ANSW.EQ.'y')IANSW=1
	IF(ANSW.EQ.'N'.OR.ANSW.EQ.'n')IANSW=0
	IF(IANSW.EQ.-1)THEN
	PRINT*,'Please answer "yes" or "no"'
	GOTO5
	ENDIF 
	PRINT1000
	READ(5,1003)INIFILE
	PRINT1001
	READ(5,1003)STRFILE
	PRINT1030
	READ(5,*)RADIUS
C READ INPUT FILES
	CALL READINI(INIFILE)
	CALL READSTR(STRFILE)
C CALCULATE MESH ARRAYS
	CALL LIBMSH
	CALL RADMSH
	CALL FFTMSH
	CALL PLWMSH
	CALL PLWSTR
	CALL PLW2MH
	CALL SYMLMM 
C READ ATOMIC DENSITIES
	DO 10 ISORT=1,NSORT
	IF(IANSW.EQ.0)THEN
	PRINT1010,TXTEL(ISORT)
	READ(5,1003)CORFILE(ISORT)
	IF(CORFILE(ISORT).EQ.'EMPTY'.OR.
     &  CORFILE(ISORT).EQ.'empty')
     &  CORFILE(ISORT)='empty sphere'
	ELSEIF(IANSW.EQ.1)THEN
	IZ=Z(ISORT)
	IF(IZ.EQ.0)CORFILE(ISORT)='empty sphere'
	IF(IZ.NE.0)CORFILE(ISORT)=DIR(:NBL-1)//FILE//ELEMENT(IZ)
	ENDIF
	CALL READCOR(CORFILE(ISORT),CHR(ISORT),ISORT)
  10    CONTINUE
C  PERFORM THE SUMMATION OF ATOMIC DENSITIES ACCORDING TO
C  MATTHEISS PRESCRIPTION. RETURN FULL CHARGE DENSITY.
	PRINT*,
     &  '============== Start Processing Atomic Data =============>'
	CALL MATRHO
	CALL PLWRHO
	CALL RENROV
	DO 20 IATOM=1,NATOM
	ISORT=IS(IATOM)
	PRINT1020,Z(ISORT),CHR(ISORT),NRAD(ISORT),TXTEL(ISORT),
     &  CORFILE(ISORT)
  20    CONTINUE
	PRINT*,
     &  '=========================================================>'
C  STORE OUTPUT FILE
	PRINT1002
	READ(5,1003)SCFFILE
	OPEN(3,FILE=SCFFILE,STATUS='NEW',FORM='UNFORMATTED')
	WRITE(3)NATOM,NSORT,NSPIN,NPLW,-1,(NRAD(ISORT),ISORT=1,
     &  NSORT),(ILSV(ISORT),ISORT=1,NSORT),(NSYM(IATOM),IATOM=1,NATOM)
	WRITE(3)((GPLW(I,IPLW),I=1,3),IPLW=0,NPLW),ORTH,GBAS,RBAS
	WRITE(3)(RHOPS(IPLW),IPLW=0,NPLW)
	DO 50 IATOM=1,NATOM
	ISORT=IS(IATOM)
	WRITE(3)(R(I,ISORT),I=0,NRAD(ISORT))
	WRITE(3)
	DO 40 LM=1,(ILSV(ISORT)+1)**2
	IF(SYM(LM,IATOM))THEN
	ISYM=LMSYM(LM,IATOM)
	WRITE(3)LM
	WRITE(3)(RO(I,ISYM,IATOM),I=0,NRAD(ISORT))
	ENDIF
  40    CONTINUE
	WRITE(3)JCORE(ISORT),JMAX(ISORT)
	WRITE(3)(XZ(L,ISORT),L=1,JMAX(ISORT))
	WRITE(3)(XE(L,ISORT),L=1,JMAX(ISORT))
	WRITE(3)(NNIZ(L,ISORT),L=1,JMAX(ISORT))
	WRITE(3)(ROCOR(I,ISORT),I=0,NRAD(ISORT))
	WRITE(3)
  50    CONTINUE
	CLOSE(3)
 999    FORMAT(1X,'Do you wish to use the default values? [y/n]',$)
1000    FORMAT(1X,'INIFILE? ',$)
1001    FORMAT(1X,'STRFILE? ',$)
1002    FORMAT(1X,'SCFFILE? ',$)
1003    FORMAT(A)
1010    FORMAT(1X,'Enter atomic density file ',A10,'> ',$)
1020    FORMAT(1X,'Charge: ',G12.5,1X,G12.5,'; Nrad=',I3,1X,A10,
     &  '; File used ',A60)
1030    FORMAT(1X,'Enter summation radius in a.u. : ',$)
	END


	SUBROUTINE READINI(INIFILE)
************************************************************
*  <READINI> reads control parameters,atomic stucture data *
*  iterative procedures limits and accuracy parameters     *
************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER IS(NPAT),ILST(NSORTMAX),ILSB(NSORTMAX),ILSV(NSORTMAX)
     &   ,LR(NSORTMAX),NKAP(NPANMAX),NFFTG(3)
	DIMENSION Z(NSORTMAX),ZCORE(NSORTMAX)
	COMPLEX*16 EKAP(NKAPMAX,NPANMAX),EK(NKAPMAX,NPANMAX)
	CHARACTER*60 INIFILE,TXTEL(NSORTMAX)*10
	COMMON /CONTROL/ MAN,LMTO,NSPH,NINT,NPF
	COMMON /PARAM/   NSORT,IS,ILST,ILSB,ILSV,NATOM
	COMMON /POTCOM/  SWZ,SMT(NSORTMAX)
	COMMON /MULTRO/  Z,ZCORE
	COMMON /ACCURG/  EPSR,EPSG
	COMMON /FFTMESH/ NFFTG
	COMMON /LATPAR/  PAR
	COMMON /KAPPAR/  NPAN,NKAP,EK,EKAP
	COMMON /ASASPH/  SW(NSORTMAX)
	COMMON /RELATIV/ LR
	COMMON /UNIT/    IUN
	COMMON /TXTEL/   TXTEL
	DATA PI/3.141592653589793D0/
	OPEN(1,FILE=INIFILE,STATUS='OLD')
	DO 10 I=1,13
	READ(1,*)
  10    CONTINUE
	READ(1,*)NATOM,NSORT
	IF(NATOM.GT.NPAT)STOP'NATOM>NPAT, INCREASE NPAT IN PARAM.DAT'
	IF(NSORT.GT.NSORTMAX)STOP'NSORT>NSORTMAX, INCREASE NSORTMAX
     &  IN PARAM.DAT'
	READ(1,*)PAR
	READ(1,*)(IS(I),I=1,NATOM)
	READ(1,*)NKAP(1),(EKAP(IKAP,1),IKAP=1,NKAP(1))
	IF(NKAP(1).GT.NKAPMAX)STOP'NKAP>NKAPMAX, INCREASE NKAPMAX IN
     &  PARAM.DAT'
	DO 50 ISORT=1,NSORT
	READ(1,1000)TXTEL(ISORT)
	READ(1,*)Z(ISORT),ZCORE(ISORT),LR(ISORT)
	READ(1,*)SMT(ISORT),SR1,SW(ISORT)
	READ(1,*)ILST(ISORT),ILSB(ISORT),ILSV(ISORT)
	IF(ILSV(ISORT).GT.LMAXV)STOP'ILSV>LMAXV, INCREASE LMAXV IN
     &  PARAM.DAT'
	READ(1,*)
	DO 30 IKAP=1,NKAP(1)
	READ(1,*)
	READ(1,*)
	READ(1,*)
	READ(1,*)
	READ(1,*)
	READ(1,*)
	EK(IKAP,1)=EKAP(IKAP,1)*PAR**2
  30    CONTINUE
	READ(1,*)
	READ(1,*)NC
	DO 40 IC=1,NC
	READ(1,*)
  40    CONTINUE
  50    CONTINUE
	DO 60 I=1,13
	READ(1,*)
  60    CONTINUE
	READ(1,*)N1,N2,N3
	READ(1,*)NFFTG,EPSR,EPSG
        IF(NFFTG(1).EQ.0)STOP'SET FFT-GRID IN INIFILE'
        IF(MOD(NFFTG(1),2).NE.0)STOP'FFT-GRID MUST BE EVEN'
        IF(MOD(NFFTG(2),2).NE.0)STOP'FFT-GRID MUST BE EVEN'
        IF(MOD(NFFTG(3),2).NE.0)STOP'FFT-GRID MUST BE EVEN'
	CLOSE(1)
	NPAN=1
1000    FORMAT(A)
	END

 
 
	SUBROUTINE READCOR(CORFILE,CHARGE,ISORT)
*****************************************************************
*  Readcor reads atomic density data file.                      *
***************************************************************** 
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	DIMENSION ROCATOM(0:631,NSORTMAX),ROATOM(0:631,NSORTMAX)
     &   ,HLIB(NSORTMAX),SCEXP(0:631,NSORTMAX),XE(36,NSORTMAX)
     &   ,XZ(36,NSORTMAX),WORK1(0:631),WORK2(0:631)
     &   ,DRLIB(0:631,NSORTMAX)
	CHARACTER*60 CORFILE
	INTEGER NNIZ(36,NSORTMAX),JCORE(NSORTMAX),JMAX(NSORTMAX)
	COMMON /LIBMESH/NLIB,HLIB,SCEXP,DRLIB
	COMMON /CORE/   ROATOM,ROCATOM,JCORE,JMAX,XZ,XE,NNIZ
	DATA PI/3.141592653589793D0/
	IF(CORFILE.EQ.'empty sphere')THEN
	JCORE(ISORT)=0
	JMAX(ISORT)=0
	DO 10 IRAD=0,NLIB
	ROATOM(IRAD,ISORT)=0.D0
	ROCATOM(IRAD,ISORT)=0.D0
  10    CONTINUE
	CHARGE=0.D0
	RETURN
	ENDIF
	OPEN(1,FILE=CORFILE,STATUS='OLD',FORM='FORMATTED')
	READ(1,*)
	READ(1,*)JCORE(ISORT),JMAX(ISORT)
	READ(1,*)(ROATOM(N,ISORT),N=1,NLIB)
	READ(1,*)(ROCATOM(N,ISORT),N=1,NLIB)
	ROATOM(0,ISORT)=ROATOM(1,ISORT)
     & -(ROATOM(2,ISORT)-ROATOM(1,ISORT))/
     &  (SCEXP(2,ISORT)-SCEXP(1,ISORT))*SCEXP(1,ISORT)
	ROCATOM(0,ISORT)=ROCATOM(1,ISORT)
     & -(ROCATOM(2,ISORT)-ROCATOM(1,ISORT))/
     &  (SCEXP(2,ISORT)-SCEXP(1,ISORT))*SCEXP(1,ISORT)
C       ---------------------------
	READ(1,*)(XZ(L,ISORT),L=1,JMAX(ISORT))
	READ(1,*)(XE(L,ISORT),L=1,JMAX(ISORT))
	READ(1,*)(NNIZ(L,ISORT),L=1,JMAX(ISORT))
	CLOSE(1)
C  FIND CHARGE
	DO 20 IRAD=0,NLIB
	WORK1(IRAD)=ROATOM(IRAD,ISORT)*4.D0*PI*SCEXP(IRAD,ISORT)**2*
     &  DRLIB(IRAD,ISORT)
  20    CONTINUE
	CALL QD(HLIB(ISORT),WORK1,WORK2,NLIB)
	CHARGE=WORK2(NLIB-1)
	END
 

        SUBROUTINE READSTR(STRFILE)
        IMPLICIT REAL*8 (A-H,O-Z)
        INCLUDE 'PARAM.DAT'
        CHARACTER STRFILE*60,KOVFILE*60,SYS*1,TXT*72,STRING(80)*1
	INTEGER IS(NPAT),ILST(NSORTMAX),ILSB(NSORTMAX),ILSV(NSORTMAX)
        DIMENSION RBASR(3,3),TAUR(3,NPAT),BASR(3),BBASR(3,3),ORTH(2:3)
     &    ,GBAS(3,3),RBAS(3,3),BBAS(3,3),TAU(3,NPAT),STRAIN(3,3,2)
     &    ,RSTN(3,3),TAU0(3,NPAT),TAU0R(3,NPAT)
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM   !!! from init
        COMMON /LATTICE/RBAS,GBAS                       !!! from init
        COMMON /MANSTR/ ISTRAIN,IBAS,IBZ,ICALC          !!! from init
        COMMON /BASIS/  TAU                             !!! from init
        COMMON /BASIS0/ TAU0                            !!! from init
        COMMON /LATPAR/ PAR,ORTH,OMEGAC,STRAIN          !!! from init
	COMMON /GROUPOUT/NGROUP                         !!! from group
        COMMON /UNIT/   IUN                             !!! from init
	DATA PI/3.141592653589793D0/,EPS/1.D-05/
        OPEN(UNIT=1,FILE=STRFILE,STATUS='OLD')
        READ(1,*)
        READ(1,1001)TXT
        READ(1,*) NATOM0,ORTH
        READ(1,*) IBAS,IBZ,ICALC,ISTRAIN
        READ(1,*) NDIV1,NDIV2
        READ(1,*) NVECMX,ALPHA
        IF(NATOM0.NE.NATOM)STOP'<READSTR>: # OF ATOMS MISMATCHES
     &  IN STRFILE, CHECK IT'
        READ(1,1000)TXT
        DO 10 IVEC=1,3
        IF(ICALC.NE.1)THEN
        READ(1,*)(RBASR(I,IVEC),I=1,3)
        ELSEIF(ICALC.EQ.1)THEN
        READ(1,1020)STRING
        CALL COMPVEC(STRING,RBASR(1,IVEC),3)
        ENDIF
  10    CONTINUE
        READ(1,1000)TXT
        DO 15 IATOM=1,NATOM
        IF(IBAS.EQ.1)THEN     !!! basis in Cartesian coordinates
        IF(ICALC.NE.1)THEN
        READ(1,*)(TAU0R(I,IATOM),I=1,3)
        ELSEIF(ICALC.EQ.1)THEN!!! using calculator
        READ(1,1020)STRING
        CALL COMPVEC(STRING,TAU0R(1,IATOM),3)
        ENDIF
        ELSEIF(IBAS.NE.1)THEN !!! basis in units of RBAS
        IF(ICALC.NE.1)THEN
        READ(1,*)(BASR(I),I=1,3)
        ELSEIF(ICALC.EQ.1)THEN!!! using calculator
        READ(1,1020)STRING
        CALL COMPVEC(STRING,BASR(1),3)
        ENDIF
        TAU0R(1,IATOM)=BASR(1)*RBASR(1,1)
     &                +BASR(2)*RBASR(1,2)
     &                +BASR(3)*RBASR(1,3)
        TAU0R(2,IATOM)=BASR(1)*RBASR(2,1)
     &                +BASR(2)*RBASR(2,2)
     &                +BASR(3)*RBASR(2,3)
        TAU0R(3,IATOM)=BASR(1)*RBASR(3,1)
     &                +BASR(2)*RBASR(3,2)
     &                +BASR(3)*RBASR(3,3)
        ENDIF
  15    CONTINUE
        READ(1,1000)TXT
        DO 20 IATOM=1,NATOM
        IF(IBAS.EQ.1)THEN     !!! basis in Cartesian coordinates
        IF(ICALC.NE.1)THEN
        READ(1,*)(TAUR(I,IATOM),I=1,3)
        ELSEIF(ICALC.EQ.1)THEN!!! using calculator
        READ(1,1020)STRING
        CALL COMPVEC(STRING,TAUR(1,IATOM),3)
        ENDIF
        ELSEIF(IBAS.NE.1)THEN !!! basis in units of RBAS
        IF(ICALC.NE.1)THEN
        READ(1,*)(BASR(I),I=1,3)
        ELSEIF(ICALC.EQ.1)THEN!!! using calculator
        READ(1,1020)STRING
        CALL COMPVEC(STRING,BASR(1),3)
        ENDIF
        TAUR(1,IATOM)=BASR(1)*RBASR(1,1)
     &               +BASR(2)*RBASR(1,2)
     &               +BASR(3)*RBASR(1,3)
        TAUR(2,IATOM)=BASR(1)*RBASR(2,1)
     &               +BASR(2)*RBASR(2,2)
     &               +BASR(3)*RBASR(2,3)
        TAUR(3,IATOM)=BASR(1)*RBASR(3,1)
     &               +BASR(2)*RBASR(3,2)
     &               +BASR(3)*RBASR(3,3)
        ENDIF
  20    CONTINUE
        READ(1,1000)TXT
        DO 30 I=1,3
        IF(ICALC.NE.1)THEN
        READ(1,*)(STRAIN(I,J,1),J=1,3)
        ELSEIF(ICALC.EQ.1)THEN
        READ(1,1020)STRING
        CALL COMPVEC(STRING,BASR(1),3)
        STRAIN(I,1,1)=BASR(1)
        STRAIN(I,2,1)=BASR(2)
        STRAIN(I,3,1)=BASR(3)
        ENDIF
  30    CONTINUE
C  SET RECIPROCAL STRAIN MATRIX: S*S^(-1)=1
        CALL CROSS(RSTN(1,1),STRAIN(1,2,1),STRAIN(1,3,1))
        CALL CROSS(RSTN(1,2),STRAIN(1,3,1),STRAIN(1,1,1))
        CALL CROSS(RSTN(1,3),STRAIN(1,1,1),STRAIN(1,2,1))
        W=STRAIN(1,1,1)*RSTN(1,1)
     &   +STRAIN(2,1,1)*RSTN(2,1)
     &   +STRAIN(3,1,1)*RSTN(3,1)
        IF(ABS(W).LE.1.D-10)STOP'<READSTR>:: WRONG STRAIN, DET=0'
        DO 40 I=1,3
        STRAIN(1,I,2)=RSTN(I,1)/W
        STRAIN(2,I,2)=RSTN(I,2)/W
        STRAIN(3,I,2)=RSTN(I,3)/W
  40    CONTINUE
	READ(1,1000)TXT
        READ(1,*)SYS
        IF(SYS.EQ.'C')IKOV=1
        IF(SYS.EQ.'H')IKOV=2
        IF(SYS.EQ.'A')IKOV=3
        IF(IKOV.EQ.3)THEN
        BACKSPACE(1)
        READ(1,*)SYS,KOVFILE
        ENDIF
        READ(1,1000)TXT
        DO 50 IVEC=1,3
        IF(ICALC.NE.1)THEN
        READ(1,*)(BBASR(I,IVEC),I=1,3)
        ELSEIF(ICALC.EQ.1)THEN
        READ(1,1020)STRING
        CALL COMPVEC(STRING,BBASR(1,IVEC),3)
        ENDIF
  50    CONTINUE
C  ACCOUNT FOR ORTHOROMBICITY PARAMETERS
        DO 90 I=2,3
        DO 70 IVEC=1,3
        RBASR(I,IVEC)=RBASR(I,IVEC)*ORTH(I)
        BBASR(I,IVEC)=BBASR(I,IVEC)/ORTH(I)
  70    CONTINUE
        DO 80 IATOM=1,NATOM
        TAU0R(I,IATOM)=TAU0R(I,IATOM)*ORTH(I)
        TAU R(I,IATOM)=TAU R(I,IATOM)*ORTH(I)
  80    CONTINUE
  90    CONTINUE
C  APPLY STRAIN MATRIX FOR TRANSLATIONS:  R'=S*R
        DO 150 IVEC=1,3
        DO 150 I=1,3
        RBAS(I,IVEC)=0.D0
        DO 140 J=1,3
        RBAS(I,IVEC)=RBAS(I,IVEC)+STRAIN(I,J,1)*RBASR(J,IVEC)
 140    CONTINUE
 150    CONTINUE
C  APPLY STRAIN FOR BASIS VECTORS:  T'=S*T
        DO 170 IATOM=1,NATOM
        DO 170 I=1,3
        TAU (I,IATOM)=0.D0
        TAU0(I,IATOM)=0.D0
        DO 160 J=1,3
        TAU (I,IATOM)=TAU (I,IATOM)+STRAIN(I,J,1)*TAU R(J,IATOM)
        TAU0(I,IATOM)=TAU0(I,IATOM)+STRAIN(I,J,1)*TAU0R(J,IATOM)
 160    CONTINUE
 170    CONTINUE
C  APPLY INVERSE STRAIN FOR BRILLOUIN ZONE: BZ'=BZ*S^(-1)
        DO 190 IVEC=1,3
        DO 190 I=1,3
        BBAS(I,IVEC)=0.D0
        DO 180 J=1,3
        BBAS(I,IVEC)=BBAS(I,IVEC)+BBASR(J,IVEC)*STRAIN(J,I,2)
 180    CONTINUE
 190    CONTINUE
C  SET RECIPROCAL LATTICE VECTORS WITHOUT 2*PI
        CALL CROSS(GBAS(1,1),RBAS(1,2),RBAS(1,3))
        CALL CROSS(GBAS(1,2),RBAS(1,3),RBAS(1,1))
        CALL CROSS(GBAS(1,3),RBAS(1,1),RBAS(1,2))
        W=RBAS(1,1)*GBAS(1,1)
     &   +RBAS(2,1)*GBAS(2,1)
     &   +RBAS(3,1)*GBAS(3,1)
        DO 230 I=1,3
        GBAS(I,1)=GBAS(I,1)/W
        GBAS(I,2)=GBAS(I,2)/W
        GBAS(I,3)=GBAS(I,3)/W
 230    CONTINUE
        OMEGAC=ABS(W)*PAR**3
C  SET BRILLOUIN ZONE TO GBAS IF REQUIRED
        IF(IBZ.EQ.1)THEN
        DO 240 I=1,3
        BBAS(I,1)=GBAS(I,1)
        BBAS(I,2)=GBAS(I,2)
        BBAS(I,3)=GBAS(I,3)
 240    CONTINUE
        ENDIF
	LMMV=0
	DO 250 IATOM=1,NATOM
	LMMV=MAX(LMMV,ILSV(IS(IATOM)))
 250    CONTINUE
        CALL WIGMAT(LMMV,SYS,KOVFILE)
        CALL GROUPS(RBAS,TAU0,IS,LMMV,NATOM,1,1,EPS,1)
        WRITE(IUN,1030)NGROUP
        CALL WIGMAT(LMMV,SYS,KOVFILE)
        CALL GROUPS(RBAS,TAU, IS,LMMV,NATOM,1,1,EPS,2)
        WRITE(IUN,1040)NGROUP
	CALL GDATA(LMMV+1)        !!! calulate Gaunt numbers
1000    FORMAT(A)
1001    FORMAT(/A)
1010    FORMAT(2(1X,A1))
1020    FORMAT(80A1)
1030    FORMAT(1X,I4,' elements discovered for  original lattice')
1040    FORMAT(1X,I4,' elements found      for distorted lattice')
	END


	SUBROUTINE RADMSH
*************************************************************
*   Module prepares radial mesh in each  MT-sphere          *
*************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER IS(NPAT),ILST(NSORTMAX),ILSB(NSORTMAX),ILSV(NSORTMAX)
     &    ,NRAD(NSORTMAX),LR(NSORTMAX)
	DIMENSION H(NSORTMAX),R(0:NRADMAX,NSORTMAX),SMT(NSORTMAX)
     &    ,GL(3),WEIGHT(0:NRADMAX,NSORTMAX),Z(NSORTMAX),AS(NPAT)
     &    ,RL(0:NRADMAX,0:LMAXV,NSORTMAX),ZCOR(NSORTMAX)
     &    ,DR(0:NRADMAX,NSORTMAX),SASA(NSORTMAX)
	COMMON /PARAM/   NSORT,IS,ILST,ILSB,ILSV,NATOM      !!! from init
	COMMON /LATTICE/ A(3),B(3),C(3)                     !!! from init
	COMMON /RADMESH/ NRAD,H,R,DR,WEIGHT,RL              !!! for all modules
	COMMON /MULTRO/  Z,ZCOR                             !!! from init
	COMMON /POTCOM/  SWZ,SMT                            !!! for all modules
	COMMON /ASASPH/  SASA                               !!! for all modules
	COMMON /RELATIV/ LR                                 !!! from init
	COMMON /LATPAR/  PAR                                !!! from init
	COMMON /UNIT/    IUN                                !!! from init
	DATA PI/3.141592653589793D0/,DELTANR/0.03D0/,DELTAR/0.03D0/
C  DEFINE WIGNER-ZEITS SPHERE
	CALL CROSS(GL,B,C)
	OMEGA=ABS(A(1)*GL(1)+A(2)*GL(2)+A(3)*GL(3))   !!! volume of unit-cell
	DO 1 IATOM=1,NATOM
    1   AS(IATOM)=SASA(IS(IATOM))
	CALL SCASW(NATOM,OMEGA,AS,S0,AS)              !!! ASA sphere radii
	SWZ=PAR*S0                                    !!! WZ sphere radius
	DO 5 IATOM=1,NATOM
    5   SASA(IS(IATOM))=PAR*AS(IATOM)
	DO 30 ISORT=1,NSORT
C  DEFINE STEP
	IF(LR(ISORT).EQ.0)H(ISORT)=DELTANR
	IF(LR(ISORT).EQ.1)H(ISORT)=DELTA R
C  DEFINE MESH PARAMETERS
	BETTA=1.D0/(2.D0*Z(ISORT)+1.D0)
	NRAD(ISORT)=2*LOG(SMT(ISORT)/BETTA+1.D0)/H(ISORT)
	NRAD(ISORT)=MAX(NRAD(ISORT),100)
	NRAD(ISORT)=MIN(NRAD(ISORT),NRADMAX)
	NRAD(ISORT)=((NRAD(ISORT)-1)/2)*2  !!! must be odd number
	BETTA=SMT(ISORT)/(EXP(H(ISORT)*NRAD(ISORT))-1.D0)
C  DEFINE RADIAL MESH ARRAYS
	DO 20 IRAD=0,NRAD(ISORT)
	R(IRAD,ISORT)=BETTA*(EXP(H(ISORT)*IRAD)-1.D0)
	DR(IRAD,ISORT)=BETTA*EXP(H(ISORT)*IRAD)
	WEIGHT(IRAD,ISORT)=4.D0*PI*R(IRAD,ISORT)**2*DR(IRAD,ISORT)
	RL(IRAD,0,ISORT)=1.D0
	DO 10 L=1,LMAXV
	RL(IRAD,L,ISORT)=R(IRAD,ISORT)**L
  10    CONTINUE
  20    CONTINUE
  30    CONTINUE
	END



	SUBROUTINE SCASW(NATOM,OMEGA,R,S0,S)
*********************************************************
*  Scale ASA sphere radii according to the numbers R(I) *
*********************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	DIMENSION R(NATOM),S(NATOM)
	DATA PI/3.141592653589793D0/
	S0=(OMEGA/NATOM/(4.*PI)*3.)**0.33333333333333D0
	OMEGAR=0.0
	DO 10 I=1,NATOM
  10    OMEGAR=OMEGAR+4.D0/3.D0*PI*R(I)**3
	A=(OMEGA/OMEGAR)**0.333333333333333D0
	DO 20 I=1,NATOM
  20    S(I)=A*R(I)
	END


	SUBROUTINE LIBMSH
************ ORIGINAL LIB.MESH *********
	INCLUDE 'PARAM.DAT'
	IMPLICIT REAL*8 (A-H,O-Z)
	DIMENSION HLIB(NSORTMAX),SCEXP(0:631,NSORTMAX)
     &    ,DRLIB(0:631,NSORTMAX)
	COMMON /PARAM/   NSORT
	COMMON /LIBMESH/ NLIB,HLIB,SCEXP,DRLIB
	NLIB=421
	HH1=32.D0
	XMAX=LOG(60.D0)
	XMIN=XMAX-DBLE(NLIB-1)/HH1
	DO 20 ISORT=1,NSORT
	HLIB(ISORT)=(XMAX-XMIN)/DBLE(NLIB-1)
	SCEXP(0,ISORT)=0.D0
	DRLIB(0,ISORT)=0.D0
	DO 10 N=1,NLIB
	SCEXP(N,ISORT)=EXP(XMIN+HLIB(ISORT)*(N-1))
	DRLIB(N,ISORT)=EXP(XMIN+HLIB(ISORT)*(N-1))
  10    CONTINUE
  20    CONTINUE
	END



	SUBROUTINE CROSS(A,B,C)
**********************************************************
*    Cross product (AX,AY,AZ)=(BX,BY,BZ)*(CX,CY,CZ)      *
**********************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	DIMENSION A(3),B(3),C(3)
	A(1)=B(2)*C(3)-B(3)*C(2)
	A(2)=B(3)*C(1)-B(1)*C(3)
	A(3)=B(1)*C(2)-B(2)*C(1)
	END
	
	
	
