	SUBROUTINE PLWRHO
**************************************************************
* Calculates pseudocharge density by fast fourier transform. *
* Written by S.Yu.Savrasov (Lebedev Physical Institute)      *
**************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER IS(NPAT),ILST(NSORTMAX),ILSB(NSORTMAX),ILSV(NSORTMAX)
     &    ,ISENVR(0:NVCMAX),MDIV(3),MR(3),KGMIN(3),KGMAX(3)
     &    ,INDG(NFFTMAX),KVEC(3,0:NPLWMAX),MF(3),INTFFT(NFFTMAX)
	COMPLEX*16 RHOPS(0:NPLWMAX),RHORS(NFFTMAX),EXPGR
     &   ,RHOTM(NFFTMAX)
	DIMENSION SMT(NSORTMAX),ORTH(2:3),AD(3,3),RD(3,3),TAU(3,NPAT)
     &    ,WX(0:631,NSORTMAX),WY(0:631,NSORTMAX),WZ(0:631,NSORTMAX)
     &    ,TENVR(3,0:NVCMAX),TAUT(3,NPAT),RBAS(3,3),GBAS(3,3),GL(3)
     &    ,ROATOM(0:631,NSORTMAX),ROCATOM(0:631,NSORTMAX)
     &    ,HLIB(NSORTMAX),RLIB(0:631,NSORTMAX),RHOT(5)
     &    ,PREF(NSORTMAX),EXPF(NSORTMAX),GPLW(3,0:NPLWMAX)
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM    !!! from init
	COMMON /POTCOM/ SWZ,SMT                          !!! from init
	COMMON /PSRHO/  RHOPS                            !!! from plwrho
	COMMON /LATTICE/RBAS,GBAS                        !!! from init
	COMMON /BASIS/  TAU                              !!! from init
	COMMON /FFTMESH/MDIV,AD,RD,INTFFT                !!! from init
	COMMON /LIBMESH/NLIB,HLIB,RLIB                   !!! from libmsh
	COMMON /PLWMESH/NPLW,GPLW,KVEC,KGMIN,KGMAX,INDG  !!! from plwmsh
	COMMON /RADIUS/ RADIUS                           !!! from makescfm
	COMMON /LATPAR/ PAR,ORTH,OMEGAC                  !!! from init
	COMMON /CORE/   ROATOM,ROCATOM  
	DATA PI/3.141592653589793D0/,DIM/(0.D0,1.D0)/
	DO 20 ISORT=1,NSORT
C  DEFINE SPLINE COEFFICIENTS
	CALL SPLKFF(NLIB+1,RLIB(0,ISORT),ROATOM(0,ISORT),
     &  WX(0,ISORT),WY(0,ISORT),WZ(0,ISORT))
C  DEFINE SMOOTH MT-PART BY A*EXP(-B*R^2)
	STEP=SMT(ISORT)/100.D0
	DO 10 ID=1,5
	RR=SMT(ISORT)+DBLE(ID-3)*STEP
	RHOT(ID)=SPLPNT(NLIB+1,RR,RLIB(0,ISORT),ROATOM(0,ISORT),
     &  WX(0,ISORT),WY(0,ISORT),WZ(0,ISORT))
  10    CONTINUE
	RHOS=RHOT(3)
	RHOD=(RHOT(1)-RHOT(5)+8.D0*(RHOT(4)-RHOT(2)))/12.D0/STEP
	EXPF(ISORT)=-RHOD/RHOS/2.D0/SMT(ISORT)
	PREF(ISORT)=RHOS*EXP(EXPF(ISORT)*SMT(ISORT)**2)
  20    CONTINUE
C  DO GLOBALLY OVER  GRID POINTS OF FFT
	DO 90 MFFT3=0,MDIV(3)-1                    !!! over mfft3
	DO 80 MFFT2=0,MDIV(2)-1                    !!! over mfft2
	DO 70 MFFT1=0,MDIV(1)-1                    !!! over mfft1
	IFFT=1+MFFT1+MFFT2*MDIV(1)+MFFT3*MDIV(1)*MDIV(2)
	IATOM0=INTFFT(IFFT)
	ISORT0=0
	IF(IATOM0.GT.0)ISORT0=IS(IATOM0)
	RHORS(IFFT)=(0.D0,0.D0)
C  RADIUS-VECTOR IS GIVEN BY
	RSX=MFFT1*AD(1,1)+MFFT2*AD(1,2)+MFFT3*AD(1,3)
	RSY=MFFT1*AD(2,1)+MFFT2*AD(2,2)+MFFT3*AD(2,3)
	RSZ=MFFT1*AD(3,1)+MFFT2*AD(3,2)+MFFT3*AD(3,3)
C  CALCULATE ENVIRONMET SITES FOR THE POINT "RS"
	DO 30 IATOM=1,NATOM
	TAUT(1,IATOM)=TAU(1,IATOM)-RSX
	TAUT(2,IATOM)=TAU(2,IATOM)-RSY
	TAUT(3,IATOM)=TAU(3,IATOM)-RSZ
  30    CONTINUE
	RMAX=RADIUS/PAR+1.D-05
	CALL SITEGEN(RMAX,RBAS(1,1),RBAS(1,2),RBAS(1,3),
     &  TAUT,NATOM,NENVR,TENVR(1,0),ISENVR(0))
	NENVR=NENVR-1
	DO 50 IENVR=0,NENVR                            !!! over ienvr
	IATOMR=ISENVR(IENVR)
	ISORTR=IS(IATOMR)
	RTX=-TENVR(1,IENVR)
	RTY=-TENVR(2,IENVR)
	RTZ=-TENVR(3,IENVR)
	RT=SQRT(RTX*RTX+RTY*RTY+RTZ*RTZ)
	KEYOUT=1
	IF(RT*PAR.LE.SMT(ISORTR))KEYOUT=0
C  CALCULATE PSEUDOCHARGE DENSITY AT THE POINT "RT"
	IF(KEYOUT.EQ.1)THEN
	RHOPNT=SPLPNT(NLIB+1,RT*PAR,RLIB(0,ISORTR),ROATOM(0,ISORTR),
     &  WX(0,ISORTR),WY(0,ISORTR),WZ(0,ISORTR))
	ELSEIF(KEYOUT.EQ.0)THEN
	IF(ISORT0.NE.ISORTR)STOP'<PLWRHO>: WRONG ARRAY "INTFFT", 
     &  POSSIBLY MT-SPHERES OVERLAP!!!'
	RHOPNT=PREF(ISORT0)*EXP(-EXPF(ISORT0)*(RT*PAR)**2)
	ENDIF
	RHORS(IFFT)=RHORS(IFFT)+RHOPNT
  50    CONTINUE                                      !!! over ienvr
  70    CONTINUE
  80    CONTINUE
  90    CONTINUE
C
C  MAKE FAST FOURIER TRANSFORM FOR THE PSEUDOCHARGE DENSITY
C  DO OVER "R2","R3" AND "G1", *** GET RHO{G1,R2,R3} ***
	DO 540 MFFT3=0,MDIV(3)-1
	DO 530 MFFT2=0,MDIV(2)-1
	DO 520 MFTR1=0,MDIV(1)-1
	IFTR=1+MFTR1+MFFT2*MDIV(1)+MFFT3*MDIV(1)*MDIV(2)
	GX=MFTR1*GBAS(1,1)
	GY=MFTR1*GBAS(2,1)
	GZ=MFTR1*GBAS(3,1)
	RHOTM(IFTR)=(0.D0,0.D0)
C  SUM OVER "R1"
	DO 510 MFFT1=0,MDIV(1)-1
	IFFT=1+MFFT1+MFFT2*MDIV(1)+MFFT3*MDIV(1)*MDIV(2)
	SCP=GX*MFFT1*AD(1,1)+GY*MFFT1*AD(2,1)+GZ*MFFT1*AD(3,1)
	EXPGR=EXP((0.D0,-1.D0)*2.D0*PI*SCP)
	RHOTM(IFTR)=RHOTM(IFTR)+EXPGR*RHORS(IFFT)
 510    CONTINUE
 520    CONTINUE
 530    CONTINUE
 540    CONTINUE
C  DO OVER "R3","G1" AND "G2", *** GET RHO{G1,G2,R3} ***
	DO 640 MFFT3=0,MDIV(3)-1
	DO 630 MFTR1=0,MDIV(1)-1
	DO 620 MFTR2=0,MDIV(2)-1
	IFTR=1+MFTR1+MFTR2*MDIV(1)+MFFT3*MDIV(1)*MDIV(2)
	GX=MFTR2*GBAS(1,2)
	GY=MFTR2*GBAS(2,2)
	GZ=MFTR2*GBAS(3,2)
	RHORS(IFTR)=(0.D0,0.D0)
C  SUM OVER "R2"
	DO 610 MFFT2=0,MDIV(2)-1
	IFFT=1+MFTR1+MFFT2*MDIV(1)+MFFT3*MDIV(1)*MDIV(2)
	SCP=GX*MFFT2*AD(1,2)+GY*MFFT2*AD(2,2)+GZ*MFFT2*AD(3,2)
	EXPGR=EXP((0.D0,-1.D0)*2.D0*PI*SCP)
	RHORS(IFTR)=RHORS(IFTR)+EXPGR*RHOTM(IFFT)
 610    CONTINUE
 620    CONTINUE
 630    CONTINUE
 640    CONTINUE
C  DO OVER "G1","G2" AND "G3", *** GET RHO{G1,G2,G3} ***
	DO 740 MFTR1=0,MDIV(1)-1
	DO 730 MFTR2=0,MDIV(2)-1
	DO 720 MFTR3=0,MDIV(3)-1
	IFTR=1+MFTR1+MFTR2*MDIV(1)+MFTR3*MDIV(1)*MDIV(2)
	GX=MFTR3*GBAS(1,3)
	GY=MFTR3*GBAS(2,3)
	GZ=MFTR3*GBAS(3,3)
	RHOTM(IFTR)=(0.D0,0.D0)
C  SUM OVER "R3"
	DO 710 MFFT3=0,MDIV(3)-1
	IFFT=1+MFTR1+MFTR2*MDIV(1)+MFFT3*MDIV(1)*MDIV(2)
	SCP=GX*MFFT3*AD(1,3)+GY*MFFT3*AD(2,3)+GZ*MFFT3*AD(3,3)
	EXPGR=EXP((0.D0,-1.D0)*2.D0*PI*SCP)
	RHOTM(IFTR)=RHOTM(IFTR)+EXPGR*RHORS(IFFT)
 710    CONTINUE
 720    CONTINUE
 730    CONTINUE
 740    CONTINUE
C  **** SET PSEUDODENSITY WITHIN SPHERE GMAX ***
	ANORM=1.D0/DBLE(MDIV(1)*MDIV(2)*MDIV(3))
	DO 840 M3=KGMIN(3),KGMAX(3)
	DO 830 M2=KGMIN(2),KGMAX(2)
	DO 820 M1=KGMIN(1),KGMAX(1)
	IDIM=1+M1-KGMIN(1)+(KGMAX(1)-KGMIN(1)+1)*(M2-KGMIN(2))+
     &  (KGMAX(1)-KGMIN(1)+1)*(KGMAX(2)-KGMIN(2)+1)*(M3-KGMIN(3))
	IPLW=INDG(IDIM)
	IF(IPLW.EQ.-1)GOTO820
	GL(1)=M1*GBAS(1,1)+M2*GBAS(1,2)+M3*GBAS(1,3)
	GL(2)=M1*GBAS(2,1)+M2*GBAS(2,2)+M3*GBAS(2,3)
	GL(3)=M1*GBAS(3,1)+M2*GBAS(3,2)+M3*GBAS(3,3)
C  REDUCE TO FIRST CELL GIVEN BY RD(I,1..3)
	CALL REDFCEL(GL,GBAS,RBAS,MDIV,MF)
	IFTR=1+MF(1)+MF(2)*MDIV(1)+MF(3)*MDIV(1)*MDIV(2)
	RHOPS(IPLW)=ANORM*RHOTM(IFTR)
 820    CONTINUE
 830    CONTINUE
 840    CONTINUE
	END


	SUBROUTINE REDFCEL(X,AD,RD,NDIV,NR)
*********************************************************
*  Finds coordinates of vector X in the first cell      *
*  defined by Ad*Ndiv. Rd - reciprocals to Ad.          *
*********************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INTEGER NDIV(3),NR(3)
	DIMENSION X(3),AD(3,3),RD(3,3)
	X1=X(1)*RD(1,1)+X(2)*RD(2,1)+X(3)*RD(3,1)
	X2=X(1)*RD(1,2)+X(2)*RD(2,2)+X(3)*RD(3,2)
	X3=X(1)*RD(1,3)+X(2)*RD(2,3)+X(3)*RD(3,3)
	N1=ANINT(X1)
	N2=ANINT(X2)
	N3=ANINT(X3)
	IF(ABS(N1-X1).GE.1.D-05.OR.ABS(N2-X2).GE.1.D-05.
     &  OR.ABS(N3-X3).GE.1.D-05)STOP'<REDFCEL>:: WRONG POINT !'
	NR(1)=MOD(N1,NDIV(1))
	NR(2)=MOD(N2,NDIV(2))
	NR(3)=MOD(N3,NDIV(3))
	IF(NR(1).LT.0)NR(1)=NR(1)+NDIV(1)
	IF(NR(2).LT.0)NR(2)=NR(2)+NDIV(2)
	IF(NR(3).LT.0)NR(3)=NR(3)+NDIV(3)
	END
