	SUBROUTINE BANDS
****************************************************************
*   Control module for package of programs solved generalized  *
*         eigenvalue problem of the LMTO method                *
****************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER NPNT(NPANMAX)
	COMMON /KAPPAR/ NPAN
	COMMON /SPIN/   NSPIN
	COMMON /MESH/   NPNT
	COMMON /UNIT/   IUN
C ** COMPUTE EIGENVALUES AND EIGENVECTORS ***
	DO IPAN=1,NPAN           !!! over panels
	CALL SNULTOS(IPAN)       !!! set tos-matrix to zero
	CALL SNULINT(IPAN)       !!! set int-matrix to zero
	CALL SNULPUL(IPAN)       !!! set pul-matrix to zero
	CALL SSETENY(IPAN)       !!! place Eny somewhere
	CALL SCORENY(IPAN)       !!! find binding energies for semicore
	CALL SPOTPAR(IPAN)       !!! different potential partameters
	CALL SKKRPAR(IPAN)       !!! KKR-partameters (only to print)
	CALL SPRIPAR(IPAN)       !!! print potential parameters
	CALL SLMTPAR(IPAN)       !!! some combinations of parameters
	CALL SOVRPAR(IPAN)       !!! potential parameters for overlapping
	CALL SNMTPAR(IPAN)       !!! NMT potential parameters
        CALL SINTPAR(IPAN)       !!! potential parameters in the int.region
	CALL SHUBPAR(IPAN)       !!! Hubbard corrections
 	CALL SORBPAR(IPAN)       !!! SO-coupling parameters
	DO IPNT=1,NPNT(IPAN)     !!! over k-points
        CALL INTMAT(IPNT,IPAN)   !!! pseudopotential matrix elements
	CALL STRSUM(IPNT,IPAN)   !!! calculate lattice sums
	CALL STRGNT(IPNT,IPAN)   !!! restore bare structure matrices
        CALL STRALP(IPNT,IPAN)   !!! screen structure constants
        CALL SCRSTR(IPNT,IPAN)   !!! restore screened structure constants
	CALL LMTMAT(IPNT,IPAN)   !!! hamiltonian and overlap from MTS
        CALL ORBMAT(IPNT,IPAN)   !!! SO-coupling to the hamiltonian
        CALL GETHTB(IPNT,IPAN)   !!! get tight-binding parameters
	CALL LMTBND(IPNT,IPAN)   !!! solve eigenvalue problem
        CALL LMTVAR(IPNT,IPAN)   !!! calculate kj-contribution to Pulay force
 	CALL TOSPAR(IPNT,IPAN,0) !!! BZ-integrals from the occupied states
        CALL INTVAR(IPNT,IPAN)   !!! pseudopotential contribution to  pulay
        CALL TOSINT(IPNT,IPAN,0) !!! pseudodensity from the occupied states
        CALL PULINT(IPNT,IPAN,0) !!! Puley forces from the occupied states
	CALL FATBND(IPNT,IPAN)   !!! tl-characters of the bands
        ENDDO                    !!! over k-points
        CALL TOSEND(IPAN)        !!! make final pseudodensity
        CALL PULEND(IPAN)        !!! make final Puley force
	CLOSE(13,STATUS='DELETE')!!! close scratch file opened in NMTPAR
	CLOSE(18,STATUS='DELETE')!!! close scratch file opened in INTPAR
	CLOSE(19,STATUS='DELETE')!!! close scratch file opened in NULINT
	CLOSE(20,STATUS='DELETE')!!! close scratch file opened in NULINT
        ENDDO                    !!! over panels
	END
