	SUBROUTINE SENERGY(EXIT)
**********************************************************
*  Calculate total energy of a solid according to the    *
*  density functional theory.                            *
*  Written by S.Yu.Savrasov (Lebedev Physical Institute) *
**********************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
        COMPLEX*16 FPTN(3,NPAT,4),FCOU(3,NPAT,4),FEXC(3,NPAT,4)
     &    ,FHLF(3,NPAT,4)
	LOGICAL EXIT
        COMMON /FORCES/ FPTN,FCOU,FEXC,FHLF
	COMMON /ACCU/   EPS
	COMMON /UNIT/   IUN,IUT,IUR
	SAVE ETOT0
	DATA ETOT0/0.D0/
	CALL BANDENER(EBND)   !!! find band energy
	CALL COREENER(ECOR)   !!! find core energy
	CALL PTNLENER(EPTN)   !!! find potential energy
	CALL PTNFORCE(FPTN)   !!! find potential forces
	CALL HLFFORCE(FHLF)   !!! find Hellman-Feynman forces
	CALL COULENER(ECOU)   !!! find Coulomb energy
	CALL COUFORCE(FCOU)   !!! find Coulomb forces
	CALL EXCHENER(EXCH)   !!! find exchange-correlation energy
	CALL EXCFORCE(FEXC)   !!! find exchange-correlation forces
        CALL HUBRENER(EHUB)   !!! find Hubbard correction
	EKIN=EBND+ECOR-EPTN
	ETOT=EKIN+ECOU+EXCH+EHUB
	WRITE(IUN,1000)
	WRITE(IUN,1010)EBND
	WRITE(IUN,1020)ECOR
	WRITE(IUN,1030)EPTN
	WRITE(IUN,1040)EKIN
	WRITE(IUN,1050)ECOU
	WRITE(IUN,1060)EXCH
        WRITE(IUN,1065)EHUB
	WRITE(IUN,1070)ETOT
	IF(IUN.NE.IUT)
     &  WRITE(IUT,1070)ETOT
	WRITE(IUN,1000)
	IF(ABS(ETOT-ETOT0).LE.EPS)EXIT=.TRUE.
	IF(ABS(ETOT-ETOT0).GT.EPS)EXIT=.FALSE.
	ETOT0=ETOT
1000    FORMAT(1X,'***************************************************')
1010    FORMAT(1X,'*       BAND ENERGY     =',G20.14,'     *')
1020    FORMAT(1X,'*       CORE ENERGY     =',G20.14,'     *')
1030    FORMAT(1X,'*       POTENTIAL ENERGY=',G20.14,'     *')
1040    FORMAT(1X,'*       KINETIC ENERGY  =',G20.14,'     *')
1050    FORMAT(1X,'*       COULOMB ENERGY  =',G20.14,'     *')
1060    FORMAT(1X,'*       EXCH-CORR ENERGY=',G20.14,'     *')
1065    FORMAT(1X,'*       HUBBARD ENERGY  =',G20.14,'     *')
1070    FORMAT(1X,'*       TOTAL ENERGY    =',G20.14,'     *')
	END




	SUBROUTINE BANDENER(EBND)
*************************************************************
*  Calculate one-electron contribution to the total energy  *
*************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER ILST(NSORTMAX),ILSB(NSORTMAX),ILSV(NSORTMAX)
     &    ,IS(NPAT),NHSORT(NSORTMAX),NKAP(NPANMAX)
     &    ,NODES(0:LMAXT,NSORTMAX,NKAPMAX,NPANMAX)
     &    ,MNY  (0:LMAXT,NSORTMAX,NKAPMAX,NPANMAX)
     &    ,LNY  (0:LMAXT,NSORTMAX,NKAPMAX,NPANMAX)
     &    ,NCLS (0:LMAXT,NSORTMAX,NPANMAX)
	DIMENSION TOS(NPANMAX,0:1,NSPINMAX) 
     &    ,DHLOG(0:LMAXB,NSORTMAX,NKAPMAX,NPANMAX,NSPINMAX)
     &    ,DNY(0:LMAXT,NSORTMAX,NKAPMAX,NPANMAX,NSPINMAX)
     &    ,ENY(0:LMAXT,NSORTMAX,NKAPMAX,NPANMAX,NSPINMAX)
     &    ,TNY(0:LMAXT,NSORTMAX,NKAPMAX,NPANMAX,NSPINMAX)
	COMPLEX*16 EK(NKAPMAX,NPANMAX),EKAP(NKAPMAX,NPANMAX)
     &    ,ATOS(0:LMAXT,NSORTMAX,NKAPMAX,NKAPMAX,NPANMAX,NSPINMAX,0:5)
     &    ,ADOS(0:LMAXT,NSORTMAX,NKAPMAX,NKAPMAX,NPANMAX,NSPINMAX)
     &    ,PTOS(0:LMAXT,NSORTMAX,NKAPMAX,NPANMAX,NSPINMAX,0:2)
     &    ,PFOS(0:LMAXT,NSORTMAX,NKAPMAX,NPANMAX,NSPINMAX,0:2)
     &    ,PDOS(0:LMAXT,NSORTMAX,NKAPMAX,NPANMAX,NSPINMAX,0:2)
        CHARACTER TXTNY(0:3)*6,TL(0:3)*1,TN(9)*1,TXTSP(2)*2
     &    ,TXTEL(NSORTMAX)*10
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM,NHSORT !!! from init
	COMMON /TOSDOS/ ATOS,ADOS,PTOS,PFOS,PDOS             !!! from ttrint
        COMMON /INPPAR/ TNY,ENY,DNY,NODES,MNY,DHLOG,NCLS,LNY !!! from seteny
	COMMON /SPIN/   NSPIN                                !!! from init
	COMMON /EFERMI/ EF                                   !!! from sefermi
	COMMON /KAPPAR/ NPAN,NKAP,EK,EKAP                    !!! from init
	COMMON /UNIT/   IUN                                  !!! from init
	COMMON /TXTEL/  TXTEL,TXTSP                          !!! from init
        DATA PI/3.141592653589793D0/,TL/'s','p','d','f'/,TN/'1','2'
     &      ,'3','4','5','6','7','8','9'/,TXTNY/'fix.E '
     &      ,'fix.D ','bind.E','center'/
	DO IPAN=1,NPAN                          !!! over panels
	DO ISORT=1,NSORT                        !!! over sorts
	DO L=0,ILST(ISORT)                      !!! over l
C  SET PARTIAL NUMBERS OF STATES
	DO ISPIN=1,NSPIN                        !!! over spins
	DO ICLS=1,NCLS(L,ISORT,IPAN)            !!! over l-classes
	PTOS(L,ISORT,ICLS,IPAN,ISPIN,0)=0.D0
	PFOS(L,ISORT,ICLS,IPAN,ISPIN,0)=0.D0
	PDOS(L,ISORT,ICLS,IPAN,ISPIN,0)=0.D0
	PTOS(L,ISORT,ICLS,IPAN,ISPIN,1)=0.D0
	PFOS(L,ISORT,ICLS,IPAN,ISPIN,1)=0.D0
	PDOS(L,ISORT,ICLS,IPAN,ISPIN,1)=0.D0
	PTOS(L,ISORT,ICLS,IPAN,ISPIN,2)=0.D0
	PFOS(L,ISORT,ICLS,IPAN,ISPIN,2)=0.D0
	PDOS(L,ISORT,ICLS,IPAN,ISPIN,2)=0.D0
	DO IKAP1=1,NKAP(IPAN)
	DO IKAP=1,NKAP(IPAN)
C  TOTAL 
	PTOS(L,ISORT,ICLS,IPAN,ISPIN,0)=
     &  PTOS(L,ISORT,ICLS,IPAN,ISPIN,0)+
     &  ATOS(L,ISORT,IKAP1,IKAP,IPAN,ISPIN,0)
	PFOS(L,ISORT,ICLS,IPAN,ISPIN,0)=
     &  PFOS(L,ISORT,ICLS,IPAN,ISPIN,0)+
     &  ATOS(L,ISORT,IKAP1,IKAP,IPAN,ISPIN,1)
	PDOS(L,ISORT,ICLS,IPAN,ISPIN,0)=
     &  PDOS(L,ISORT,ICLS,IPAN,ISPIN,0)+
     &  ADOS(L,ISORT,IKAP1,IKAP,IPAN,ISPIN)
C  DIAGONAL
	IF(LNY(L,ISORT,IKAP1,IPAN).EQ.ICLS.
     &  AND.LNY(L,ISORT,IKAP,IPAN).EQ.ICLS)THEN
	PTOS(L,ISORT,ICLS,IPAN,ISPIN,1)=
     &  PTOS(L,ISORT,ICLS,IPAN,ISPIN,1)+
     &  ATOS(L,ISORT,IKAP1,IKAP,IPAN,ISPIN,0)
	PFOS(L,ISORT,ICLS,IPAN,ISPIN,1)=
     &  PFOS(L,ISORT,ICLS,IPAN,ISPIN,1)+
     &  ATOS(L,ISORT,IKAP1,IKAP,IPAN,ISPIN,1)
	PDOS(L,ISORT,ICLS,IPAN,ISPIN,1)=
     &  PDOS(L,ISORT,ICLS,IPAN,ISPIN,1)+
     &  ADOS(L,ISORT,IKAP1,IKAP,IPAN,ISPIN)
C  CROSS
	ELSEIF((LNY(L,ISORT,IKAP1,IPAN).EQ.ICLS.
     &  AND.LNY(L,ISORT,IKAP,IPAN).NE.ICLS).OR.
     &	       (LNY(L,ISORT,IKAP1,IPAN).NE.ICLS.
     &  AND.LNY(L,ISORT,IKAP,IPAN).EQ.ICLS))THEN
	PTOS(L,ISORT,ICLS,IPAN,ISPIN,2)=
     &  PTOS(L,ISORT,ICLS,IPAN,ISPIN,2)+
     &  ATOS(L,ISORT,IKAP1,IKAP,IPAN,ISPIN,0)
	PFOS(L,ISORT,ICLS,IPAN,ISPIN,2)=
     &  PFOS(L,ISORT,ICLS,IPAN,ISPIN,2)+
     &  ATOS(L,ISORT,IKAP1,IKAP,IPAN,ISPIN,1)
	PDOS(L,ISORT,ICLS,IPAN,ISPIN,2)=
     &  PDOS(L,ISORT,ICLS,IPAN,ISPIN,2)+
     &  ADOS(L,ISORT,IKAP1,IKAP,IPAN,ISPIN)
	ENDIF
	ENDDO
	ENDDO
	ENDDO                                  !!! over l-classes
	ENDDO                                  !!! over spins
	ENDDO                                  !!! over l
	ENDDO                                  !!! over isort
	ENDDO                                  !!! over ipan
C  PRINT PARTIAL NUMBERS OF STATES
	EBND=0.D0
	CALL TTRINT3(EF,TOS,DOS) !!! get partial numbers of valence states
	DO IPAN=1,NPAN                         !!! over panels
	EBND=EBND+(TOS(IPAN,1,1)+TOS(IPAN,1,NSPIN))/2.D0*DFLOAT(NSPIN)
	EAVR=(TOS(IPAN,1,1)+TOS(IPAN,1,NSPIN))/
     &       (TOS(IPAN,0,1)+TOS(IPAN,0,NSPIN))
	WRITE(IUN,1010)IPAN,EAVR
	DO ISORT=1,NSORT                       !!! over sorts
        WRITE(IUN,1020)TXTEL(ISORT)
        WRITE(IUN,1030)(DREAL(PTOS(L,ISORT,1,IPAN,1,0)+
     &  PTOS(L,ISORT,1,IPAN,NSPIN,0))/2.D0*NSPIN,
     &  L=0,MIN(ILST(ISORT),3))
        IF(NSPIN.EQ.2)
     &  WRITE(IUN,1040)(DREAL(PTOS(L,ISORT,1,IPAN,1,0)-
     &  PTOS(L,ISORT,1,IPAN,NSPIN,0)),
     &  L=0,MIN(ILST(ISORT),3))
        IF(IPAN.EQ.1.AND.NSPIN.EQ.1)
     &  WRITE(IUN,1050)(DREAL(PDOS(L,ISORT,1,IPAN,1,0)),
     &  L=0,MIN(ILST(ISORT),3))
        DO ISPIN=1,NSPIN
        IF(IPAN.EQ.1.AND.NSPIN.EQ.2)
     &  WRITE(IUN,1060)TXTSP(ISPIN),(DREAL(
     &  PTOS(L,ISORT,1,IPAN,ISPIN,0)),L=0,MIN(ILST(ISORT),3))
        ENDDO
        DO ISPIN=1,NSPIN
        IF(IPAN.EQ.1.AND.NSPIN.EQ.2)
     &  WRITE(IUN,1070)TXTSP(ISPIN),(DREAL(
     &  PDOS(L,ISORT,1,IPAN,ISPIN,0)),L=0,MIN(ILST(ISORT),3))
        ENDDO
        ENDDO                                 !!! over sorts
        ENDDO                                 !!! over panels
1010    FORMAT(1X,'Occupation numbers for the ',I2,'th panel; <E>=',
     &  G14.7,'---->')
1020    FORMAT(1X,'Summed over tail energies partial states ',A10)
1030    FORMAT(1X,'spdf... TOS ='    ,20(1X,G11.4))
1040    FORMAT(1X,'spdf... MAG ='    ,20(1X,G11.4))
1050    FORMAT(1X,'spdf... DOS ='    ,20(1X,G11.4))
1060    FORMAT(1X,'spdf ',A2,'-TOS =',20(1X,G11.4))
1070    FORMAT(1X,'spdf ',A2,'-DOS =',20(1X,G11.4))
C  PRINT CONTRIBUTIONS FROM DIFFERENT KAPPA'S
	IPAN=1
	WRITE(IUN,1110)
	DO ISORT=1,NSORT                          !!! over sorts
	DO ISPIN=1,NSPIN                          !!! over spins
	IF(NSPIN.EQ.1)WRITE(IUN,1120)TXTEL(ISORT)
	IF(NSPIN.EQ.2)WRITE(IUN,1130)TXTSP(ISPIN),TXTEL(ISORT)
	WRITE(IUN,1140)
	DO L=0,ILSB(ISORT)                        !!! over l
	DO ICLS=1,NCLS(L,ISORT,IPAN)              !!! over l-classes
	JKAP=0
	DO IKAP=1,NKAP(IPAN)
	IF(LNY(L,ISORT,IKAP,IPAN).EQ.ICLS)THEN
        MN=MNY(L,ISORT,IKAP,IPAN)
        NO=TNY(L,ISORT,IKAP,IPAN,1)+L+1
	JKAP=IKAP
	ENDIF
	ENDDO
	IF(JKAP.EQ.0)PRINT*,'<BANDENER>:: ERROR IN BASIS DEFINITION'
	WRITE(IUN,1150)TN(NO)//TL(L),TXTNY(MN),
     &  ENY(L,ISORT,JKAP,IPAN,ISPIN),
     &  DREAL(PTOS(L,ISORT,ICLS,IPAN,ISPIN,1)),
     &  DREAL(PTOS(L,ISORT,ICLS,IPAN,ISPIN,2))
	ENDDO                                     !!! over l-classes
	ENDDO                                     !!! over l
	ENDDO                                     !!! over spins
	ENDDO                                     !!! over sorts
1110	FORMAT(1X,'Different contributions for the orbitals ',
     &  'with many kappas --->')
1120	FORMAT(1X,'Diagonal/cross partial occupations ',A10)
1130	FORMAT(1X,'Diagonal/cross spin-',A2,' occupations ',A10)
1140	FORMAT(1X,'State  Eny',8X,'Value(Ry)',7X,'DTOS',13X,'CTOS :')
1150	FORMAT(2X,A2,3X,A6,3X,G12.5,3X,G14.7,1X,G14.7)
	END





	SUBROUTINE COREENER(ECOR)
*************************************************************
*  Calculate one-electron contribution to the total energy  *
*************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER ILST(NSORTMAX),ILSB(NSORTMAX),ILSV(NSORTMAX)
     &   ,IS(NPAT),NHSORT(NSORTMAX),ICOR(NSORTMAX)
     &   ,NLEVC(NSORTMAX),NLEVT(NSORTMAX)
	DIMENSION ELEV(36,NSORTMAX),ZLEV(36,NSORTMAX)
	CHARACTER*10 TXTEL(NSORTMAX)
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM,NHSORT !!! from init
	COMMON /COR1/   ICOR,NLEVC,NLEVT,ELEV,ZLEV           !!! from init
	COMMON /VZERO/  VMT0                                 !!! from vzero
	COMMON /SPIN/   NSPIN                                !!! from init
	COMMON /UNIT/   IUN                                  !!! from init
	COMMON /TXTEL/  TXTEL                                !!! from init
	DATA PI/3.141592653589793D0/
C  CALCULATE ONE-ELECTRON CORE CONTRIBUTION
	ECOR=0.D0
	DO 20 ISORT=1,NSORT
	DO 10 ILEV=1,NLEVC(ISORT)
	ECOR=ECOR+ELEV(ILEV,ISORT)*NHSORT(ISORT)*ZLEV(ILEV,ISORT)
  10    CONTINUE
  20    CONTINUE
	END


	SUBROUTINE PTNLENER(EPTN)
*****************************************************************
*  Calculate potential energy contribution to the total energy  *
*****************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER ILST(NSORTMAX),ILSB(NSORTMAX),ILSV(NSORTMAX)
     &    ,IS(NPAT),NHSORT(NSORTMAX),LMSYM(LMMAXV,NPAT)
     &    ,NRAD(NSORTMAX)
	COMPLEX*16 V(0:NRADMAX,NSYMMAX,NPAT,NSPINMAX)
     &    ,RHOPS(0:NPLWMAX,NSPINMAX),VPS(0:NPLWMAX,NSPINMAX)
     &    ,RO(0:NRADMAX,NSYMMAX,NPAT,NSPINMAX)
     &    ,ROVALDS(3,NSYMMAX,NPAT,NSPINMAX)
     &    ,WORK2(0:NRADMAX),WORK1(0:NRADMAX)
     &    ,VPSINT(0:NPLWMAX,NSPINMAX)
	DIMENSION H(NSORTMAX),R(0:NRADMAX,NSORTMAX),ORTH(2:3)
     &    ,WEIGHT(0:NRADMAX,NSORTMAX),DR(0:NRADMAX,NSORTMAX)
     &    ,SMT(NSORTMAX),RL(0:NRADMAX,0:LMAXV,NSORTMAX)
     &    ,VMT(NSORTMAX,NSPINMAX),VSF(NSORTMAX,NSPINMAX)
     &    ,VSPH(0:NRADMAX,NSORTMAX,NSPINMAX),GPLW(3,0:NPLWMAX)
     &    ,ROCOR(0:NRADMAX,NSORTMAX,NSPINMAX)
	REAL*8  WORK3(0:NRADMAX),WORK4(0:NRADMAX),TR1,TR2
	LOGICAL SYM(LMMAXV,NPAT)
	CHARACTER TXTEL(NSORTMAX)*10
	COMMON /CONTROL/MAN,LMTO,NLR,NOVR,NPF               !!! from init
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM,NHSORT!!! from init
	COMMON /POTCOM/ SWZ,SMT,VSPH,V                      !!! from vfull
	COMMON /PSVCOM/ VPS,VPSINT                          !!! from vfull
	COMMON /DENS/   RO,ROVALDS,ROCOR                    !!! from rofull
	COMMON /PSRHO/  RHOPS                               !!! from ttrint2
	COMMON /VZERO/  VMT0,VMT,VSF0,VSF                   !!! from vzero
	COMMON /SYMMLM/ SYM,LMSYM                           !!! from symmlm
	COMMON /RADMESH/NRAD,H,R,DR,WEIGHT,RL               !!! from init
	COMMON /PLWMESH/NPLW,GPLW                           !!! from init
	COMMON /SPIN/   NSPIN                               !!! from init
	COMMON /LATPAR/ PAR,ORTH,OMEGAC                     !!! from init
	COMMON /UNIT/   IUN                                 !!! from init
	COMMON /TXTEL/  TXTEL                               !!! from init
	DATA PI/3.141592653589793D0/
	SQPI4=2.D0*SQRT(PI)
C   CALCULATE MUFFIN-TIN CONTRIBUTION TO THE POTENTIAL ENERGY
	EPTNMT=0.D0
	DO 140 IATOM=1,NATOM                                !!! over atoms
	ISORT=IS(IATOM)
	DO 130 ISPIN=1,NSPIN                                !!! over spins
	DO 120 L=0,ILSV(ISORT)                              !!! over l
	DO 110 M=-L,L                                       !!! over m
	LM=L*(L+1)+M+1
	IF(SYM(LM,IATOM))THEN
	ISYM=LMSYM(LM,IATOM)
	DO 20 IRAD=0,NRAD(ISORT)                            !!! over irad
	WORK1(IRAD)=CONJG(RO(IRAD,ISYM,IATOM,ISPIN))*
     &  V(IRAD,ISYM,IATOM,ISPIN)*DR(IRAD,ISORT)*R(IRAD,ISORT)**2
  20    CONTINUE                                            !!! over irad
	CALL CQD(H(ISORT),WORK1,WORK2,NRAD(ISORT)+1)
	EPTNMT=EPTNMT+WORK2(NRAD(ISORT))
	ENDIF
 110    CONTINUE                                            !!! over m
 120    CONTINUE                                            !!! over l
 130    CONTINUE                                            !!! over ispin
 140    CONTINUE                                            !!! over iatom
C  CALCULATE PSEUDOPOTENTIAL CONTRIBUTION FROM INT.REGION
	EPTNINT=0.D0
	DO 220 ISPIN=1,NSPIN                                !!! over spins
	DO 210 IPLW=0,NPLW                                  !!! over plane waves
	EPTNINT=EPTNINT+VPSINT(IPLW,ISPIN)*DCONJG(RHOPS(IPLW,ISPIN))
 210    CONTINUE                                            !!! over spins
 220    CONTINUE                                            !!! over plane waves
	EPTN=EPTNMT+EPTNINT
	WRITE(IUN,1010)EPTNMT,EPTNINT
1010    FORMAT(1X,'E{ptn} : MT,INT-parts are',2(1X,G14.7))
	END




	SUBROUTINE COULENER(ECOU)
**************************************************************
*  Calculate electrostatic contribution to the total energy  *
**************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER ILST(NSORTMAX),ILSB(NSORTMAX),ILSV(NSORTMAX)
     &   ,IS(NPAT),NHSORT(NSORTMAX),LMSYM(LMMAXV,NPAT),NRAD(NSORTMAX)
	COMPLEX*16 V(0:NRADMAX,NSYMMAX,NPAT,NSPINMAX)
     &   ,RHOPS(0:NPLWMAX,NSPINMAX),VPS(0:NPLWMAX,NSPINMAX)
     &   ,RO(0:NRADMAX,NSYMMAX,NPAT,NSPINMAX)
     &   ,ROVALDS(3,NSYMMAX,NPAT,NSPINMAX)
     &   ,WORK1(0:NRADMAX),WORK2(0:NRADMAX)
     &   ,VPSINT(0:NPLWMAX,NSPINMAX)
     &   ,RHOPS1(0:NPLWMAX,NSPINMAX)
	DIMENSION H(NSORTMAX),R(0:NRADMAX,NSORTMAX),ORTH(2:3)
     &   ,WEIGHT(0:NRADMAX,NSORTMAX),DR(0:NRADMAX,NSORTMAX)
     &   ,SMT(NSORTMAX),RL(0:NRADMAX,0:LMAXV,NSORTMAX)
     &   ,VSPH(0:NRADMAX,NSORTMAX,NSPINMAX),GPLW(3,0:NPLWMAX)
     &   ,ROCOR(0:NRADMAX,NSORTMAX,NSPINMAX)
     &   ,Z(NSORTMAX),ZCOR(NSORTMAX)
	REAL*8 WORK3(0:NRADMAX),WORK4(0:NRADMAX),TR1,TR2
	LOGICAL SYM(LMMAXV,NPAT)
	CHARACTER TXTEL(NSORTMAX)*10
	COMMON /CONTROL/MAN,LMTO,NLR,NOVR,NPF               !!! from init
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM,NHSORT!!! from init
	COMMON /POTCOM/ SWZ,SMT,VSPH,V                      !!! from vfull
	COMMON /DENS/   RO,ROVALDS,ROCOR                    !!! from rofull
	COMMON /PSVCOM/ VPS,VPSINT                          !!! from vfull
	COMMON /PSRHO/  RHOPS,RHOPS1                        !!! from ttrint2
	COMMON /MULTRO/ Z,ZCOR                              !!! from init
	COMMON /SYMMLM/ SYM,LMSYM                           !!! from symmlm
	COMMON /RADMESH/NRAD,H,R,DR,WEIGHT,RL               !!! from init
	COMMON /PLWMESH/NPLW,GPLW                           !!! from init
	COMMON /LATPAR/ PAR,ORTH,OMEGAC                     !!! from init
	COMMON /SPIN/   NSPIN                               !!! from init
	COMMON /UNIT/   IUN                                 !!! from init
	COMMON /TXTEL/  TXTEL                               !!! from init
	DATA PI/3.141592653589793D0/
	SQPI4=2.D0*SQRT(PI)
C  SET UP FULL POTENTIAL TO ZERO, THEN CALCULATE COULOMB PART
	DO 60 IATOM=1,NATOM               !!! over atoms
	ISORT=IS(IATOM) 
	DO 50 ISPIN=1,NSPIN               !!! over spins
	DO 40 L=0,ILSV(ISORT)             !!! over l
	DO 30 M=-L,L                      !!! over m
	LM=L*(L+1)+M+1
	IF(SYM(LM,IATOM))THEN             !!! for non-zero components
	ISYM=LMSYM(LM,IATOM)
	DO 10 IRAD=0,NRAD(ISORT)          !!! over rad.points
	V(IRAD,ISYM,IATOM,ISPIN)=(0.D0,0.D0)
  10    CONTINUE                          !!! over rad.points
	ENDIF                             !!! for non-zero components
  30    CONTINUE                          !!! over m
  40    CONTINUE                          !!! over l
  50    CONTINUE                          !!! over spins
  60    CONTINUE                          !!! over atoms
	DO 80 ISPIN=1,NSPIN
	DO 70 IPLW=0,NPLW
	VPS(IPLW,ISPIN)=(0.D0,0.D0)
  70    CONTINUE
  80    CONTINUE
C  CALCULATE MULTIPOLE FIELD
        CALL MULTRHO           !!! calculate moments of (pseudo)density
        CALL MULTFTR           !!! multipoles as lattice sums
C  CALCULATE COULOMB POTENTIAL WITHOUT NUCLEAR PART
	CALL VCOUL             !!! calculate Coulomb potential whithin MTs
	CALL VCFTR             !!! calculate Coulomb potential in the int.reg.
	CALL VPINT             !!! set up convolutions
C   CALCULATE MT-CONTRIBUTION TO THE COULOMB ENERGY
	ECOUMT=0.D0
	DO 160 IATOM=1,NATOM                                 !!! over atoms
	ISORT=IS(IATOM)
	DO 150 L=0,ILSV(ISORT)                               !!! over l
	DO 140 M=-L,L                                        !!! over m
	LM=L*(L+1)+M+1
	IF(SYM(LM,IATOM))THEN
	ISYM=LMSYM(LM,IATOM)
	IF(L.EQ.0)THEN
	DO 110 IRAD=0,NRAD(ISORT)                            !!! over irad
	TR1=0.5D0*DREAL(V(IRAD,1,IATOM,1)+V(IRAD,1,IATOM,NSPIN))/
     &  2.D0*R(IRAD,ISORT)**2*DR(IRAD,ISORT)
	TR2=DREAL(RO(IRAD,1,IATOM,1)+RO(IRAD,1,IATOM,NSPIN))/
     &  2.D0*DFLOAT(NSPIN)
	WORK3(IRAD)=TR1*TR2
 110    CONTINUE                                             !!! over irad
	CALL DQD(H(ISORT),WORK3,WORK4,NRAD(ISORT)+1)
	ECOUMT=ECOUMT+WORK4(NRAD(ISORT))
	DO 120 IRAD=0,NRAD(ISORT)                            !!! over irad
	TR1=-0.5D0*2.D0*Z(ISORT)*SQPI4*R(IRAD,ISORT)*DR(IRAD,ISORT)
	TR2=DREAL(RO(IRAD,1,IATOM,1)+RO(IRAD,1,IATOM,NSPIN))/
     &  2.D0*DFLOAT(NSPIN)
	WORK3(IRAD)=TR1*TR2
 120    CONTINUE                                             !!! over irad
	CALL DQD(H(ISORT),WORK3,WORK4,NRAD(ISORT)+1)
	ECOUMT=ECOUMT+WORK4(NRAD(ISORT))-0.5D0*Z(ISORT)*(
     &  V(0,1,IATOM,1)+V(0,1,IATOM,NSPIN))/2.D0/SQPI4
	ELSE
	DO 130 IRAD=0,NRAD(ISORT)                            !!! over irad
	WORK1(IRAD)=0.5D0*CONJG(RO(IRAD,ISYM,IATOM,1)+
     &  RO(IRAD,ISYM,IATOM,NSPIN))/2.D0*DFLOAT(NSPIN)*(
     &  V(IRAD,ISYM,IATOM,1)+V(IRAD,ISYM,IATOM,NSPIN))/
     &  2.D0*R(IRAD,ISORT)**2*DR(IRAD,ISORT)
 130    CONTINUE                                             !!! over irad
	CALL CQD(H(ISORT),WORK1,WORK2,NRAD(ISORT)+1)
	ECOUMT=ECOUMT+WORK2(NRAD(ISORT))
	ENDIF
	ENDIF
 140    CONTINUE                                             !!! over m
 150    CONTINUE                                             !!! over l
 160    CONTINUE                                             !!! over iatom
C  CALCULATE PSEUDOPOTENTIAL CONTRIBUTION FROM INT.REGION 
	ECOUINT=0.D0
	ECOUZER=0.D0
	DO 210 IPLW=0,NPLW                                   !!! over plane waves
	ECOUINT=ECOUINT+(VPSINT(IPLW,1)+VPSINT(IPLW,NSPIN))/2.D0*
     &  DCONJG(RHOPS(IPLW,1)+RHOPS(IPLW,NSPIN))/2.D0*DBLE(NSPIN)
	ECOUZER=ECOUZER+(VPSINT(IPLW,1)+VPSINT(IPLW,NSPIN))/2.D0*
     &  DCONJG(RHOPS1(IPLW,1)+RHOPS1(IPLW,NSPIN))/2.D0*DBLE(NSPIN)
 210    CONTINUE                                             !!! over spins
	ECOUINT=0.5D0*ECOUINT
	ECOUZER=0.5D0*ECOUZER
	ECOU=ECOUMT+ECOUINT
	WRITE(IUN,1010)ECOUMT,ECOUINT,ECOUZER
1010    FORMAT(1X,'E{cou} : M,I,Z0-parts are',3(1X,G14.7))
	END


	SUBROUTINE EXCHENER(EXCH)
*********************************************************
*  Calcculate exchange-correlation contribution to the  *
*  total energy.                                        *
*********************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER ILST(NSORTMAX),ILSB(NSORTMAX),ILSV(NSORTMAX)
     &   ,IS(NPAT),NHSORT(NSORTMAX),LMSYM(LMMAXV,NPAT)
     &   ,NRAD(NSORTMAX)
	COMPLEX*16 V(0:NRADMAX,NSYMMAX,NPAT,NSPINMAX)
     &   ,RHOPS(0:NPLWMAX,NSPINMAX),VPS(0:NPLWMAX,NSPINMAX)
     &   ,RO(0:NRADMAX,NSYMMAX,NPAT,NSPINMAX)
     &   ,WORK1(0:NRADMAX),WORK2(0:NRADMAX)
     &   ,ROVALDS(3,NSYMMAX,NPAT,NSPINMAX)
     &   ,VPSINT(0:NPLWMAX,NSPINMAX)
	DIMENSION H(NSORTMAX),R(0:NRADMAX,NSORTMAX),ORTH(2:3)
     &   ,WEIGHT(0:NRADMAX,NSORTMAX),DR(0:NRADMAX,NSORTMAX)
     &   ,SMT(NSORTMAX),RL(0:NRADMAX,0:LMAXV,NSORTMAX)
     &   ,VSPH(0:NRADMAX,NSORTMAX,NSPINMAX),GPLW(3,0:NPLWMAX)
     &   ,ROCOR(0:NRADMAX,NSORTMAX,NSPINMAX)
     &   ,Z(NSORTMAX),ZCOR(NSORTMAX)
	LOGICAL SYM(LMMAXV,NPAT)
	REAL*8 WORK3(0:NRADMAX),WORK4(0:NRADMAX),TR1,TR2
	CHARACTER TXTEL(NSORTMAX)*10
	COMMON /CONTROL/MAN,LMTO,NLR,NINT,NPF               !!! from init
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM,NHSORT!!! from init
	COMMON /POTCOM/ SWZ,SMT,VSPH,V                      !!! from vfull
	COMMON /PSVCOM/ VPS,VPSINT                          !!! from vfull
	COMMON /PSRHO/  RHOPS                               !!! from ttrint2
	COMMON /DENS/   RO,ROVALDS,ROCOR                    !!! from rofull
	COMMON /RADMESH/NRAD,H,R,DR,WEIGHT,RL               !!! from init
	COMMON /PLWMESH/NPLW,GPLW                           !!! from init
	COMMON /SYMMLM/ SYM,LMSYM                           !!! from symmlm
	COMMON /LATPAR/ PAR,ORTH,OMEGAC                     !!! from init
	COMMON /EXCH/   IXC                                 !!! from init
	COMMON /SPIN/   NSPIN                               !!! from init
	COMMON /UNIT/   IUN                                 !!! from init
	COMMON /TXTEL/  TXTEL                               !!! from init
	DATA PI/3.141592653589793D0/
	SQPI4=2.D0*SQRT(PI)
C  SET UP FULL POTENTIAL TO ZERO, THEN CALCULATE EXCHANGE-CORRELATION 
	DO 60 IATOM=1,NATOM               !!! over atoms
	ISORT=IS(IATOM) 
	DO 50 ISPIN=1,NSPIN               !!! over spins
	DO 40 L=0,ILSV(ISORT)             !!! over l
	DO 30 M=-L,L                      !!! over m
	LM=L*(L+1)+M+1
	IF(SYM(LM,IATOM))THEN             !!! for non-zero components
	ISYM=LMSYM(LM,IATOM)
	DO 10 IRAD=0,NRAD(ISORT)          !!! over rad.points
	V(IRAD,ISYM,IATOM,ISPIN)=(0.D0,0.D0)
  10    CONTINUE                          !!! over rad.points
	ENDIF                             !!! for non-zero components
  30    CONTINUE                          !!! over m
  40    CONTINUE                          !!! over l
  50    CONTINUE                          !!! over spins
  60    CONTINUE                          !!! over atoms
	DO 80 ISPIN=1,NSPIN
	DO 70 IPLW=0,NPLW
	VPS(IPLW,ISPIN)=(0.D0,0.D0)
  70    CONTINUE
  80    CONTINUE
C  CALCULATE DENSITY OF THE EXCHANGE-CORRELATION ENERGY
	CALL VEXCH(2)           !!! exchange-correlation within MTs
	CALL VXFTR(2)           !!! pseudopart by Fourier transform
	CALL VPINT              !!! set up convolutions
C   CALCULATE MT-CONTRIBUTION TO THE EXCHANGE-CORRELATION ENERGY
	EXCHMT=0.D0
	DO 170 ISPIN=1,NSPIN                                !!! over spins
	DO 160 IATOM=1,NATOM                                !!! over atoms
	ISORT=IS(IATOM)
	DO 150 L=0,ILSV(ISORT)                              !!! over l
	DO 140 M=-L,L                                       !!! over m
	LM=L*(L+1)+M+1
	IF(SYM(LM,IATOM))THEN
	ISYM=LMSYM(LM,IATOM)
	IF(L.EQ.0)THEN
	DO 110 IRAD=0,NRAD(ISORT)                           !!! over irad
	TR1=V(IRAD,1,IATOM,ISPIN)*R(IRAD,ISORT)**2*DR(IRAD,ISORT)
	TR2=DREAL(RO(IRAD,1,IATOM,ISPIN))
	WORK3(IRAD)=TR1*TR2
 110    CONTINUE                                            !!! over irad
	CALL DQD(H(ISORT),WORK3,WORK4,NRAD(ISORT)+1)
	EXCHMT=EXCHMT+WORK4(NRAD(ISORT))
	ELSE
	DO 120 IRAD=0,NRAD(ISORT)                           !!! over irad
	WORK1(IRAD)=CONJG(RO(IRAD,ISYM,IATOM,ISPIN))*
     &  V(IRAD,ISYM,IATOM,ISPIN)*R(IRAD,ISORT)**2*DR(IRAD,ISORT)
 120    CONTINUE                                            !!! over irad
	CALL CQD(H(ISORT),WORK1,WORK2,NRAD(ISORT)+1)
	EXCHMT=EXCHMT+WORK2(NRAD(ISORT))
	ENDIF
	ENDIF
 140    CONTINUE                                            !!! over m
 150    CONTINUE                                            !!! over l
 160    CONTINUE                                            !!! over iatom
 170    CONTINUE                                            !!! over ispin
C  CALCULATE PSEUDOPOTENTIAL CONTRIBUTION FROM INT.REGION 
	EXCHINT=0.D0
	DO 220 ISPIN=1,NSPIN                               !!! over spins
	DO 210 IPLW=0,NPLW                                 !!! over plane waves
	EXCHINT=EXCHINT+VPSINT(IPLW,ISPIN)*DCONJG(RHOPS(IPLW,ISPIN))
 210    CONTINUE                                           !!! over spins
 220    CONTINUE                                           !!! over plane waves
	EXCH=EXCHMT+EXCHINT
	WRITE(IUN,1010)EXCHMT,EXCHINT
1010    FORMAT(1X,'E{xc } : MT,INT-parts are',2(1X,G14.7))
	END
