	SUBROUTINE MIXROB(ITER,KEY)
**************************************************************
*  Mixes charge densities according to the Broyden           *
*  prescription.                                             *
*  Last modified 01.11.96.                                   *
**************************************************************
        IMPLICIT REAL*8 (A-H,O-Z)
        INCLUDE 'PARAM.DAT'
        INTEGER ILST(NSORTMAX),ILSB(NSORTMAX),ILSV(NSORTMAX)
     &   ,IS(NPAT),NHSORT(NSORTMAX),NKAP(NPANMAX),NRAD(NSORTMAX)
     &   ,LMSYM(LMMAXV,NPAT)
        DIMENSION H(NSORTMAX),R(0:NRADMAX,NSORTMAX),SMT(NSORTMAX)
     &   ,WEIGHT(0:NRADMAX,NSORTMAX),Z(NSORTMAX),ZCOR(NSORTMAX)
     &   ,RL(0:NRADMAX,0:LMAXV,NSORTMAX),DR(0:NRADMAX,NSORTMAX)
     &   ,WTER(0:NTERMAX),ROCOR(0:NRADMAX,NSORTMAX,NSPINMAX)
     &   ,QCH(NPAT,NSPINMAX),GPLW(3,0:NPLWMAX),WRAD(NLENMAX)
        COMPLEX*16 RO(0:NRADMAX,NSYMMAX,NPAT,NSPINMAX)
     &	 ,RHOPS(0:NPLWMAX,NSPINMAX),WRK1(NLENMAX),WRK2(NLENMAX)
     &   ,WORK1(0:NRADMAX),WORK2(0:NRADMAX),WMIX(NTERMAX,NTERMAX)
     &   ,ROVALDS(3,NSYMMAX,NPAT,NSPINMAX),WINP(NTERMAX)
     &	 ,XRHO(NLENMAX),XNEW(NLENMAX)
        CHARACTER*10 TXTEL(NSORTMAX),TXTSP(2)*2,SCRFILE(100)*60
        LOGICAL SYM(LMMAXV,NPAT),FIRST,RESET
        COMMON /CONTROL/LIFT,LMTO,NCOU,NINT,NPF              !!! from init
        COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM,NHSORT !!! from init
        COMMON /POTCOM/ SWZ,SMT                              !!! from init
        COMMON /DENS/   RO,ROVALDS,ROCOR                     !!! from rofull
        COMMON /PSRHO/  RHOPS                                !!! from ttrint2
        COMMON /RADMESH/NRAD,H,R,DR,WEIGHT,RL                !!! from radmsh
	COMMON /MIXBROY/LBROY,IBROY,ADMIXB,ADMIXH,MTER,WINP,WMIX!from init
	COMMON /STORE1/ XRHO,XNEW,WRAD,WRK1,WRK2             !!! tmp.storage
        COMMON /PLWMESH/NPLW,GPLW                            !!! from plwmsh
        COMMON /MULTRO/ Z,ZCOR                               !!! from init
        COMMON /SYMMLM/ SYM,LMSYM                            !!! from symlm
        COMMON /OUT0/   SCRFILE                              !!! from init
        COMMON /SPIN/   NSPIN                                !!! from init
        COMMON /UNIT/   IUN                                  !!! from init
        COMMON /TXTEL/  TXTEL,TXTSP                          !!! from init
	SAVE LBROY0,FIRST,RESET,WTER
        DATA PI/3.141592653589793D0/,FIRST/.TRUE./
C  SAVE SWITCH
        IF(FIRST)THEN
        LBROY0=LBROY
        MTER=0
        RESET=.TRUE.
        ENDIF
        FIRST=.FALSE.
C  DO NOT START BROYDEN, WAIT
	IF(ITER.LE.IBROY)THEN
	LBROY=-1
C  SWITCH ON NOW
	ELSEIF(ITER.GT.IBROY)THEN
	LBROY=LBROY0
	ENDIF
	IF(LBROY.LT.0)RETURN
C  SET ITERATION NUMBER
	IF(MTER.EQ.NTERMAX-1)RESET=.TRUE.
	IF(MTER.EQ.NTERMAX-1)
     &  PRINT*,'<MIXROB>:: MTER>NTERMAX, BROYDEN RESTARTED'
	IF(RESET)MTER=0
	IF(KEY.EQ.1.AND.MTER.NE.0)RETURN
	IF(KEY.EQ.2)MTER=MTER+1
C  *** SET MIXING ARRAY ***
C  MT-PART
	IDIM=0
	DO IATOM=1,NATOM                    !!! over atoms
	ISORT=IS(IATOM)
        DO L=0,ILSV(ISORT)                  !!! over l
        DO M=-L,L                           !!! over m
        LM=L*(L+1)+M+1
        ISYM=LMSYM(LM,IATOM)
        SL=SMT(ISORT)**L
        IF(SYM(LM,IATOM).AND.L.LE.LBROY)THEN!!! for only non-zero components
C  1) Pack Valence Charge Density into Array
	DO IRAD=0,NRAD(ISORT)
	IDIM=IDIM+1
	IF(ISYM.EQ.1)
     &	XRHO(IDIM)=0.5D0*DBLE(NSPIN)*CMPLX(DREAL(
     & 	RO(IRAD,ISYM,IATOM,1)+RO(IRAD,ISYM,IATOM,NSPIN)),0.D0)
	IF(ISYM.GT.1)
     &	XRHO(IDIM)=0.5D0*DBLE(NSPIN)*(
     & 	RO(IRAD,ISYM,IATOM,1)+RO(IRAD,ISYM,IATOM,NSPIN))
	WRAD(IDIM)=1.D0
	ENDDO
C  2) Pack Magnetization into Array
	IF(NSPIN.EQ.2)THEN
	DO IRAD=0,NRAD(ISORT)
	IDIM=IDIM+1
	IF(ISYM.EQ.1)
     &	XRHO(IDIM)=CMPLX(DREAL(RO(IRAD,ISYM,IATOM,1)-
     &  RO(IRAD,ISYM,IATOM,NSPIN)),0.D0)
	IF(ISYM.GT.1)
     &	XRHO(IDIM)=RO(IRAD,ISYM,IATOM,1)-RO(IRAD,ISYM,IATOM,NSPIN)
	WRAD(IDIM)=1.D0
	ENDDO
	ENDIF
	ENDIF                               !!! for only non-zero components
	ENDDO                               !!! over m
	ENDDO                               !!! over l
	ENDDO                               !!! over atoms
C  *** SET MIXING ARRAY ***
C  PLW-PART
C  1) Pack Density into Array
	DO IPLW=0,NPLW                      !!! over plane waves
	IDIM=IDIM+1
      	XRHO(IDIM)=0.5D0*DBLE(NSPIN)*(
     & 	RHOPS(IPLW,1)+RHOPS(IPLW,NSPIN))
	WRAD(IDIM)=1.D0
	ENDDO                               !!! over plane waves
C  2) Pack Magnetization into Array
	IF(NSPIN.EQ.2)THEN
	DO IPLW=0,NPLW                      !!! over plane waves
	IDIM=IDIM+1
      	XRHO(IDIM)=RHOPS(IPLW,1)-RHOPS(IPLW,NSPIN)
	WRAD(IDIM)=1.D0
	ENDDO                               !!! over plane waves
	ENDIF
	NDIM=IDIM
	IF(NDIM.GT.NLENMAX)
     &  STOP'NLENMAX MUST BE INCREASED IN PARAM.DAT'
C  SEND ARRAY TO BROYDEN
        CALL BROY4N(XRHO,XNEW,WRAD,WRK1,WRK2,NDIM,MTER
     &             ,ADMIXB,WTER,WINP,WMIX,23,SCRFILE(23))      
	IF(MTER.EQ.0)RESET=.FALSE.
	IF(MTER.EQ.0)RETURN
C  *** DEFINE NEW CHARGE DENSITY ***
C  MT-PART
	IDIM=0
	NEGD=0
	DO IATOM=1,NATOM                    !!! over atoms
	ISORT=IS(IATOM)
        DO L=0,ILSV(ISORT)                  !!! over l
        DO M=-L,L                           !!! over m
        LM=L*(L+1)+M+1
        ISYM=LMSYM(LM,IATOM)
        SL=SMT(ISORT)**L
        IF(SYM(LM,IATOM).AND.L.LE.LBROY)THEN!!! for only non-zero components
C  Repack Spin Densities
	DO IRAD=0,NRAD(ISORT) 
	IDIM=IDIM+1
	IF(ISYM.EQ.1)THEN
	RO(IRAD,ISYM,IATOM,1)=
     &  CMPLX(DREAL(XNEW(IDIM)/DBLE(NSPIN)),0.D0)
	RO(IRAD,ISYM,IATOM,NSPIN)=
     &  CMPLX(DREAL(XNEW(IDIM)/DBLE(NSPIN)),0.D0)
	ELSE
	RO(IRAD,ISYM,IATOM,1)=XNEW(IDIM)/DBLE(NSPIN)
	RO(IRAD,ISYM,IATOM,NSPIN)=XNEW(IDIM)/DBLE(NSPIN)
	ENDIF
	ENDDO
	IF(NSPIN.EQ.2)THEN
	DO IRAD=0,NRAD(ISORT)
	IDIM=IDIM+1
	IF(ISYM.EQ.1)THEN
	RO(IRAD,ISYM,IATOM,1)=RO(IRAD,ISYM,IATOM,1)+
     &  CMPLX(DREAL(XNEW(IDIM)/DBLE(NSPIN)),0.D0)
	RO(IRAD,ISYM,IATOM,NSPIN)=RO(IRAD,ISYM,IATOM,NSPIN)-
     &  CMPLX(DREAL(XNEW(IDIM)/DBLE(NSPIN)),0.D0)
	ELSE
	RO(IRAD,ISYM,IATOM,1)=RO(IRAD,ISYM,IATOM,1)+
     &  XNEW(IDIM)/DBLE(NSPIN)
	RO(IRAD,ISYM,IATOM,NSPIN)=RO(IRAD,ISYM,IATOM,NSPIN)-
     &  XNEW(IDIM)/DBLE(NSPIN)
	ENDIF
	ENDDO
	ENDIF
	ENDIF                               !!! for only non-zero components
	ENDDO                               !!! over m
	ENDDO                               !!! over l
C  Check out for positive definiteness
	DO ISPIN=1,NSPIN
	DO IRAD=0,NRAD(ISORT)
	IF(DREAL(RO(IRAD,1,IATOM,ISPIN)).LE.0.D0)NEGD=1
	ENDDO
	ENDDO
	ENDDO                               !!! over atoms
C  *** DEFINE NEW CHARGE DENSITY ***
C  PLW-PART
	DO IPLW=0,NPLW                      !!! over plane waves
	IDIM=IDIM+1
	RHOPS(IPLW,1)=XNEW(IDIM)/DBLE(NSPIN)
	RHOPS(IPLW,NSPIN)=XNEW(IDIM)/DBLE(NSPIN)
	ENDDO                               !!! over plane waves
	IF(NSPIN.EQ.2)THEN
	DO IPLW=0,NPLW                      !!! over plane waves
	IDIM=IDIM+1
	RHOPS(IPLW,1)=RHOPS(IPLW,1)+XNEW(IDIM)/DBLE(NSPIN)
	RHOPS(IPLW,NSPIN)=RHOPS(IPLW,NSPIN)-XNEW(IDIM)/
     &  DBLE(NSPIN)
	ENDDO                               !!! over plane waves
	ENDIF
C  Switch off mixing ??? Then we have to reset RHO to XRHO
	IF(NEGD.EQ.1)
     &  WRITE(IUN,*)'<MIXROB>::CHARGE DENSITY IS NOT POSITIVE'
C	IF(NEGD.EQ.1)LBROY =-1
C	IF(NEGD.EQ.1)LBROY0=-1
C	IF(NEGD.EQ.1)PRINT*,'<MIXBRO>: BROYDEN  MIXING IS OFF' 
C  CHECK OUT ELECTRONEUTRALITY
	ZTOT=0.D0
	TOTM=0.D0
	IRES=0
        DO IATOM=1,NATOM                    !!! over atoms
        ISORT=IS(IATOM)
        DO ISPIN=1,NSPIN                    !!! over spins
        DO IRAD=0,NRAD(ISORT)
        WORK1(IRAD)=RO(IRAD,1,IATOM,ISPIN)*
     &  WEIGHT(IRAD,ISORT)/SQRT(4.D0*PI)
	ENDDO
        CALL CQD(H(ISORT),WORK1,WORK2,NRAD(ISORT)+1)
        QCH(IATOM,ISPIN)=DREAL(WORK2(NRAD(ISORT)))
	QIM=DIMAG(WORK2(NRAD(ISORT)))
        IF(ABS(QIM).GE.1.D-10)THEN
	IRES=1
	PRINT*,'<MIXBRO>: IMAGINARY PART IS NOT ZERO',QIM
        ENDIF
        QCH(IATOM,ISPIN)=QCH(IATOM,ISPIN)-Z(ISORT)/DFLOAT(NSPIN)
	ZTOT=ZTOT+QCH(IATOM,ISPIN)
	TOTM=TOTM-QCH(IATOM,ISPIN)*(-1)**ISPIN
	ENDDO                               !!! over spins
	ENDDO                               !!! over atoms
C  Restart mixing
	IF(IRES.EQ.0)RESET=.FALSE.
 	IF(IRES.EQ.1)RESET=.TRUE.
	IF(IRES.EQ.1)PRINT*,'<MIXBRO>: BROYDEN  MIXING  RESTARTED' 
C  Switch off mixing ???
C	IF(IRES.EQ.1)LBROY =-1
C	IF(IRES.EQ.1)LBROY0=-1
C	IF(IRES.EQ.1)PRINT*,'<MIXBRO>: BROYDEN  MIXING  IS OFF' 
C  PRINT BLOCK
	WRITE(IUN,1010)WTER(MTER)
	IF(NSPIN.EQ.1)WRITE(IUN,1020)
	IF(NSPIN.EQ.2)WRITE(IUN,1030)
        DO IATOM=1,NATOM                    !!! over atoms
        ISORT=IS(IATOM)
	IF(NSPIN.EQ.1)
     &	WRITE(IUN,1040)0.5D0*DBLE(NSPIN)*(QCH(IATOM,1)+
     &  QCH(IATOM,NSPIN)),TXTEL(ISORT)
	IF(NSPIN.EQ.2)
     &	WRITE(IUN,1050)0.5D0*DBLE(NSPIN)*(QCH(IATOM,1)+
     &  QCH(IATOM,NSPIN)),QCH(IATOM,1)-QCH(IATOM,NSPIN),
     &  TXTEL(ISORT)
	ENDDO                               !!! over atoms
	WRITE(IUN,1060)ZTOT
	IF(NSPIN.EQ.2)WRITE(IUN,1070)TOTM
	WRITE(IUN,1080)
1010	FORMAT(1X,'Broyden Mixing for Rho(r), Iter-Weight=',G14.7)
1020	FORMAT(1X,'   Charge:')
1030	FORMAT(1X,'   Charge:        Magnetization:')           
1040	FORMAT(1X,G14.7,2X,A10)
1050	FORMAT(1X,G14.7,5X,G14.7,2X,A10)
1060    FORMAT(1X,'Interst. Charge after Broyden  =',G14.7)
1070    FORMAT(1X,'Magnetization over MT-spheres  =',G14.7)
1080    FORMAT(1X,'----------------------------------------------')
	END
