	SUBROUTINE PLW2MH
***********************************************************
*  Generates plane waves for all differences G'-G .       *
***********************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER IS(NPAT),ILST(NSORTMAX),ILSB(NSORTMAX)
     &   ,INDG(NFFTMAX),KVEC(3,0:NPLWMAX),KGMIN(3),KGMAX(3)
     &   ,ILSV(NSORTMAX),INDG2(9*NFFTMAX)
	DIMENSION RBAS(3,3),GBAS(3,3),TAU(3,NPAT),ORTH(2:3)
     &   ,GPLW(3,0:NPLWMAX),GL(3),TAU0(3),SMT(NSORTMAX)
     &   ,G2PLW(3,0:9*NPLWMAX)
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM         !!! from init
	COMMON /LATTICE/RBAS,GBAS                             !!! from init
	COMMON /BASIS/  TAU                                   !!! from init
	COMMON /POTCOM/ SWZ,SMT                               !!! from init
	COMMON /PLWMESH/NPLW,GPLW,KVEC,KGMIN,KGMAX,INDG       !!! from plwmsh
	COMMON /PLW2MSH/N2PLW,G2PLW,INDG2                     !!! from plw2mh
	COMMON /LATPAR/ PAR,ORTH,OMEGAC                       !!! from init
	COMMON /UNIT/   IUN                                   !!! from init
	COMMON /WORD/   NVAL                                  !!! from nmtdata
C  SET POINT-INDICATOR ARRAY TO "-1"
	DO 10 M3=2*KGMIN(3),2*KGMAX(3)
	DO 10 M2=2*KGMIN(2),2*KGMAX(2)
	DO 10 M1=2*KGMIN(1),2*KGMAX(1)
	IDIM=1+M1-2*KGMIN(1)+(2*KGMAX(1)-2*KGMIN(1)+1)*
     &  (M2-2*KGMIN(2))+(2*KGMAX(1)-2*KGMIN(1)+1)*
     &  (2*KGMAX(2)-2*KGMIN(2)+1)*(M3-2*KGMIN(3))
	IF(IDIM.GT.9*NFFTMAX)STOP'<PLWINT>: INCREASE NFFTMAX'
	INDG2(IDIM)=-1
  10    CONTINUE
C  DO OVER PLANE WAVES
	N2PLW=-1
	DO 30 IPLW=0,NPLW
	M1I=KVEC(1,IPLW)
	M2I=KVEC(2,IPLW)
	M3I=KVEC(3,IPLW)
	DO 20 JPLW=0,NPLW
	M1J=KVEC(1,JPLW)
	M2J=KVEC(2,JPLW)
	M3J=KVEC(3,JPLW)
C  SET UP DIFFERENCE
	M1=M1J-M1I
	M2=M2J-M2I
	M3=M3J-M3I
	IDIM=1+M1-2*KGMIN(1)+(2*KGMAX(1)-2*KGMIN(1)+1)*
     &  (M2-2*KGMIN(2))+(2*KGMAX(1)-2*KGMIN(1)+1)*
     &  (2*KGMAX(2)-2*KGMIN(2)+1)*(M3-2*KGMIN(3))
	IF(INDG2(IDIM).NE.-1)GOTO20
	N2PLW=N2PLW+1
	IF(N2PLW.GT.9*NPLWMAX)STOP'<PLWINT>: INCREASE NPLWMAX'
	INDG2(IDIM)=N2PLW
	G2PLW(1,N2PLW)=GPLW(1,JPLW)-GPLW(1,IPLW)
	G2PLW(2,N2PLW)=GPLW(2,JPLW)-GPLW(2,IPLW)
	G2PLW(3,N2PLW)=GPLW(3,JPLW)-GPLW(3,IPLW)
 20     CONTINUE
 30     CONTINUE
	END


	SUBROUTINE PLWINT(GINT)
***********************************************************
*  Integrates plane waves over interstitial region.       *
***********************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	DIMENSION G2PLW(3,0:9*NPLWMAX)
 	COMPLEX*16 GINT(0:9*NPLWMAX)
	COMMON /PLW2MSH/N2PLW,G2PLW                           !!! from plw2mh
	DO 10 I2PLW=0,N2PLW
	CALL PLWMTS(G2PLW(1,I2PLW),G2PLW(2,I2PLW),G2PLW(3,I2PLW),
     &  GINT(I2PLW))
  10	CONTINUE
	END




	SUBROUTINE PLWMTS(GX,GY,GZ,GINT)
**************************************************************
*  Calculates integral over the interstitial region for a    *
*  single plane wave given by Gx,Gy,Gz which is the integral *
*  over all MT-spheres.                                      *
**************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER IS(NPAT),ILST(NSORTMAX),ILSB(NSORTMAX)
     &   ,ILSV(NSORTMAX)
	DIMENSION RBAS(3,3),GBAS(3,3),GPLW(3,0:NPLWMAX),ORTH(2:3)
     &   ,TAU(3,NPAT),SMT(NSORTMAX)
	COMPLEX*16 GINT,EXPGT
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM         !!! from init
	COMMON /LATTICE/RBAS,GBAS                             !!! from init
	COMMON /BASIS/  TAU                                   !!! from init
	COMMON /LATPAR/ PAR,ORTH,OMEGAC                       !!! from init
	COMMON /POTCOM/ SWZ,SMT                               !!! from init
	DATA PI/3.141592653589793D0/
	GG=SQRT(GX*GX+GY*GY+GZ*GZ)*2.D0*PI/PAR
	IF(GG.LE.1.D-10)THEN  ! just interstitial volume
	VINT=OMEGAC
	DO 10 IATOM=1,NATOM
	ISORT=IS(IATOM)
	VINT=VINT-4.D0*PI/3.D0*SMT(ISORT)**3
  10    CONTINUE
	GINT=DCMPLX(VINT,0.D0)
	ELSE
	GINT=(0.D0,0.D0)
	DO 20 IATOM=1,NATOM
	ISORT=IS(IATOM)
	SCP=GX*TAU(1,IATOM)+GY*TAU(2,IATOM)+GZ*TAU(3,IATOM)
	EXPGT=EXP((0.D0,1.D0)*2.D0*PI*SCP)
	GS=GG*SMT(ISORT)
	GINT=GINT-4.D0*PI*EXPGT/GG**3*(SIN(GS)-GS*COS(GS))
  20    CONTINUE
	ENDIF
	END



	SUBROUTINE DPLWMTS(GX,GY,GZ,GINT,IATOM0)
**************************************************************
*  Calculates change in the integral over the MT-region for a* 
*  single plane wave given by Gx,Gy,Gz.                      * 
**************************************************************
        IMPLICIT REAL*8 (A-H,O-Z)
        INCLUDE 'PARAM.DAT'
	INTEGER IS(NPAT),ILST(NSORTMAX),ILSB(NSORTMAX)
     &   ,ILSV(NSORTMAX)
	DIMENSION RBAS(3,3),GBAS(3,3),GPLW(3,0:NPLWMAX),ORTH(2:3)
     &   ,TAU(3,NPAT),SMT(NSORTMAX)
	COMPLEX*16 GINT,EXPGT
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM         !!! from init
	COMMON /LATTICE/RBAS,GBAS                             !!! from init
	COMMON /PLWMESH/NPLW,GPLW                             !!! from plwmsh
	COMMON /BASIS/  TAU                                   !!! from init
	COMMON /LATPAR/ PAR,ORTH,OMEGAC                       !!! from init
	COMMON /POTCOM/ SWZ,SMT                               !!! from init
	DATA PI/3.141592653589793D0/
	GG=SQRT(GX*GX+GY*GY+GZ*GZ)*2.D0*PI/PAR
	IATOM=IATOM0
	ISORT=IS(IATOM)
	IF(GG.LE.1.D-10)THEN  ! simply zero
	GINT=4.D0*PI/3.D0*SMT(ISORT)**3
	ELSE
	SCP=GX*TAU(1,IATOM)+GY*TAU(2,IATOM)+GZ*TAU(3,IATOM)
	EXPGT=EXP((0.D0,1.D0)*2.D0*PI*SCP)
	GS=GG*SMT(ISORT)
	GINT=4.D0*PI*EXPGT/GG**3*(SIN(GS)-GS*COS(GS))
	ENDIF
	END
