	SUBROUTINE RENROV
****************************************************************
*  Renormalize valence density according to the input charge   *
*  Written by S.Yu.Savrasov (P.N.Lebedev Physical Institute)   *
****************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER ILSV(NSORTMAX),ILST(NSORTMAX),ILSB(NSORTMAX)
     &    ,IS(NPAT),NHSORT(NSORTMAX),LMSYM(LMMAXV,NPAT)
     &    ,NRAD(NSORTMAX)
	DIMENSION SMT(NSORTMAX),Z(NSORTMAX),ZCOR(NSORTMAX)
     &    ,H(NSORTMAX),R(0:NRADMAX,NSORTMAX),DR(0:NRADMAX,NSORTMAX)
     &    ,WEIGHT(0:NRADMAX,NSORTMAX),WORK1(0:NRADMAX),WORK2(0:NRADMAX)
     &    ,RL(0:NRADMAX,0:LMAXV,NSORTMAX),AD(3,3),RD(3,3)
     &    ,ROCOR(0:NRADMAX,NSORTMAX,NSPINMAX),ORTH(2:3)
     &    ,GPLW(3,0:NPLWMAX)
	COMPLEX*16 DIM,ROVALDS(3,NSYMMAX,NPAT,NSPINMAX)
     &    ,RO(0:NRADMAX,NSYMMAX,NPAT,NSPINMAX),ROVAL
     &    ,RHOPS(0:NPLWMAX,NSPINMAX),GINT
	LOGICAL SYM(LMMAXV,NPAT)
	CHARACTER TXTEL(NSORTMAX)*10
	COMMON /CONTROL/MAN,LMTO,NLR,NOVR                   !!! from init
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM,NHSORT!!! from init
	COMMON /DENS/   RO,ROVALDS,ROCOR                    !!! from rofull
	COMMON /PSRHO/  RHOPS                               !!! from init
	COMMON /POTCOM/ SWZ,SMT                             !!! from init
	COMMON /LATPAR/ PAR,ORTH,OMEGAC                     !!! from init
	COMMON /PLWMESH/NPLW,GPLW                           !!! from plwmesh
	COMMON /MULTRO/ Z,ZCOR                              !!! from init
	COMMON /SYMMLM/ SYM,LMSYM                           !!! from symlm
	COMMON /RADMESH/NRAD,H,R,DR,WEIGHT,RL               !!! from radmsh
	COMMON /SPIN/   NSPIN                               !!! from init
	COMMON /UNIT/   IUN                                 !!! from init
	DATA PI/3.141592653589793D0/,DIM/(0.D0,1.D0)/
	SQPI4=2.D0*SQRT(PI)
	ZVMTS=0.D0
	ZVALT=0.D0
	DO 40 ISPIN=1,NSPIN                   !!! over spins
	DO 30 IATOM=1,NATOM                   !!! over atoms
	ISORT=IS(IATOM)
C  FIND CHARGES WITHIN MTS
	DO 10 IRAD=0,NRAD(ISORT)
	WORK1(IRAD)=RO(IRAD,1,IATOM,ISPIN)*WEIGHT(IRAD,ISORT)/
     &  SQRT(4.D0*PI)
  10    CONTINUE
	CALL QD(H(ISORT),WORK1,WORK2,NRAD(ISORT)+1)
	ZVMTS=ZVMTS+WORK2(NRAD(ISORT))
	ZVALT=ZVALT+(Z(ISORT)-ZCOR(ISORT))/DFLOAT(NSPIN)
  30    CONTINUE                              !!! over atoms
  40    CONTINUE                              !!! over spins
C FIND PSEUDOCHARGE
	ZVINT=0.D0
	DO 50 ISPIN=1,NSPIN                   !!! over spins
	DO 50 IPLW=0,NPLW
	CALL PLWMTS(GPLW(1,IPLW),GPLW(2,IPLW),GPLW(3,IPLW),GINT)
	ZVINT=ZVINT+RHOPS(IPLW,ISPIN)*GINT
  50    CONTINUE                              !!! over spins
	ZVTOT=ZVMTS+ZVINT
	IF(ABS(ZVTOT).LE.1.D-10)
     &  STOP'<RENROV>: INTERNAL ERROR, VALENCE CHARGE IS ZERO'
C  RENORMALIZE VALENCE DENSITY
	ANORM=ZVALT/ZVTOT
	DO 150 ISPIN=1,NSPIN                  !!! over spins
	DO 60 IPLW=0,NPLW
	ROVAL=RHOPS(IPLW,ISPIN)*ANORM
	RHOPS(IPLW,ISPIN)=ROVAL
  60    CONTINUE
	DO 140 IATOM=1,NATOM                  !!! over atoms
	ISORT=IS(IATOM)
	DO 130 L=0,ILSV(ISORT)                !!! over l
	DO 120 M=-L,L                         !!! over m
	LM=L*(L+1)+M+1
	IF(SYM(LM,IATOM))THEN
	ISYM=LMSYM(LM,IATOM)
	DO 80 IRAD=0,NRAD(ISORT)
	ROVAL=RO(IRAD,ISYM,IATOM,ISPIN)*ANORM
	RO(IRAD,ISYM,IATOM,ISPIN)=ROVAL
  80    CONTINUE
	ROVALDS(1,ISYM,IATOM,ISPIN)=
     &  RO(NRAD(ISORT),ISYM,IATOM,ISPIN)
	ROVALDS(2,ISYM,IATOM,ISPIN)=
     &  ROVALDS(2,ISYM,IATOM,ISPIN)*ANORM
	ROVALDS(3,ISYM,IATOM,ISPIN)=
     &  ROVALDS(3,ISYM,IATOM,ISPIN)*ANORM
	ENDIF
 120    CONTINUE                               !!! over m
 130    CONTINUE                               !!! over l
 140    CONTINUE                               !!! over atoms
 150    CONTINUE                               !!! over spins
	WRITE(IUN,1010)ZVALT
	WRITE(IUN,1020)ZVTOT
	WRITE(IUN,1030)ANORM
1010    FORMAT(1X,'Valence charge in whole  elementary cell  must be ',
     &  G14.7)
1020    FORMAT(1X,'Valence charge  found  via fourier  transform  is ',
     &  G14.7)
1030    FORMAT(1X,'Renormalization coefficient of the val.density is ',
     &  G14.7)
	END
