	SUBROUTINE TOSPAR(IPNT,IPAN,IC)
***********************************************************
*  Calculates partial numbers-of-states matrix.           *
*  Written by S.Savrasov in Max-Planck Institute, Germany *
***********************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER ILST(NSORTMAX),ILSB(NSORTMAX),ILSV(NSORTMAX)
     &    ,NHSORT(NSORTMAX),IS(NPAT),NKAP(NPANMAX),NPNT(NPANMAX)
     &    ,IATS(NPAT,NPANMAX),ISTS(NSORTMAX,NPANMAX)
     &    ,NBNDF(NPANMAX),NBNDE(NPANMAX),NBNDT(NPANMAX)
	COMPLEX*16 ATOSHH(LIMLMB,LIMLMB,NPAT),ATOSHJ(LIMLMB,LIMLMT,NPAT)
     &    ,ATOSJH(LIMLMT,LIMLMB,NPAT),ATOSJJ(LIMLMT,LIMLMT,NPAT)
     &    ,APH(LIMLMB,NPAT,NKAPMAX),APJ(LIMLMT,NPAT,NKAPMAX)
     &    ,ATOS(0:LMAXT,NSORTMAX,NKAPMAX,NKAPMAX,NPANMAX,NSPINMAX,0:5)
     &    ,ADOS(0:LMAXT,NSORTMAX,NKAPMAX,NKAPMAX,NPANMAX,NSPINMAX)
     &    ,ASUM(0:LMAXT,NSORTMAX,NKAPMAX,NKAPMAX)
     &    ,PFVAL(-1:1,NPAT,NPANMAX,NSPINMAX,2)
     &    ,RHOPS(0:NPLWMAX,NSPINMAX)
	DIMENSION PNT(3,KMAX,NPANMAX),IP(NPAT,NOPRMAX)
     &    ,WEIGH(NDIMMAX*NSPINMAX,KMAX),WEIGD(NDIMMAX*NSPINMAX,KMAX)
     &    ,EARR(NDIMMAX*NSPINMAX,KMAX,NPANMAX),WGT(KMAX,NPANMAX)
	LOGICAL SYM(LMMAXV,NPAT),LOG1,LOG
     &    ,LTPAN(0:LMAXT+1,NPAT,NKAPMAX,NPANMAX)
     &    ,LSPAN(0:LMAXT+1,NSORTMAX,NKAPMAX,NPANMAX)
	CHARACTER*60 SCRFILE(100)
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM,NHSORT    !!! from init
	COMMON /MESH/   NPNT,PNT,WGT                            !!! from ttrmsh
	COMMON /KAPPAR/ NPAN,NKAP                               !!! from init
	COMMON /ENERGY/ EARR,WEIGH,WEIGD                        !!! from lmtbnd
	COMMON /PANPAR/ LTPAN,LSPAN,IATS,ISTS                   !!! from init
	COMMON /SYMMLM/ SYM                                     !!! from symmlm 
	COMMON /STORE1/ ATOSHH,ATOSJH,ATOSHJ,ATOSJJ             !!! from tospar
	COMMON /TOSDOS/ ATOS,ADOS                               !!! from tospar
        COMMON /PSRHO/  RHOPS                                   !!! from tosint
	COMMON /PLWMESH/NPLW                                    !!! from plwmsh
	COMMON /PILAUF/ PFVAL                                   !!! from tospar
	COMMON /NBANDS/ NBNDF,NBNDE,NBNDT                       !!! from init
	COMMON /ORBS/   NORBS                                   !!! from init
	COMMON /SPIN/   NSPIN                                   !!! from init
	COMMON /WORD/   NVAL                                    !!! from nmtdat
	COMMON /OUT0/   SCRFILE                                 !!! from init
	COMMON /UNIT/   IUN                                     !!! output unit
	DATA PI/3.141592653589793D0/
	NSHIFT1=0
	NSHIFT2=0
	DO JPAN=1,NPAN
	IF(JPAN.LT.IPAN)NSHIFT1=NSHIFT1+NKAP(JPAN)**2
	NSHIFT2=NSHIFT2+NKAP(JPAN)**2
        ENDDO       
        DO IORBS=1,NORBS                               !!! over spinor components
        DO IBNDS=1,NSPIN                               !!! over spin subbands
        IF(NORBS.EQ.1)ISPIN=IBNDS
        IF(NORBS.EQ.2)ISPIN=IORBS
        DO IKAP=1,NKAP(IPAN)                           !!! over energies
        DO JKAP=1,NKAP(IPAN)                           !!! over energies
	DO IATOM=1,NATOM                               !!! over iatom
	ISORT=IS(IATOM)
	IREC=IKAP+NKAP(IPAN)*(JKAP-1)+NKAP(IPAN)**2*(IATOM-1)+
     &  NSHIFT1*NATOM+NSHIFT2*NATOM*(ISPIN-1)
	READ(21,REC=IREC)((ATOSHH(L1M1,LM,IATOM),
     &  L1M1=1,(ILSB(ISORT)+1)**2),LM=1,(ILSB(ISORT)+1)**2),
     &  ((ATOSJH(L1M1,LM,IATOM),
     &  L1M1=1,(ILST(ISORT)+1)**2),LM=1,(ILSB(ISORT)+1)**2),
     &  ((ATOSHJ(L1M1,LM,IATOM),
     &  L1M1=1,(ILSB(ISORT)+1)**2),LM=1,(ILST(ISORT)+1)**2),
     &  ((ATOSJJ(L1M1,LM,IATOM),
     &  L1M1=1,(ILST(ISORT)+1)**2),LM=1,(ILST(ISORT)+1)**2)
        ENDDO                                          !!! over iatom
C *********** TETRAHEDRON METHOD ASSUMING FULL FILLING *****
        DO IBNDT=1,NBNDF(IPAN)                         !!! over bands
        IBAND=IBNDS+NSPIN*(IBNDT-1)
C  SET WEIGHT
        IF(.NOT.(IC.EQ.0.AND.IBNDT.GE.NBNDE(IPAN)))THEN
        IF(.NOT.(IC.EQ.1.AND.IBNDT.LT.NBNDE(IPAN)))THEN
        IF(IC.EQ.0)WHT=WGT(IPNT,IPAN)/DBLE(NSPIN)
        IF(IC.EQ.1)WHT=WEIGH(IBAND,IPNT)
C  READ VARIATIONAL COEFFICIENTS
        IF(IC.EQ.0)THEN !!! called from bands
        IREC=IKAP+NKAP(IPAN)*(IBNDT-1)+
     &  NKAP(IPAN)*NBNDF(IPAN)*(IBNDS-1)+
     &  NKAP(IPAN)*NBNDF(IPAN)*NSPIN*(IORBS-1)
        READ(14,REC=IREC)
     &  ((APH(LM,IATOM,IKAP),LM=1,(ILSB(IS(IATOM))+1)**2),
     &  IATOM=1,NATOM),
     &  ((APJ(LM,IATOM,IKAP),LM=1,(ILST(IS(IATOM))+1)**2),
     &  IATOM=1,NATOM)
        IREC=JKAP+NKAP(IPAN)*(IBNDT-1)+
     &  NKAP(IPAN)*NBNDF(IPAN)*(IBNDS-1)+
     &  NKAP(IPAN)*NBNDF(IPAN)*NSPIN*(IORBS-1)
        READ(14,REC=IREC)
     &  ((APH(LM,IATOM,JKAP),LM=1,(ILSB(IS(IATOM))+1)**2),
     &  IATOM=1,NATOM),
     &  ((APJ(LM,IATOM,JKAP),LM=1,(ILST(IS(IATOM))+1)**2),
     &  IATOM=1,NATOM)
        ELSEIF(IC.EQ.1.AND.IBNDT.GE.NBNDE(IPAN))THEN !!! from ttrint
        IF(IPAN.GT.1)STOP'<LMTBND>: RECORD FOR IPAN.GT.1 NOT ALLOWED'
        IREC=IKAP+NKAP(1)*(IBNDT-NBNDE(1))+
     &  NKAP(1)*(NBNDF(1)-NBNDE(1)+1)*(IBNDS-1)+
     &  NKAP(1)*(NBNDF(1)-NBNDE(1)+1)*NSPIN*(IORBS-1)+
     &  NKAP(1)*(NBNDF(1)-NBNDE(1)+1)*NSPIN*NORBS*(IPNT-1)
        READ(15,REC=IREC)
     &  ((APH(LM,IATOM,IKAP),LM=1,(ILSB(IS(IATOM))+1)**2),
     &  IATOM=1,NATOM),
     &  ((APJ(LM,IATOM,IKAP),LM=1,(ILST(IS(IATOM))+1)**2),
     &  IATOM=1,NATOM)
        IREC=JKAP+NKAP(1)*(IBNDT-NBNDE(1))+
     &  NKAP(1)*(NBNDF(1)-NBNDE(1)+1)*(IBNDS-1)+
     &  NKAP(1)*(NBNDF(1)-NBNDE(1)+1)*NSPIN*(IORBS-1)+
     &  NKAP(1)*(NBNDF(1)-NBNDE(1)+1)*NSPIN*NORBS*(IPNT-1)
        READ(15,REC=IREC)
     &  ((APH(LM,IATOM,JKAP),LM=1,(ILSB(IS(IATOM))+1)**2),
     &  IATOM=1,NATOM),
     &  ((APJ(LM,IATOM,JKAP),LM=1,(ILST(IS(IATOM))+1)**2),
     &  IATOM=1,NATOM)
        ENDIF
C COMPUTE CONTRIBUTION FROM THIS K-POINT
        DO IATOM=1,NATOM                               !!! over atoms in cell
        ISORT=IS(IATOM)
        DO L1=0,ILST(ISORT)                            !!! over l1
        LOG1=.FALSE.
        IF(LTPAN(L1,IATOM,IKAP,IPAN))LOG1=.TRUE.
        DO M1=-L1,L1                                   !!! over m1
        L1M1=L1*(L1+1)+M1+1
        DO L=0,ILST(ISORT)                             !!! over l
        LOG=.FALSE.
        IF(LTPAN(L,IATOM,JKAP,IPAN))LOG=.TRUE.
        DO M=-L,L                                      !!! over m
        LM=L*(L+1)+M+1
        IF(LOG1.AND.LOG)ATOSHH(L1M1,LM,IATOM)=ATOSHH(L1M1,LM,IATOM)+
     &  CONJG(APH(L1M1,IATOM,IKAP))*APH(LM,IATOM,JKAP)*WHT
        IF(LOG1)ATOSHJ(L1M1,LM,IATOM)=ATOSHJ(L1M1,LM,IATOM)+
     &  CONJG(APH(L1M1,IATOM,IKAP))*APJ(LM,IATOM,JKAP)*WHT
        IF(LOG)ATOSJH(L1M1,LM,IATOM)=ATOSJH(L1M1,LM,IATOM)+
     &  CONJG(APJ(L1M1,IATOM,IKAP))*APH(LM,IATOM,JKAP)*WHT
        ATOSJJ(L1M1,LM,IATOM)=ATOSJJ(L1M1,LM,IATOM)+
     &  CONJG(APJ(L1M1,IATOM,IKAP))*APJ(LM,IATOM,JKAP)*WHT
        ENDDO                                          !!! over m
        ENDDO                                          !!! over l
        ENDDO                                          !!! over m1
        ENDDO                                          !!! over l1
        ENDDO                                          !!! over atoms in cell
        ENDIF
        ENDIF
        ENDDO                                          !!! over valence bands
        DO IATOM=1,NATOM
        ISORT=IS(IATOM)
        IREC=IKAP+NKAP(IPAN)*(JKAP-1)+NKAP(IPAN)**2*(IATOM-1)+
     &  NSHIFT1*NATOM+NSHIFT2*NATOM*(ISPIN-1)
        WRITE(21,REC=IREC)((ATOSHH(L1M1,LM,IATOM),
     &  L1M1=1,(ILSB(ISORT)+1)**2),LM=1,(ILSB(ISORT)+1)**2),
     &  ((ATOSJH(L1M1,LM,IATOM),
     &  L1M1=1,(ILST(ISORT)+1)**2),LM=1,(ILSB(ISORT)+1)**2),
     &  ((ATOSHJ(L1M1,LM,IATOM),
     &  L1M1=1,(ILSB(ISORT)+1)**2),LM=1,(ILST(ISORT)+1)**2),
     &  ((ATOSJJ(L1M1,LM,IATOM),
     &  L1M1=1,(ILST(ISORT)+1)**2),LM=1,(ILST(ISORT)+1)**2)
        ENDDO
        ENDDO                                          !!! over energies
        ENDDO                                          !!! over energies
        ENDDO                                          !!! over spin subbands
        ENDDO                                          !!! over spinor components
C  CALCULATE PARTIAL NUMBER OF STATES
        DO IORBS=1,NORBS                               !!! over spinor components
        DO IBNDS=1,NSPIN                               !!! over spin subbands
        IF(NORBS.EQ.1)ISPIN=IBNDS
        IF(NORBS.EQ.2)ISPIN=IORBS
        DO IBNDT=1,NBNDF(IPAN)                         !!! over bands
        IBAND=IBNDS+NSPIN*(IBNDT-1)
C  SET WEIGHT
        IF(.NOT.(IC.EQ.0.AND.IBNDT.GE.NBNDE(IPAN)))THEN
        IF(.NOT.(IC.EQ.1.AND.IBNDT.LT.NBNDE(IPAN)))THEN
        IF(IC.EQ.0)WHT=WGT(IPNT,IPAN)/DBLE(NSPIN)
        IF(IC.EQ.1)WHT=WEIGH(IBAND,IPNT)
        IF(IC.EQ.0)WDT=0.D0
        IF(IC.EQ.1)WDT=WEIGD(IBAND,IPNT)
        CALL SUMSUB(ASUM,IBNDT,IBNDS,IORBS,IPNT,IPAN,IC)
        DO IKAP1=1,NKAP(IPAN)                          !!! over energies
        DO IKAP=1,NKAP(IPAN)                           !!! over energies
        DO ISORT=1,NSORT                               !!! over isort
        DO L=0,ILST(ISORT)                             !!! over l
        ADOS(L,ISORT,IKAP1,IKAP,IPAN,ISPIN)=
     &  ADOS(L,ISORT,IKAP1,IKAP,IPAN,ISPIN)+
     &  ASUM(L,ISORT,IKAP1,IKAP)*WDT
        DO IMOM=0,5                                    !!! over moments
        ATOS(L,ISORT,IKAP1,IKAP,IPAN,ISPIN,IMOM)=
     &  ATOS(L,ISORT,IKAP1,IKAP,IPAN,ISPIN,IMOM)+
     &  ASUM(L,ISORT,IKAP1,IKAP)*
     &  EARR(IBAND,IPNT,IPAN)**IMOM*WHT
        ENDDO                                          !!! over moments
        ENDDO                                          !!! over l
        ENDDO                                          !!! over isort
        ENDDO                                          !!! over energies
        ENDDO                                          !!! over energies
        ENDIF
        ENDIF
        ENDDO                                          !!! over bands
        ENDDO                                          !!! over spin subbands
        ENDDO                                          !!! over spinor components
	RETURN



	ENTRY SNULTOS(IPAN)
******************************************************
*  Set initial tos-matrix to zero                    *
******************************************************
	NRECL=0    !!! estimate record length
	DO IATOM=1,NATOM
	ISORT=IS(IATOM)
	LMAXH=((ILSB(ISORT)+1)**2+(ILST(ISORT)+1)**2)**2
	NRECL=MAX(NRECL,NVAL*LMAXH)
        ENDDO                  
	NSHIFT1=0
	NSHIFT2=0
	DO JPAN=1,NPAN
	IF(JPAN.LT.IPAN)NSHIFT1=NSHIFT1+NKAP(JPAN)**2
	NSHIFT2=NSHIFT2+NKAP(JPAN)**2
        ENDDO                  
C  OPEN SCRATCH FILE FOR STORING PARTIAL NUMBERS OF STATES
	IF(IPAN.EQ.1)
     &  OPEN(UNIT=21,FILE=SCRFILE(21),STATUS='NEW',ACCESS='DIRECT',
     &  FORM='UNFORMATTED',RECL=NRECL)
C SET TOS-MATRIX TO ZERO
        DO ISPIN=1,NSPIN                               !!! over spins
	DO IKAP=1,NKAP(IPAN)                           !!! over energies
	DO JKAP=1,NKAP(IPAN)                           !!! over energies
	DO IATOM=1,NATOM                               !!! over iatom
	ISORT=IS(IATOM)
	DO L1=0,ILST(ISORT)                            !!! over l1
	LOG1=.FALSE.
	IF(L1.LE.ILSB(ISORT))LOG1=.TRUE.
	DO M1=-L1,L1                                   !!! over m1
	L1M1=L1*(L1+1)+M1+1
	DO L=0,ILST(ISORT)                             !!! over l
	LOG=.FALSE.
	IF(L.LE.ILSB(ISORT))LOG=.TRUE.
	DO M=-L,L                                      !!! over m
	LM=L*(L+1)+M+1
	IF(LOG1.AND.LOG)ATOSHH(L1M1,LM,IATOM)=(0.D0,0.D0)
	IF(LOG1)ATOSHJ(L1M1,LM,IATOM)=(0.D0,0.D0)
	IF(LOG )ATOSJH(L1M1,LM,IATOM)=(0.D0,0.D0)
	ATOSJJ(L1M1,LM,IATOM)=(0.D0,0.D0)
        ENDDO                                          !!! over m
        ENDDO                                          !!! over l
        ENDDO                                          !!! over m1
        ENDDO                                          !!! over l1
        ENDDO                                          !!! over atoms
	DO IATOM=1,NATOM                               !!! over atoms
	ISORT=IS(IATOM)
	IREC=IKAP+NKAP(IPAN)*(JKAP-1)+NKAP(IPAN)**2*(IATOM-1)+
     &  NSHIFT1*NATOM+NSHIFT2*NATOM*(ISPIN-1)
	WRITE(21,REC=IREC)((ATOSHH(L1M1,LM,IATOM),
     &  L1M1=1,(ILSB(ISORT)+1)**2),LM=1,(ILSB(ISORT)+1)**2),
     &  ((ATOSJH(L1M1,LM,IATOM),
     &  L1M1=1,(ILST(ISORT)+1)**2),LM=1,(ILSB(ISORT)+1)**2),
     &  ((ATOSHJ(L1M1,LM,IATOM),
     &  L1M1=1,(ILSB(ISORT)+1)**2),LM=1,(ILST(ISORT)+1)**2),
     &  ((ATOSJJ(L1M1,LM,IATOM),
     &  L1M1=1,(ILST(ISORT)+1)**2),LM=1,(ILST(ISORT)+1)**2)
        ENDDO                                          !!! over atoms
        ENDDO                                          !!! over energies
        ENDDO                                          !!! over energies
        ENDDO                                          !!! over spins
C  SET PSEUDOCHARGEDENSITY TO ZERO
        IF(IPAN.EQ.1)THEN
        DO ISPIN=1,NSPIN                               !!! over spins
        DO IPLW=0,NPLW                                 !!! over iplw
        RHOPS(IPLW,ISPIN)=(0.D0,0.D0)
        ENDDO                                          !!! over iplw
        ENDDO                                          !!! over spins
        ENDIF
C  SET PARTIAL NUMBERS OF STATES TO ZERO
        DO ISPIN=1,NSPIN                               !!! over spins
	DO IKAP1=1,NKAP(IPAN)                          !!! over ikap
	DO IKAP=1,NKAP(IPAN)                           !!! over ikap
	DO ISORT=1,NSORT                               !!! over isort
	DO L=0,ILST(ISORT)                             !!! over l
	DO IMOM=0,5                                    !!! over moments
	ATOS(L,ISORT,IKAP1,IKAP,IPAN,ISPIN,IMOM)=(0.D0,0.D0)
        ENDDO                                          !!! over moments
	ADOS(L,ISORT,IKAP1,IKAP,IPAN,ISPIN)=(0.D0,0.D0)
        ENDDO                                          !!! over l
        ENDDO                                          !!! over isort
        ENDDO                                          !!! over ikap
        ENDDO                                          !!! over ikap1
        ENDDO                                          !!! over spins
C  SET PULAY FORCES TO ZERO
        DO ISPIN=1,NSPIN                               !!! over spins
	DO INUC=1,NATOM                                !!! over displacements
	DO MY=-1,1                                     !!! over polarizations
	PFVAL(MY,INUC,IPAN,ISPIN,1)=(0.D0,0.D0)
	PFVAL(MY,INUC,IPAN,ISPIN,2)=(0.D0,0.D0)
        ENDDO                                          !!! over polarizations
        ENDDO                                          !!! over displacements
        ENDDO                                          !!! over spins
	END
