	SUBROUTINE TTRINT2(EF)
***********************************************************
*  The calculation of the integrals over whole Brillouin  *
*  zone :                                                 *
*    __  /  3    kj*     kj                               *
*    >   \ d k  C1      C2    tetta(E-E  )                *
*    --  /       l1m1,t  lmt           kj                 *
*    j   BZ                                               *
*  where theta is a Heaviside step-function.              *
*  The C-coefficients are the variational coefficients    *
*         kj                   __    kj     k             *
*        A          or         >    A      S              *
*         L t                  --    L"t"   Lt,L"t"       *
*                              L"t"                       *
*  i.e. their convolutions with the structure constants   *
*  which are transformed with help of the Wigner matrices *
*  after applying the point group operation.              *
*  Written by S.Savrasov in Max-Planck Institute, Germany *
***********************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER ILST(NSORTMAX),ILSB(NSORTMAX),ILSV(NSORTMAX)
     &   ,IKOV(NOPRMAX),NHSORT(NSORTMAX),IS(NPAT),NKAP(NPANMAX)
     &   ,IATS(NPAT,NPANMAX),ISTS(NSORTMAX,NPANMAX)
     &   ,NBNDF(NPANMAX),NBNDE(NPANMAX),NBNDT(NPANMAX)
     &   ,INDG(NFFTMAX),KVEC(3,0:NPLWMAX),KGMIN(3),KGMAX(3)
     &   ,LBAS(0:LMAXB,NSORTMAX,NKAPMAX,NPANMAX)
     &   ,NPNT(NPANMAX),IP(NPAT,NOPRMAX)
	COMPLEX*16 ATOSHH(LIMLMB,LIMLMB,NPAT),ATOSHJ(LIMLMB,LIMLMT,NPAT)
     &   ,ATOSJH(LIMLMT,LIMLMB,NPAT),ATOSJJ(LIMLMT,LIMLMT,NPAT)
     &   ,ATMP1(-LMAXT:LMAXT,-LMAXT:LMAXT,NPAT,4),EXPGR
     &   ,TMPARR(-LMAXT:LMAXT,4),U(NWIGMAX,48)
     &   ,RHOPS(0:NPLWMAX,NSPINMAX),RHOTMP(0:NPLWMAX)
     &   ,PFVAL(-1:1,NPAT,NPANMAX,NSPINMAX,2),PFTMP(-1:1,NPAT,2)
	DIMENSION PNT(3,KMAX,NPANMAX),SHIFT(3,NOPRMAX)
     &   ,EARR(NDIMMAX*NSPINMAX,KMAX,NPANMAX),GPLW(3,0:NPLWMAX)
     &   ,WEIGH(NDIMMAX*NSPINMAX,KMAX),RBAS(3,3),GBAS(3,3)
     &   ,WEIGD(NDIMMAX*NSPINMAX,KMAX),RDC(3,NPAT,NOPRMAX)
     &   ,ETA(0:LMAXB,NSORTMAX,NKAPMAX,NPANMAX)
     &   ,CUT(0:LMAXB,NSORTMAX,NKAPMAX,NPANMAX)
	LOGICAL LTPAN(0:LMAXT+1,NPAT,NKAPMAX,NPANMAX),LOG1,LOG
     &   ,LSPAN(0:LMAXT+1,NSORTMAX,NKAPMAX,NPANMAX)
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM,NHSORT!!! from init
	COMMON /MESH/   NPNT,PNT                            !!! from ttrmsh
	COMMON /ENERGY/ EARR,WEIGH,WEIGD                    !!! from lmtbnd
	COMMON /KAPPAR/ NPAN,NKAP                           !!! from init
	COMMON /LATTICE/RBAS,GBAS                           !!! from init
	COMMON /PANPAR/ LTPAN,LSPAN,IATS,ISTS               !!! from init
	COMMON /STORE1/ ATOSHH,ATOSJH,ATOSHJ,ATOSJJ         !!! from ttrint2
        COMMON /TEILORG/KEYT,BZM,GOPT,MBAS                  !!! from teipar
        COMMON /PILAUF/ PFVAL                               !!! from tosint
	COMMON /PLWMESH/NPLW,GPLW,KVEC,KGMIN,KGMAX,INDG     !!! from plwmsh
        COMMON /ETAPAR/ ETA,CUT,LBAS,NBAS                   !!! from plwmsh
	COMMON /INVERS/ INV,IKOV                            !!! from group
	COMMON /PSRHO/  RHOPS                               !!! from tosint
	COMMON /GROUPOUT/NGROUP,U,IP,RDC,SHIFT              !!! from group
	COMMON /NBANDS/ NBNDF,NBNDE,NBNDT                   !!! from init
	COMMON /ORBS/   NORBS                               !!! from init
	COMMON /SPIN/   NSPIN                               !!! from init
	COMMON /WORD/   NVAL                                !!! from nmtdat
	COMMON /UNIT/   IUN                                 !!! from init
	DATA PI/3.141592653589793D0/
C DO THE SAME OPERATIONS FOR EVERY SPIN AND ENERGY PANEL
	DO 4000 IPAN=1,NPAN                            !!! over panels
	NSHIFT1=0
	NSHIFT2=0
	DO 10 JPAN=1,NPAN
	IF(JPAN.LT.IPAN)NSHIFT1=NSHIFT1+NKAP(JPAN)**2
	NSHIFT2=NSHIFT2+NKAP(JPAN)**2
  10    CONTINUE
C *********** TETRAHEDRON METHOD FOR CONDUCTION BANDS *****
	IF(IPAN.EQ.1.AND.NBNDF(IPAN).GE.NBNDE(IPAN))THEN
	CALL SNULINT(IPAN)
	CALL SNULPUL(IPAN)
	DO 110 IPNT=1,NPNT(IPAN)                       !!! over k-points
C  COMPUTE INTEGRALS
	CALL TOSPAR(IPNT,IPAN,1)
	CALL TOSINT(IPNT,IPAN,1)
	CALL PULINT(IPNT,IPAN,1)
 110    CONTINUE                                       !!! over k-points
	CALL TOSEND(IPAN)
	CALL PULEND(IPAN)
	CLOSE(UNIT=19,STATUS='DELETE')
	CLOSE(UNIT=20,STATUS='DELETE')
	ENDIF
C  ********  SYMMETRISATION OF THE MT-PART ********
	DO 3000 ISPIN=1,NSPIN                          !!! over spins
	DO 2000 IKAP=1,NKAP(IPAN)                      !!! over energies
	DO 1000 JKAP=1,NKAP(IPAN)                      !!! over energies
	DO 200 IATOM=1,NATOM                           !!! over iatom
	ISORT=IS(IATOM)
	IREC=IKAP+NKAP(IPAN)*(JKAP-1)+NKAP(IPAN)**2*(IATOM-1)+
     &  NSHIFT1*NATOM+NSHIFT2*NATOM*(ISPIN-1) 
	READ(21,REC=IREC)((ATOSHH(L1M1,LM,IATOM),
     &  L1M1=1,(ILSB(ISORT)+1)**2),LM=1,(ILSB(ISORT)+1)**2),
     &  ((ATOSJH(L1M1,LM,IATOM),
     &  L1M1=1,(ILST(ISORT)+1)**2),LM=1,(ILSB(ISORT)+1)**2),
     &  ((ATOSHJ(L1M1,LM,IATOM),
     &  L1M1=1,(ILSB(ISORT)+1)**2),LM=1,(ILST(ISORT)+1)**2),
     &  ((ATOSJJ(L1M1,LM,IATOM),
     &  L1M1=1,(ILST(ISORT)+1)**2),LM=1,(ILST(ISORT)+1)**2)
 200    CONTINUE                                       !!! over iatom
	ILSTMAX=0
	DO 210 ISORT=1,NSORT
	ILSTMAX=MAX(ILST(ISORT),ILSTMAX) 
 210    CONTINUE
	DO 330 L1=0,ILSTMAX                            !!! over l1
	NLS1=L1*(2*L1-1)*(2*L1+1)/3
	LP1=L1*L1+L1+1
	DO 320 L=0,ILSTMAX                             !!! over l
	NLS=L*(2*L-1)*(2*L+1)/3
	LP=L*L+L+1
	DO 280 IATOM=1,NATOM                           !!! over atoms in cell
	ISORT=IS(IATOM)
	LOG1=.FALSE.
	IF(LTPAN(L1,IATOM,IKAP,IPAN))LOG1=.TRUE.
	IF(L1.GT.ILST(ISORT))GOTO280
	LOG=.FALSE.
	IF(LTPAN(L,IATOM,JKAP,IPAN))LOG=.TRUE.
	IF(L.GT.ILST(ISORT))GOTO280
	DO 215 M1=-L1,L1                               !!! over m1
	DO 215 M=-L,L                                  !!! over m
	ATMP1(M1,M,IATOM,1)=(0.D0,0.D0)
	ATMP1(M1,M,IATOM,2)=(0.D0,0.D0)
	ATMP1(M1,M,IATOM,3)=(0.D0,0.D0)
	ATMP1(M1,M,IATOM,4)=(0.D0,0.D0)
 215    CONTINUE                                       !!! over m,m1
	DO 270 IR=1,NGROUP                             !!! over point group
	IG=IKOV(IR)
	DO 260 M=-L,L                                  !!! over m
	LM=LP+M
	MM=L+M+1
	DO 230 M2=-L1,L1
	L1M2=LP1+M2
	TMPARR(M2,1)=(0.D0,0.D0)
	TMPARR(M2,2)=(0.D0,0.D0)
	TMPARR(M2,3)=(0.D0,0.D0)
	TMPARR(M2,4)=(0.D0,0.D0)
	DO 220 M3=-L,L
	LM3=LP+M3
	IWIG03=NLS+(2*L+1)*(L+M3)+MM
	IF(LOG1.AND.LOG) 
     &  TMPARR(M2,1)=TMPARR(M2,1)+U(IWIG03,IG)*
     &  ATOSHH(L1M2,LM3,IP(IATOM,IR))
	IF(LOG) 
     &  TMPARR(M2,2)=TMPARR(M2,2)+U(IWIG03,IG)*
     &  ATOSJH(L1M2,LM3,IP(IATOM,IR))
	IF(LOG1) 
     &  TMPARR(M2,3)=TMPARR(M2,3)+U(IWIG03,IG)*
     &  ATOSHJ(L1M2,LM3,IP(IATOM,IR))
	TMPARR(M2,4)=TMPARR(M2,4)+U(IWIG03,IG)*
     &  ATOSJJ(L1M2,LM3,IP(IATOM,IR))
 220    CONTINUE
 230    CONTINUE
	DO 250 M1=-L1,L1                                   !!! over m1
	L1M1=LP1+M1
	MM1=L1+M1+1
	DO 240 M2=-L1,L1                                   !!! over m2
	IWIG12=NLS1+(2*L1+1)*(L1+M2)+MM1
	IF(LOG1.AND.LOG) 
     &  ATMP1(M1,M,IATOM,1)=ATMP1(M1,M,IATOM,1)+
     &  CONJG(U(IWIG12,IG))*TMPARR(M2,1)
	IF(LOG) 
     &  ATMP1(M1,M,IATOM,2)=ATMP1(M1,M,IATOM,2)+
     &  CONJG(U(IWIG12,IG))*TMPARR(M2,2)
	IF(LOG1) 
     &  ATMP1(M1,M,IATOM,3)=ATMP1(M1,M,IATOM,3)+
     &  CONJG(U(IWIG12,IG))*TMPARR(M2,3)
	ATMP1(M1,M,IATOM,4)=ATMP1(M1,M,IATOM,4)+
     &  CONJG(U(IWIG12,IG))*TMPARR(M2,4)
 240    CONTINUE                                         !!! over m2
 250    CONTINUE                                         !!! over m1
 260    CONTINUE                                         !!! over m
 270    CONTINUE                                         !!! over group
 280    CONTINUE                                         !!! over atoms in cell
C NORMALIZATION
	DO 310 IATOM=1,NATOM                             !!! over atoms in cell
	ISORT=IS(IATOM)
	LOG1=.FALSE.
	IF(LTPAN(L1,IATOM,IKAP,IPAN))LOG1=.TRUE.
	IF(L1.GT.ILST(ISORT))GOTO310
	LOG=.FALSE.
	IF(LTPAN(L,IATOM,JKAP,IPAN))LOG=.TRUE.
	IF(L.GT.ILST(ISORT))GOTO310 
	DO 300 M1=-L1,L1                                 !!! over m1
	L1M1=L1*(L1+1)+M1+1
	DO 290 M=-L,L                                    !!! over m
	LM=L*(L+1)+M+1
	IF(LOG1.AND.LOG)ATOSHH(L1M1,LM,IATOM)=ATMP1(M1,M,IATOM,1)/
     &  DBLE(NGROUP)
	IF(LOG)ATOSJH(L1M1,LM,IATOM)=ATMP1(M1,M,IATOM,2)/
     &  DBLE(NGROUP)
	IF(LOG1)ATOSHJ(L1M1,LM,IATOM)=ATMP1(M1,M,IATOM,3)/
     &  DBLE(NGROUP)
	ATOSJJ(L1M1,LM,IATOM)=ATMP1(M1,M,IATOM,4)/ 
     &  DBLE(NGROUP)
 290    CONTINUE                                        !!! over m
 300    CONTINUE                                        !!! over m1
 310    CONTINUE                                        !!! over atoms
 320    CONTINUE                                        !!! over l
 330    CONTINUE                                        !!! over l1
	DO 400 IATOM=1,NATOM
	ISORT=IS(IATOM)
	IREC=IKAP+NKAP(IPAN)*(JKAP-1)+NKAP(IPAN)**2*(IATOM-1)+
     &  NSHIFT1*NATOM+NSHIFT2*NATOM*(ISPIN-1) 
	WRITE(21,REC=IREC)((ATOSHH(L1M1,LM,IATOM),
     &  L1M1=1,(ILSB(ISORT)+1)**2),LM=1,(ILSB(ISORT)+1)**2),
     &  ((ATOSJH(L1M1,LM,IATOM),
     &  L1M1=1,(ILST(ISORT)+1)**2),LM=1,(ILSB(ISORT)+1)**2),
     &  ((ATOSHJ(L1M1,LM,IATOM),
     &  L1M1=1,(ILSB(ISORT)+1)**2),LM=1,(ILST(ISORT)+1)**2),
     &  ((ATOSJJ(L1M1,LM,IATOM),
     &  L1M1=1,(ILST(ISORT)+1)**2),LM=1,(ILST(ISORT)+1)**2)
 400    CONTINUE
1000    CONTINUE                                    !!! over energies
2000    CONTINUE                                    !!! over energies
C  SYMMETRIZE PULAY FORCE
        DO 440 INUC=1,NATOM                         !!! over displacements
        DO 430 MY=-1,1                              !!! over polarizations
        PFTMP(MY,INUC,1)=(0.D0,0.D0)
        PFTMP(MY,INUC,2)=(0.D0,0.D0)
        DO 420 IR=1,NGROUP                          !!! over crystalline group
        IG=IKOV(IR)
        DO 410 MY1=-1,1                             !!! over polarizations
        IWIG=6+MY+3*MY1                             !!! U(L=1,MY,MY1)
        PFTMP(MY,INUC,1)=PFTMP(MY,INUC,1)+CONJG(U(IWIG,IG))*
     &  PFVAL(MY1,IP(INUC,IR),IPAN,ISPIN,1)
        PFTMP(MY,INUC,2)=PFTMP(MY,INUC,2)+CONJG(U(IWIG,IG))*
     &  PFVAL(MY1,IP(INUC,IR),IPAN,ISPIN,2)
 410    CONTINUE                                    !!! over polarizations
 420    CONTINUE                                    !!! over crystalline group
 430    CONTINUE                                    !!! over polarizations
 440    CONTINUE                                    !!! over displacements
C  NORMALIZATION
        DO 460 INUC=1,NATOM                         !!! over displacements
        DO 450 MY=-1,1                              !!! over polarizations
        PFRE=DREAL(PFTMP(MY,INUC,1))/DBLE(NGROUP)
        PFIM=DIMAG(PFTMP(MY,INUC,1))/DBLE(NGROUP)
C       IF(ABS(PFRE).LE.1.D-10)PFRE=0.D0
C       IF(ABS(PFIM).LE.1.D-10)PFIM=0.D0
        PFVAL(MY,INUC,IPAN,ISPIN,1)=DCMPLX(PFRE,PFIM)
        PFRE=DREAL(PFTMP(MY,INUC,2))/DBLE(NGROUP)
        PFIM=DIMAG(PFTMP(MY,INUC,2))/DBLE(NGROUP)
C       IF(ABS(PFRE).LE.1.D-10)PFRE=0.D0
C       IF(ABS(PFIM).LE.1.D-10)PFIM=0.D0
        PFVAL(MY,INUC,IPAN,ISPIN,2)=DCMPLX(PFRE,PFIM)
 450    CONTINUE                                    !!! over polarizations
 460    CONTINUE                                    !!! over displacements
3000    CONTINUE                                    !!! over spins
4000    CONTINUE                                    !!! over panels
C  SYMMETRIZE FOURIER TRANSFORM FOR THE PSEUDOCHARGE DENSITY
	DO 5000 ISPIN=1,NSPIN    
C  SET TO ZERO
	DO 510 IPLW=0,NPLW
	RHOTMP(IPLW)=(0.D0,0.D0)
 510    CONTINUE
	DO 540 IPLW=0,NPLW                          !!! over iplw
C  RECIPROCAL LATTICE VECTOR IS GIVEN BY
	GX=GPLW(1,IPLW)
	GY=GPLW(2,IPLW)
	GZ=GPLW(3,IPLW)
	DO 530 IR=1,NGROUP                           !!! over point group
C  APPLY SYMMETRY OPERATION        
	IG=IKOV(IR)
	CALL ROTATE(GX,GY,GZ,GRX,GRY,GRZ,U(2,IG),2)
C  GET COORDINATES IN G1,G2,G3
	X1R=GRX*RBAS(1,1)+GRY*RBAS(2,1)+GRZ*RBAS(3,1)
	X2R=GRX*RBAS(1,2)+GRY*RBAS(2,2)+GRZ*RBAS(3,2)
	X3R=GRX*RBAS(1,3)+GRY*RBAS(2,3)+GRZ*RBAS(3,3)
	M1R=ANINT(X1R)
	M2R=ANINT(X2R)
	M3R=ANINT(X3R)
	IF(ABS(DBLE(M1R)-X1R).GE.1.D-10.OR.
     &     ABS(DBLE(M2R)-X2R).GE.1.D-10.OR.
     &     ABS(DBLE(M3R)-X3R).GE.1.D-10)STOP'<TTRINT2>: WRONG VECTOR'
	IDIM=1+M1R-KGMIN(1)+(KGMAX(1)-KGMIN(1)+1)*(M2R-KGMIN(2))+
     &  (KGMAX(1)-KGMIN(1)+1)*(KGMAX(2)-KGMIN(2)+1)*(M3R-KGMIN(3))
	IPLWR=INDG(IDIM)
	IF(IPLWR.EQ.-1)STOP'<TTRINT2>:: ERROR IN IPLWR'
	SCP=GRX*SHIFT(1,IR)+GRY*SHIFT(2,IR)+GRZ*SHIFT(3,IR)
	EXPGR=EXP((0.D0,1.D0)*2.D0*PI*SCP)
C  SYMMETRIZE CHARGE DENSITY
	RHOTMP(IPLW)=RHOTMP(IPLW)+RHOPS(IPLWR,ISPIN)*EXPGR
 530    CONTINUE                                     !!! over group
 540    CONTINUE                                     !!! over iplw
C  NORMALIZATION
	DO 570 IPLW=0,NPLW
	RHOPS(IPLW,ISPIN)=RHOTMP(IPLW)/DBLE(NGROUP)
 570    CONTINUE
5000    CONTINUE                                     !!! over spins
	END
