	SUBROUTINE VXFTR(KEY)
***********************************************************
* Calculates exchange-correlation part of pseudopotential *
* Generalized gradient corrections after Perdew added.    *
***********************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER IS(NPAT),ILST(NSORTMAX),ILSB(NSORTMAX),ILSV(NSORTMAX)
     &    ,INDG(NFFTMAX),KVEC(3,0:NPLWMAX),KGMIN(3),KGMAX(3),MDIV(3)
     &    ,MF(3)
	COMPLEX*16 VPS(0:NPLWMAX,NSPINMAX),RHOPS(0:NPLWMAX,NSPINMAX)
     &    ,RHORS(NFFTMAX,NSPINMAX),TMPARR(NFFTMAX),EXPGR
     &    ,G1RHO(NFFTMAX,NSPINMAX,NGGAMAX),GR1UP(3),GR1DN(3)
     &    ,G2RHO(NFFTMAX,NSPINMAX,NGGAMAX,NGGAMAX)
     &    ,VXCRS(NFFTMAX,NSPINMAX),GR2UP(3,3),GR2DN(3,3)
	DIMENSION SMT(NSORTMAX),GPLW(3,0:NPLWMAX),ORTH(2:3)
     &    ,RBAS(3,3),GBAS(3,3),AD(3,3),RD(3,3),GL(3),QGAM(3)
C Controls:
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM    !!! from readini
	COMMON /SPIN/   NSPIN                            !!! from readini
C Inputs:
	COMMON /POTCOM/ SWZ,SMT                          !!! from readini
	COMMON /LATTICE/RBAS,GBAS                        !!! from readstr
	COMMON /LATPAR/ PAR,ORTH,OMEGAC                  !!! from readini
	COMMON /EXCH/   IXC                              !!! from readini
C Potential:
	COMMON /PSVCOM/ VPS                              !!! from vxftr
C Density:
	COMMON /PSRHO/  RHOPS                            !!! from ttrint
C Temporary:
	COMMON /STORE1/ G2RHO                            !!! tmp.storage
	COMMON /STORE2/ RHORS,VXCRS,G1RHO,TMPARR         !!! tmp.storage
C FFT-grid:
	COMMON /FFTMESH/MDIV,AD,RD                       !!! from readini
	COMMON /PLWMESH/NPLW,GPLW,KVEC,KGMIN,KGMAX,INDG  !!! from plwmsh
	COMMON /WORD/   NVAL                             !!! from setup
	DATA PI/3.141592653589793D0/,QGAM/0.D0,0.D0,0.D0/
        SFACT=0.5D0*DBLE(NSPIN)
C Set keys for LDA and GGA
        ILDA=MOD(IXC,10)     !!! LDA key
        IGGA=(IXC-ILDA)/10   !!! GGA key
	DO ISPIN=1,NSPIN
C SET CHARGE DENSITY AT THE REAL SPACE MESH
	CALL FTRANSD(RHOPS(0,ISPIN),RHORS(1,ISPIN),
     &  TMPARR,0,0,QGAM)
	IF(IGGA.NE.0)THEN
C SET DENSITY GRADIENTS
	DO IA=1,3
	CALL FTRANSD(RHOPS(0,ISPIN),G1RHO(1,ISPIN,IA  ),
     &  TMPARR,IA,0,QGAM)
	DO IB=1,3
	CALL FTRANSD(RHOPS(0,ISPIN),G2RHO(1,ISPIN,IA,IB),
     &  TMPARR,IA,IB,QGAM)
	ENDDO
	ENDDO
	ENDIF
	ENDDO
C Set gradients to zero
        DO IA=1,3 
        GR1UP(IA)=(0.D0,0.D0)
        GR1DN(IA)=(0.D0,0.D0)
        DO IB=1,3
        GR2UP(IA,IB)=(0.D0,0.D0)
        GR2DN(IA,IB)=(0.D0,0.D0)
        ENDDO
        ENDDO
        ALRUP=0.D0
        ALRDN=0.D0
C *** GET EXCHANGE-CORRELATION PSEUDOPOTENTIAL AT THE REAL SPACE MESH ***
	DO 3000 MFFT3=0,MDIV(3)-1           !!! over mfft3
	DO 2000 MFFT2=0,MDIV(2)-1           !!! over mfft2
	DO 1000 MFFT1=0,MDIV(1)-1           !!! over mfft1
	IFFT=1+MFFT1+MFFT2*MDIV(1)+MFFT3*MDIV(1)*MDIV(2)
C Spin densities
	ROUP=DREAL(RHORS(IFFT,1    ))*SFACT
	RODN=DREAL(RHORS(IFFT,NSPIN))*SFACT
C Spin gradients
	IF(IGGA.NE.0)THEN
	ALRUP=0.D0
	ALRDN=0.D0
        DO IA=1,3
        GR1UP(IA)=G1RHO(IFFT,1    ,IA)*SFACT
        GR1DN(IA)=G1RHO(IFFT,NSPIN,IA)*SFACT
	DO IB=1,3
        GR2UP(IA,IB)=G2RHO(IFFT,1    ,IA,IB)*SFACT
        GR2DN(IA,IB)=G2RHO(IFFT,NSPIN,IA,IB)*SFACT
	ENDDO
        ALRUP=ALRUP+GR2UP(IA,IA)
        ALRDN=ALRDN+GR2DN(IA,IA)
        ENDDO
	ENDIF
C SET EXCHANGE-CORRELATION
        CALL EXCVXC(ROUP,RODN,GR1UP,GR1DN,GR2UP,GR2DN,ALRUP,ALRDN,
     &              IXC,KEY,NSPIN,EXCUP,EXCDN,VXCUP,VXCDN)
        DO ISPIN=1,NSPIN
        IF(ISPIN.EQ.1.AND.KEY.EQ.1)XC=VXCUP
        IF(ISPIN.EQ.2.AND.KEY.EQ.1)XC=VXCDN
        IF(ISPIN.EQ.1.AND.KEY.EQ.2)XC=EXCUP
        IF(ISPIN.EQ.2.AND.KEY.EQ.2)XC=EXCDN
	VXCRS(IFFT,ISPIN)=XC
        ENDDO
1000    CONTINUE                            !!! over mfft1
2000    CONTINUE                            !!! over mfft2
3000    CONTINUE                            !!! over mfft3
C  GET EXCHANGE-CORRELATION POTENTIAL BY RECIPROCAL FOURIER TRANSFORM
	DO ISPIN=1,NSPIN
	CALL FTRANSR(VPS(0,ISPIN),VXCRS(1,ISPIN),TMPARR,QGAM)
	ENDDO
	END




	SUBROUTINE FTRANSD(RHOPS,RHORS,RHOTM,IA,IB,QPNT)
********************************************************************
* Makes direct Fourier transform for the density and its gradients *
********************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER INDG(NFFTMAX),KVEC(3,0:NPLWMAX)
     &    ,KGMIN(3),KGMAX(3),MDIV(3),MF(3)
	COMPLEX*16 RHOPS(0:NPLWMAX),RHORS(NFFTMAX)
     &    ,RHOTM(NFFTMAX),EXPQR,EXPGR
	DIMENSION GPLW(3,0:NPLWMAX),ORTH(2:3),QPNT(3)
     &    ,RBAS(3,3),GBAS(3,3),AD(3,3),RD(3,3),GL(3)
	COMMON /FFTMESH/MDIV,AD,RD                       !!! from init
	COMMON /PLWMESH/NPLW,GPLW,KVEC,KGMIN,KGMAX,INDG  !!! from plwmsh
	COMMON /LATTICE/RBAS,GBAS                        !!! from init
	COMMON /LATPAR/ PAR,ORTH,OMEGAC                  !!! from init
	DATA PI/3.141592653589793D0/
C  **** SET CHARGE DENSITY AT THE RECIPROCAL MESH ***
	DO M3=KGMIN(3),KGMAX(3)
	DO M2=KGMIN(2),KGMAX(2)
	DO M1=KGMIN(1),KGMAX(1)
	IDIM=1+M1-KGMIN(1)+(KGMAX(1)-KGMIN(1)+1)*(M2-KGMIN(2))+
     &  (KGMAX(1)-KGMIN(1)+1)*(KGMAX(2)-KGMIN(2)+1)*(M3-KGMIN(3))
	IPLW=INDG(IDIM)
	GL(1)=M1*GBAS(1,1)+M2*GBAS(1,2)+M3*GBAS(1,3)
	GL(2)=M1*GBAS(2,1)+M2*GBAS(2,2)+M3*GBAS(2,3)
	GL(3)=M1*GBAS(3,1)+M2*GBAS(3,2)+M3*GBAS(3,3)
C  REDUCE TO FIRST CELL GIVEN BY RD(I,1..3)
	CALL REDFCEL(GL,GBAS,RBAS,MDIV,MF)
	IFTR=1+MF(1)+MF(2)*MDIV(1)+MF(3)*MDIV(1)*MDIV(2)
	IF(IA.EQ.0.AND.IB.EQ.0)THEN
C  Density:
	IF(IPLW.EQ.-1)RHOTM(IFTR)=(0.D0,0.D0)
	IF(IPLW.NE.-1)RHOTM(IFTR)=RHOPS(IPLW)
	ELSEIF(IA.NE.0.AND.IB.EQ.0)THEN
C  Density gradients:
	IF(IPLW.EQ.-1)RHOTM(IFTR)=(0.D0,0.D0)
	IF(IPLW.NE.-1)RHOTM(IFTR)=(0.D0,1.D0)*
     &  RHOPS(IPLW)*(QPNT(IA)+GPLW(IA,IPLW))*
     &  2.D0*PI/PAR
	ELSEIF(IA.EQ.0.AND.IB.NE.0)THEN
C  Density gradients:
	IF(IPLW.EQ.-1)RHOTM(IFTR)=(0.D0,0.D0)
	IF(IPLW.NE.-1)RHOTM(IFTR)=(0.D0,1.D0)*
     &  RHOPS(IPLW)*(QPNT(IB)+GPLW(IB,IPLW))*
     &  2.D0*PI/PAR
	ELSEIF(IA.NE.0.AND.IB.NE.0)THEN
C  Second gradients:
	IF(IPLW.EQ.-1)RHOTM(IFTR)=(0.D0,0.D0)
	IF(IPLW.NE.-1)RHOTM(IFTR)=-(2.D0*PI/PAR)**2*
     &  (QPNT(IA)+GPLW(IA,IPLW))*(QPNT(IB)+GPLW(IB,IPLW))*
     &  RHOPS(IPLW)
	ENDIF
	ENDDO
	ENDDO
	ENDDO
C  **** SET CHARGE DENSITY AT THE REAL SPACE MESH ***
C  DO OVER "G2","G3" AND "R1", *** GET RHO{R1,G2,G3} ***
	DO MFTR3=0,MDIV(3)-1
	DO MFTR2=0,MDIV(2)-1
	DO MFFT1=0,MDIV(1)-1
	IFFT=1+MFFT1+MFTR2*MDIV(1)+MFTR3*MDIV(1)*MDIV(2)
	RSX=MFFT1*AD(1,1)
	RSY=MFFT1*AD(2,1)
	RSZ=MFFT1*AD(3,1)
	RHORS(IFFT)=(0.D0,0.D0)
C  SUM OVER "G1"
	DO MFTR1=0,MDIV(1)-1
	IFTR=1+MFTR1+MFTR2*MDIV(1)+MFTR3*MDIV(1)*MDIV(2)
	SCP=RSX*MFTR1*GBAS(1,1)+RSY*MFTR1*GBAS(2,1)+RSZ*MFTR1*GBAS(3,1)
	EXPGR=EXP((0.D0,1.D0)*2.D0*PI*SCP)
	RHORS(IFFT)=RHORS(IFFT)+EXPGR*RHOTM(IFTR)
	ENDDO
	ENDDO
	ENDDO
	ENDDO
C  DO OVER "G3","R1" AND "R2", *** GET RHO{R1,R2,G3} ***
	DO MFTR3=0,MDIV(3)-1
	DO MFFT1=0,MDIV(1)-1
	DO MFFT2=0,MDIV(2)-1
	IFFT=1+MFFT1+MFFT2*MDIV(1)+MFTR3*MDIV(1)*MDIV(2)
	RSX=MFFT2*AD(1,2)
	RSY=MFFT2*AD(2,2)
	RSZ=MFFT2*AD(3,2)
	RHOTM(IFFT)=(0.D0,0.D0)
C  SUM OVER "G2"
	DO MFTR2=0,MDIV(2)-1
	IFTR=1+MFFT1+MFTR2*MDIV(1)+MFTR3*MDIV(1)*MDIV(2)
	SCP=RSX*MFTR2*GBAS(1,2)+RSY*MFTR2*GBAS(2,2)+RSZ*MFTR2*GBAS(3,2)
	EXPGR=EXP((0.D0,1.D0)*2.D0*PI*SCP)
	RHOTM(IFFT)=RHOTM(IFFT)+EXPGR*RHORS(IFTR)
	ENDDO
	ENDDO
	ENDDO
	ENDDO
C  DO OVER "R1","R2" AND "R3", *** GET RHO{R1,R2,R3} ***
	DO MFFT1=0,MDIV(1)-1
	DO MFFT2=0,MDIV(2)-1
	DO MFFT3=0,MDIV(3)-1
	IFFT=1+MFFT1+MFFT2*MDIV(1)+MFFT3*MDIV(1)*MDIV(2)
	RSX=MFFT3*AD(1,3)
	RSY=MFFT3*AD(2,3)
	RSZ=MFFT3*AD(3,3)
	RHORS(IFFT)=(0.D0,0.D0)
C  SUM OVER "G3"
	DO MFTR3=0,MDIV(3)-1
	IFTR=1+MFFT1+MFFT2*MDIV(1)+MFTR3*MDIV(1)*MDIV(2)
	SCP=RSX*MFTR3*GBAS(1,3)+RSY*MFTR3*GBAS(2,3)+RSZ*MFTR3*GBAS(3,3)
	EXPGR=EXP((0.D0,1.D0)*2.D0*PI*SCP)
	RHORS(IFFT)=RHORS(IFFT)+EXPGR*RHOTM(IFTR)
	ENDDO
	ENDDO
	ENDDO
	ENDDO
C  GET RHO{R1,R2,R3} IF IT IS A BLOCH WAVE OF WAVEVECTOR "Q"
        DO MFFT1=0,MDIV(1)-1
        DO MFFT2=0,MDIV(2)-1
        DO MFFT3=0,MDIV(3)-1
        IFFT=1+MFFT1+MFFT2*MDIV(1)+MFFT3*MDIV(1)*MDIV(2)
        RSX=MFFT1*AD(1,1)+MFFT2*AD(1,2)+MFFT3*AD(1,3)
        RSY=MFFT1*AD(2,1)+MFFT2*AD(2,2)+MFFT3*AD(2,3)
        RSZ=MFFT1*AD(3,1)+MFFT2*AD(3,2)+MFFT3*AD(3,3)
        SCP=RSX*QPNT(1)+RSY*QPNT(2)+RSZ*QPNT(3)
        EXPQR=EXP((0.D0,1.D0)*2.D0*PI*SCP)
        RHORS(IFFT)=RHORS(IFFT)*EXPQR
        ENDDO
        ENDDO
        ENDDO
	END



	SUBROUTINE FTRANSR(VPS,VXCRS,VXCTM,QPNT)
********************************************************************
* Makes reciprocal Fourier transform for the potential             *
********************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER INDG(NFFTMAX),KVEC(3,0:NPLWMAX)
     &    ,KGMIN(3),KGMAX(3),MDIV(3),MF(3)
	COMPLEX*16 VPS(0:NPLWMAX),VXCRS(NFFTMAX)
     &    ,VXCTM(NFFTMAX),EXPGR,EXPQR
	DIMENSION GPLW(3,0:NPLWMAX),ORTH(2:3),QPNT(3)
     &    ,RBAS(3,3),GBAS(3,3),AD(3,3),RD(3,3),GL(3)
	COMMON /FFTMESH/MDIV,AD,RD                       !!! from init
	COMMON /PLWMESH/NPLW,GPLW,KVEC,KGMIN,KGMAX,INDG  !!! from plwmsh
	COMMON /LATTICE/RBAS,GBAS                        !!! from init
	COMMON /LATPAR/ PAR,ORTH,OMEGAC                  !!! from init
	DATA PI/3.141592653589793D0/
C  GET EXCHANGE-CORRELATION PSEUDOPOTENTIAL BY FAST FOURIER TRANSFORM
C  GET VXC{R1,R2,R3} MULTIPLIED BY EXP(-IQR) IF IT IS A BLOCH WAVE
        DO MFFT1=0,MDIV(1)-1
        DO MFFT2=0,MDIV(2)-1
        DO MFFT3=0,MDIV(3)-1
        IFFT=1+MFFT1+MFFT2*MDIV(1)+MFFT3*MDIV(1)*MDIV(2)
        RSX=MFFT1*AD(1,1)+MFFT2*AD(1,2)+MFFT3*AD(1,3)
        RSY=MFFT1*AD(2,1)+MFFT2*AD(2,2)+MFFT3*AD(2,3)
        RSZ=MFFT1*AD(3,1)+MFFT2*AD(3,2)+MFFT3*AD(3,3)
        SCP=RSX*QPNT(1)+RSY*QPNT(2)+RSZ*QPNT(3)
        EXPQR=EXP((0.D0,-1.D0)*2.D0*PI*SCP)
        VXCRS(IFFT)=VXCRS(IFFT)*EXPQR
        ENDDO
        ENDDO
        ENDDO
C  DO OVER "R2","R3" AND "G1", *** GET VXC{G1,R2,R3} ***
	DO MFFT3=0,MDIV(3)-1
	DO MFFT2=0,MDIV(2)-1
	DO MFTR1=0,MDIV(1)-1
	IFTR=1+MFTR1+MFFT2*MDIV(1)+MFFT3*MDIV(1)*MDIV(2)
	GX=MFTR1*GBAS(1,1)
	GY=MFTR1*GBAS(2,1)
	GZ=MFTR1*GBAS(3,1)
	VXCTM(IFTR)=(0.D0,0.D0)
C  SUM OVER "R1"
	DO MFFT1=0,MDIV(1)-1
	IFFT=1+MFFT1+MFFT2*MDIV(1)+MFFT3*MDIV(1)*MDIV(2)
	SCP=GX*MFFT1*AD(1,1)+GY*MFFT1*AD(2,1)+GZ*MFFT1*AD(3,1)
	EXPGR=EXP((0.D0,-1.D0)*2.D0*PI*SCP)
	VXCTM(IFTR)=VXCTM(IFTR)+EXPGR*VXCRS(IFFT)
	ENDDO
	ENDDO
	ENDDO
	ENDDO
C  DO OVER "R3","G1" AND "G2", *** GET VXC{G1,G2,R3} ***
	DO MFFT3=0,MDIV(3)-1
	DO MFTR1=0,MDIV(1)-1
	DO MFTR2=0,MDIV(2)-1
	IFTR=1+MFTR1+MFTR2*MDIV(1)+MFFT3*MDIV(1)*MDIV(2)
	GX=MFTR2*GBAS(1,2)
	GY=MFTR2*GBAS(2,2)
	GZ=MFTR2*GBAS(3,2)
	VXCRS(IFTR)=(0.D0,0.D0)
C  SUM OVER "R2"
	DO MFFT2=0,MDIV(2)-1
	IFFT=1+MFTR1+MFFT2*MDIV(1)+MFFT3*MDIV(1)*MDIV(2)
	SCP=GX*MFFT2*AD(1,2)+GY*MFFT2*AD(2,2)+GZ*MFFT2*AD(3,2)
	EXPGR=EXP((0.D0,-1.D0)*2.D0*PI*SCP)
	VXCRS(IFTR)=VXCRS(IFTR)+EXPGR*VXCTM(IFFT)
	ENDDO
	ENDDO
	ENDDO
	ENDDO
C  DO OVER "G1","G2" AND "G3", *** GET VXC{G1,G2,G3} ***
	DO MFTR1=0,MDIV(1)-1
	DO MFTR2=0,MDIV(2)-1
	DO MFTR3=0,MDIV(3)-1
	IFTR=1+MFTR1+MFTR2*MDIV(1)+MFTR3*MDIV(1)*MDIV(2)
	GX=MFTR3*GBAS(1,3)
	GY=MFTR3*GBAS(2,3)
	GZ=MFTR3*GBAS(3,3)
	VXCTM(IFTR)=(0.D0,0.D0)
C  SUM OVER "R3"
	DO MFFT3=0,MDIV(3)-1
	IFFT=1+MFTR1+MFTR2*MDIV(1)+MFFT3*MDIV(1)*MDIV(2)
	SCP=GX*MFFT3*AD(1,3)+GY*MFFT3*AD(2,3)+GZ*MFFT3*AD(3,3)
	EXPGR=EXP((0.D0,-1.D0)*2.D0*PI*SCP)
	VXCTM(IFTR)=VXCTM(IFTR)+EXPGR*VXCRS(IFFT)
	ENDDO
	ENDDO
	ENDDO
	ENDDO
C  **** SET EXCHANGE-CORRELATION PSEUDOPOTENTIAL WITHIN SPHERE GMAX ***
        ANORM=1.D0/DBLE(MDIV(1)*MDIV(2)*MDIV(3))
        DO M3=KGMIN(3),KGMAX(3)
        DO M2=KGMIN(2),KGMAX(2)
        DO M1=KGMIN(1),KGMAX(1)
        IDIM=1+M1-KGMIN(1)+(KGMAX(1)-KGMIN(1)+1)*(M2-KGMIN(2))+
     &  (KGMAX(1)-KGMIN(1)+1)*(KGMAX(2)-KGMIN(2)+1)*(M3-KGMIN(3))
        IPLW=INDG(IDIM)
        IF(IPLW.NE.-1)THEN
        GL(1)=M1*GBAS(1,1)+M2*GBAS(1,2)+M3*GBAS(1,3)
        GL(2)=M1*GBAS(2,1)+M2*GBAS(2,2)+M3*GBAS(2,3)
        GL(3)=M1*GBAS(3,1)+M2*GBAS(3,2)+M3*GBAS(3,3)
C  REDUCE TO FIRST CELL GIVEN BY RD(I,1..3)
        CALL REDFCEL(GL,GBAS,RBAS,MDIV,MF)
        IFTR=1+MF(1)+MF(2)*MDIV(1)+MF(3)*MDIV(1)*MDIV(2)
        VPS(IPLW)=VPS(IPLW)+ANORM*VXCTM(IFTR) ! add to Vc
        ENDIF
        ENDDO
        ENDDO
        ENDDO
	END
